--      ___                       ___                       ___           ___           ___           ___           ___     
--     /__/\        ___          /__/\        ___          /  /\         /  /\         /__/\         /  /\         /  /\    
--    |  |::\      /  /\         \  \:\      /  /\        /  /:/_       /  /::\       |  |::\       /  /:/_       /  /:/_   
--    |  |:|:\    /  /:/          \  \:\    /  /:/       /  /:/ /\     /  /:/\:\      |  |:|:\     /  /:/ /\     /  /:/ /\  
--  __|__|:|\:\  /__/::\      _____\__\:\  /__/::\      /  /:/_/::\   /  /:/~/::\   __|__|:|\:\   /  /:/ /:/_   /  /:/ /::\ 
-- /__/::::| \:\ \__\/\:\__  /__/::::::::\ \__\/\:\__  /__/:/__\/\:\ /__/:/ /:/\:\ /__/::::| \:\ /__/:/ /:/ /\ /__/:/ /:/\:\
-- \  \:\~~\__\/    \  \:\/\ \  \:\~~\~~\/    \  \:\/\ \  \:\ /~~/:/ \  \:\/:/__\/ \  \:\~~\__\/ \  \:\/:/ /:/ \  \:\/:/~/:/
--  \  \:\           \__\::/  \  \:\  ~~~      \__\::/  \  \:\  /:/   \  \::/       \  \:\        \  \::/ /:/   \  \::/ /:/ 
--   \  \:\          /__/:/    \  \:\          /__/:/    \  \:\/:/     \  \:\        \  \:\        \  \:\/:/     \__\/ /:/  
--    \  \:\         \__\/      \  \:\         \__\/      \  \::/       \  \:\        \  \:\        \  \::/        /__/:/   
--     \__\/                     \__\/                     \__\/         \__\/         \__\/         \__\/         \__\/    
--=============================================================================================================================
--=============================================================================================================================
--TODO:
--Keep playing after crashing by saving the statuses in Savedvariables (low prio)
--Cancel the Animations when starting a new game
--Auto activate the Chat on Click like when clicking a button 2 times
--Zoomfunction
--=============================================================================================================================
--=============================================================================================================================
--All Credit and Copyrights go to (ESO EU) Dero - @Deryl
--I did my best to comment the code for others to learn from it ;)

--Basic Variables
ESO_MG_C2G_MAXWIDTH = 400
ESO_MG_C2G_MAXHEIGHT = 500
ESO_MG_C2G_GRIDOBJDIM = 60
ESO_MG_C2G_CONNECTTOWIN = 3
ESO_MG_C2G_COLS = 3
ESO_MG_C2G_ROWS = 3
ESO_MG_C2G_DEBUGMODE = 1

--Creation of the Menu
function ESO_MG.C2_buildmenu()
	if (TicTacToeMenu == nil) then
--------------------------------------------------------------------------------------------------------------------------
-- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART --
--------------------------------------------------------------------------------------------------------------------------
		--Basemenu
		ESO_MG_C2G_MENU = WINDOW_MANAGER:CreateTopLevelWindow("TicTacToeMenu")
		ESO_MG_C2G_MENU:SetDrawLayer(1)
		ESO_MG_C2G_MENU:SetAnchor(ESO_MG_SavedData.Cat2Anchor[1],ESO_MG_SavedData.Cat2Anchor[2],ESO_MG_SavedData.Cat2Anchor[3],ESO_MG_SavedData.Cat2Anchor[4],ESO_MG_SavedData.Cat2Anchor[5])
		ESO_MG_C2G_MENU:SetDimensions(ESO_MG_C2G_MAXWIDTH,ESO_MG_C2G_MAXHEIGHT)
		ESO_MG_C2G_MENU:SetMouseEnabled(true)
		ESO_MG_C2G_MENU:SetMovable(true)
		ESO_MG_C2G_MENU:SetClampedToScreen(true)
		ESO_MG_C2G_MENU:SetHandler("OnMoveStop",ESO_MG.C2WindowMoved)
		ESO_MG_C2G_MENU_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C2G_Back",TicTacToeMenu,"ZO_DefaultBackdrop")
		
		--Headertext
		ESO_MG_C2G_HEADER = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_HEADER",TicTacToeMenu,CT_LABEL)
		ESO_MG_C2G_HEADER:SetText("|c880000" .. ESO_MG_CAT2Name)
		ESO_MG_C2G_HEADER:SetFont("ZoFontTooltipTitle")
		ESO_MG_C2G_HEADER:SetAnchor(TOP,TicTacToeMenu,TOP,0,0)

		--X-Button to Close the Menu
		ESO_MG_C2G_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_BTNCLOSE",TicTacToeMenu,CT_BUTTON)
		ESO_MG_C2G_BTNCLOSE:SetDimensions(20,20)
		ESO_MG_C2G_BTNCLOSE:SetHandler("OnClicked",ESO_MG.C2CloseMenu)
		ESO_MG_C2G_BTNCLOSE:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C2G_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_MG_C2G_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_MG_C2G_BTNCLOSE:SetAnchor(TOPRIGHT,TicTacToeMenu,TOPRIGHT,0,0)
		
		--_-Button to Close / Hide the Menu
		ESO_MG_C2G_BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_BTNSH",TicTacToeMenu,CT_BUTTON)
		ESO_MG_C2G_BTNSH:SetDimensions(20,20)
		ESO_MG_C2G_BTNSH:SetHandler("OnClicked",ESO_MG.C2ShowHideMenu)
		ESO_MG_C2G_BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C2G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C2G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C2G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C2G_BTNCLOSE,TOPLEFT,-5,5)
		
		--Info button to Open the Help/Info for the current Game
		ESO_MG_C2G_BTNINFO = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_BTNINFO",TicTacToeMenu,CT_BUTTON)
		ESO_MG_C2G_BTNINFO:SetDimensions(25,25)
		ESO_MG_C2G_BTNINFO:SetHandler("OnClicked",ESO_MG.C2OpenInfo)
		ESO_MG_C2G_BTNINFO:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C2G_BTNINFO:SetNormalTexture("/esoui/art/help/help_tabicon_tutorial_up.dds")
		ESO_MG_C2G_BTNINFO:SetMouseOverTexture("/esoui/art/help/help_tabicon_tutorial_over.dds")
		ESO_MG_C2G_BTNINFO:SetAnchor(TOPLEFT,TicTacToeMenu,TOPLEFT,0,0)
		
		--Game Container
		ESO_MG_C2G_GAMECONT = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_GAMECONT",TicTacToeMenu,CT_TEXTURE)
		ESO_MG_C2G_GAMECONT:SetDimensions(0,0)
		ESO_MG_C2G_GAMECONT:SetAnchor(TOPLEFT,TicTacToeMenu,TOPLEFT,0,0)
		
		--Player WON text
		ESO_MG_C2G_PWON = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PWON",ESO_MG_C2G_GAMECONT,CT_LABEL)
		ESO_MG_C2G_PWON:SetText("|cff0000PLAYER WON!|r")
		ESO_MG_C2G_PWON:SetFont("ZoFontTooltipTitle")
		ESO_MG_C2G_PWON:SetHorizontalAlignment(1)
		ESO_MG_C2G_PWON:SetDimensions(ESO_MG_C1G_MAXWIDTH,0)
		ESO_MG_C2G_PWON:SetAnchor(CENTER,ESO_MG_C2G_GAMECONT,CENTER,0,0)

		--Player WON burst 1 - 3
		ESO_MG_C2G_PWB1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PWB1",ESO_MG_C2G_PWON,CT_TEXTURE)
		ESO_MG_C2G_PWB1:SetDimensions(512,512)
		ESO_MG_C2G_PWB1:SetAnchor(CENTER,ESO_MG_C2G_PWON,CENTER,0,0)
		ESO_MG_C2G_PWB1:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C2G_PWB1:SetColor(1,1,1,0.5)
		ESO_MG_C2G_PWB2 = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PWB2",ESO_MG_C2G_PWON,CT_TEXTURE)
		ESO_MG_C2G_PWB2:SetDimensions(512,512)
		ESO_MG_C2G_PWB2:SetAnchor(CENTER,ESO_MG_C2G_PWON,CENTER,0,0)
		ESO_MG_C2G_PWB2:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C2G_PWB2:SetColor(1,1,1,0.5)
		ESO_MG_C2G_PWB3 = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PWB3",ESO_MG_C2G_PWON,CT_TEXTURE)
		ESO_MG_C2G_PWB3:SetDimensions(512,512)
		ESO_MG_C2G_PWB3:SetAnchor(CENTER,ESO_MG_C2G_PWON,CENTER,0,0)
		ESO_MG_C2G_PWB3:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C2G_PWB3:SetColor(1,1,1,0.5)
		
		--Line1
		ESO_MG_C2G_C2L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_C2L1",ESO_MG_C2G_GAMECONT,CT_TEXTURE)
		ESO_MG_C2G_C2L1:SetDimensions(ESO_MG_C2G_MAXWIDTH+10,3)
		ESO_MG_C2G_C2L1:SetAnchor(TOPLEFT,ESO_MG_C2G_GAMECONT,TOPLEFT,-6,30)
		ESO_MG_C2G_C2L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--Match between text
		ESO_MG_C2G_MB = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_MB",ESO_MG_C2G_GAMECONT,CT_LABEL)
		ESO_MG_C2G_MB:SetText("")
		ESO_MG_C2G_MB:SetFont("ZoFontGame")
		ESO_MG_C2G_MB:SetHorizontalAlignment(1)
		ESO_MG_C2G_MB:SetDimensions(ESO_MG_C2G_MAXWIDTH,0)
		ESO_MG_C2G_MB:SetAnchor(TOP,ESO_MG_C2G_GAMECONT,TOP,0,30)
		
		--Line2
		ESO_MG_C2G_C2L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_C2L2",ESO_MG_C2G_GAMECONT,CT_TEXTURE)
		ESO_MG_C2G_C2L2:SetDimensions(ESO_MG_C2G_MAXWIDTH+10,3)
		ESO_MG_C2G_C2L2:SetAnchor(TOPLEFT,ESO_MG_C2G_GAMECONT,TOPLEFT,-6,75)
		ESO_MG_C2G_C2L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--Grid Container
		ESO_MG_C2G_CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_CONT",ESO_MG_C2G_GAMECONT,CT_TEXTURE)
		ESO_MG_C2G_CONT:SetDimensions(0,0)
		ESO_MG_C2G_CONT:SetAnchor(TOPLEFT,ESO_MG_C2G_GAMECONT,TOPLEFT,30,110)
		ESO_MG_C2G_CONT:SetTexture("/esoui/art/crafting/crafting_alchemy_goodslot.dds")
		ESO_MG_C2G_CONT:SetColor(0.5,0.5,0.3,1)
		ESO_MG_C2G_CONT_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C2G_CONT_BG",ESO_MG_C2G_CONT,"ZO_DefaultBackdrop")
		
		--Creating the Column Numbers
		ESO_MG_C2G_CN = {}		
		for i = 1 , ESO_MG_C2G_COLS , 1 do
			ESO_MG_C2G_CN[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_CN" .. i,ESO_MG_C2G_CONT,CT_LABEL)
			ESO_MG_C2G_CN[i]:SetText("|c888866" .. i )
			ESO_MG_C2G_CN[i]:SetFont("ZoFontGame")
			ESO_MG_C2G_CN[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,((ESO_MG_C2G_GRIDOBJDIM/2)-5)+((i-1)*ESO_MG_C2G_GRIDOBJDIM),-30)
		end
		
		--Creating the Lines between Cols
		ESO_MG_C2G_CL = {}
		for i = 1 , ESO_MG_C2G_COLS -1 , 1 do
			ESO_MG_C2G_CL[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_CL" .. i,ESO_MG_C2G_CONT,CT_TEXTURE)
			ESO_MG_C2G_CL[i]:SetDimensions(3,ESO_MG_C2G_ROWS * ESO_MG_C2G_GRIDOBJDIM + 10)
			ESO_MG_C2G_CL[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT, i * ESO_MG_C2G_GRIDOBJDIM,-6)
			ESO_MG_C2G_CL[i]:SetTexture("/esoui/art/miscellaneous/window_edge.dds")
		end
		
		--Creating the Rows Letters
		ESO_MG_C2G_ROWLETTERS = {"A","B","C"}
		ESO_MG_C2G_ROWLETTERSLIST = ESO_MG_C2G_ROWLETTERS
		ESO_MG_C2G_RN = {}
		for i = 1 , ESO_MG_C2G_ROWS , 1 do
			ESO_MG_C2G_RN[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_RN" .. i,ESO_MG_C2G_CONT,CT_LABEL)
			ESO_MG_C2G_RN[i]:SetText("|c888866" .. ESO_MG_C2G_ROWLETTERS[i] )
			ESO_MG_C2G_RN[i]:SetFont("ZoFontGame")
			ESO_MG_C2G_RN[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,-25,((ESO_MG_C2G_GRIDOBJDIM/2)-10)+((i-1)*ESO_MG_C2G_GRIDOBJDIM))
		end
		
		--Creating the Lines between Rows
		ESO_MG_C2G_RL = {}
		for i = 1 , ESO_MG_C2G_ROWS -1 , 1 do
			ESO_MG_C2G_RL[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_RL" .. i,ESO_MG_C2G_CONT,CT_TEXTURE)
			ESO_MG_C2G_RL[i]:SetDimensions(ESO_MG_C2G_COLS  * ESO_MG_C2G_GRIDOBJDIM + 10 + (ESO_MG_C2G_GRIDOBJDIM / 2),3)
			ESO_MG_C2G_RL[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,-6 - (ESO_MG_C2G_GRIDOBJDIM / 4),i * ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_RL[i]:SetTexture("/esoui/art/miscellaneous/centerscreen_topdivider.dds")
		end

		-- Texture to Highlight on MouseOver
		ESO_MG_C2G_HL = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_HL",ESO_MG_C2G_CONT,CT_TEXTURE)
		ESO_MG_C2G_HL:SetDimensions(ESO_MG_C2G_GRIDOBJDIM,ESO_MG_C2G_GRIDOBJDIM)
		ESO_MG_C2G_HL:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,0,0)
		ESO_MG_C2G_HL:SetTexture("/esoui/art/buttons/minmax_mouseover.dds")
		ESO_MG_C2G_HL:SetHidden(true)
		
		-- Creating the Grid
		ESO_MG_C2G_GRIDOBJ = {}
		ESO_MG_C2G_GRIDOBJC = {}
		ESO_MG_C2G_GRIDOBJB = {}
		for i = 1 , ESO_MG_C2G_ROWS * ESO_MG_C2G_COLS , 1 do
			--Grid object round Border for Winner
			ESO_MG_C2G_GRIDOBJ[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_GRIDOBJ" .. i,ESO_MG_C2G_CONT,CT_TEXTURE)
			ESO_MG_C2G_GRIDOBJ[i]:SetDimensions(ESO_MG_C2G_GRIDOBJDIM,ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJ[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM,((i-1)%ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJ[i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_disabled.dds")
			ESO_MG_C2G_GRIDOBJ[i]:SetColor(0,0,0,1)

			--Object to set the Texture for
			ESO_MG_C2G_GRIDOBJC[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_GRIDOBJC" .. i,ESO_MG_C2G_CONT,CT_TEXTURE)
			ESO_MG_C2G_GRIDOBJC[i]:SetDimensions(ESO_MG_C2G_GRIDOBJDIM,ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJC[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM,((i-1)%ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJC[i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
			ESO_MG_C2G_GRIDOBJC[i]:SetColor(0,0,0,1)
			ESO_MG_C2G_GRIDOBJC[i].status = 0 --Status of the GridItem 0 = No Stone, 1 = Opponents Stone, 2 = Your Stone
		
			--Clickable GridObject without texture (Texture to Highlight on Mouseover)
			ESO_MG_C2G_GRIDOBJB[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_GRIDOBJB" .. i,ESO_MG_C2G_CONT,CT_BUTTON)
			ESO_MG_C2G_GRIDOBJB[i]:SetDimensions(ESO_MG_C2G_GRIDOBJDIM,ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJB[i]:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM,((i-1)%ESO_MG_C2G_ROWS)*ESO_MG_C2G_GRIDOBJDIM)
			ESO_MG_C2G_GRIDOBJB[i]:SetHandler("OnClicked",function() ESO_MG.ClickedItemC2(i,ESO_MG_C2G_GRIDOBJC[i],ESO_MG_C2G_GRIDOBJC[i].status) end)			
			ESO_MG_C2G_GRIDOBJB[i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C2G_HL:SetAnchor(TOPLEFT,ESO_MG_C2G_GRIDOBJB[i],TOPLEFT,0,0) if(ESO_MG_C2G_GRIDOBJC[i].status == 0)then ESO_MG_C2G_HL:SetColor(1,1,1,1) else ESO_MG_C2G_HL:SetColor(1,0,0,1) end ESO_MG_C2G_HL:SetHidden(false) end)
			ESO_MG_C2G_GRIDOBJB[i]:SetHandler("OnMouseExit",function() ESO_MG_C2G_HL:SetHidden(true) end)
		end
		
		--Players turn text
		ESO_MG_C2G_PT = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PT",ESO_MG_C2G_CONT,CT_LABEL)
		ESO_MG_C2G_PT:SetFont("ZoFontGame")
		ESO_MG_C2G_PT:SetHorizontalAlignment(1)
		ESO_MG_C2G_PT:SetVerticalAlignment(1)
		ESO_MG_C2G_PT:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 60,50)
		ESO_MG_C2G_PT:SetAnchor(TOPLEFT,ESO_MG_C2G_CONT,BOTTOMLEFT,-30,5)

		--Button Quit Game
		ESO_MG_C2G_CG = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_CG",ESO_MG_C2G_CONT,CT_BUTTON)
		ESO_MG_C2G_CG:SetDimensions(100,25)
		ESO_MG_C2G_CG:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C2WaitForPlayer .. "" .. C2AccOrRealName .. ESO_MG_CAT2CancelText) end)
		ESO_MG_C2G_CG:SetHandler("OnMouseEnter",function() if(ESO_MG_C2G_CG:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C2G_CG:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C2G_CG:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C2G_CG:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C2G_CG:SetAnchor(BOTTOM,ESO_MG_C2G_CONT,BOTTOM,-55,80)
		ESO_MG_C2G_CGTX = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_CGTX",ESO_MG_C2G_CG,CT_LABEL)
		ESO_MG_C2G_CGTX:SetText("|c888866Quit Game|r")
		ESO_MG_C2G_CGTX:SetFont("ZoFontGame")
		ESO_MG_C2G_CGTX:SetAnchor(CENTER,ESO_MG_C2G_CG,CENTER,0,0)
		
		--Button Play Again
		ESO_MG_C2G_PA = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PA",ESO_MG_C2G_CONT,CT_BUTTON)
		ESO_MG_C2G_PA:SetDimensions(100,25)
		ESO_MG_C2G_PA:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C2WaitForPlayer .. "" .. C2AccOrRealName .. ESO_MG_CAT2AgainText) end)
		ESO_MG_C2G_PA:SetHandler("OnMouseEnter",function() if(ESO_MG_C2G_PA:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C2G_PA:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C2G_PA:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C2G_PA:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C2G_PA:SetAnchor(BOTTOM,ESO_MG_C2G_CONT,BOTTOM,55,80)
		ESO_MG_C2G_PATX = WINDOW_MANAGER:CreateControl("ESO_MG_C2G_PATX",ESO_MG_C2G_PA,CT_LABEL)
		ESO_MG_C2G_PATX:SetText("|c888866Play Again|r")
		ESO_MG_C2G_PATX:SetFont("ZoFontGame")
		ESO_MG_C2G_PATX:SetAnchor(CENTER,ESO_MG_C2G_PA,CENTER,0,0)
	end
	ESO_MG_C2G_MENU:SetHidden(true)
	ESO_MG.InitGameC2()
end

--Save Position if Window is moved
function ESO_MG.C2WindowMoved()
	ESO_MG_C2G_va, ESO_MG_C2G_pt, ESO_MG_C2G_rt, ESO_MG_C2G_rpt, ESO_MG_C2G_ox, ESO_MG_C2G_oy =  ESO_MG_C2G_MENU:GetAnchor()
	if(ESO_MG_C2G_va) then
		ESO_MG_SavedData.Cat2Anchor[1] = ESO_MG_C2G_pt
		ESO_MG_SavedData.Cat2Anchor[2] = ESO_MG_C2G_rt
		ESO_MG_SavedData.Cat2Anchor[3] = ESO_MG_C2G_rpt
		ESO_MG_SavedData.Cat2Anchor[4] = ESO_MG_C2G_ox
		ESO_MG_SavedData.Cat2Anchor[5] = ESO_MG_C2G_oy
	end
end

--Creating the Grid
function ESO_MG.InitGameC2()
	--Play the StartGame Sound
	ESO_MG.Sound(ESO_MG_SN_Battle1)

	--Sets the Game Status
	ESO_MG_C2GameEnded = 0
	if(ESO_MG_C2GameMaxed == nil)then
		ESO_MG_C2GameMaxed = 1
	end
	ESO_MG_C2Running = 1
	C2YouAgain = 0
	C2OppAgain = 0
	
	--Update the texts with PlayerNames in it
	ESO_MG_C2G_MB:SetText("|c888866Player 1: |c008888" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866Player 2: |caa0000" .. ESO_MG_SELF)
	
	--Hide the Winner Text
	ESO_MG_C2G_PWON:SetHidden(true)

	--Register the wait for Command Event
	EVENT_MANAGER:RegisterForEvent("C2WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C2WFO)
	
	--Resets the PlayGrid
	ESO_MG.C2ResetGame()
	
	--Sets the Window Dimensions depending on PlayGrid
	ESO_MG.C2SetGameWindowSize()
	
	--Unregister Events you Dont need anymore
	EVENT_MANAGER:UnregisterForEvent("C2WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL)
	
	--Disable the Play Again button
	ESO_MG_C2G_PA:SetEnabled(false)
	ESO_MG_C2G_PATX:SetText("|c666666Play Again|r")

	--Enable the Quit Game Button
	ESO_MG_C2G_CG:SetEnabled(true)
	ESO_MG_C2G_CGTX:SetText("|c888866Quit Game|r")
end

--Check the TellChat for ESO_MG_CAT2AgainText after game ended
function ESO_MG.C2PlayAgain(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C2WaitForPlayer)) then
			if(string.lower(message) == string.lower(ESO_MG_CAT2AgainText)) then
				C2OppAgain = 1
				ESO_MG.Sound(ESO_MG_SN_Reminder3)
				ESO_MG_C2G_PT:SetText(ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866wants to Play again!")
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C2WaitForPlayer)then
			if(string.lower(message) == string.lower(ESO_MG_CAT2AgainText))then
				C2YouAgain = 1
			end
		end
	end
	if(C2OppAgain == 1 and C2YouAgain == 1)then
		ESO_MG.InitGameC2()
	end
end

--Check the TellChat for Input
function ESO_MG.C2WFO(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C2WaitForPlayer)) then
			MessageArray = {}
			if(message:len() == 2) then
				for i = 1, message:len(),1 do
					MessageArray[i] = message:sub(i,i)
				end
				if(tonumber(MessageArray[2]) ~= nil and tonumber(MessageArray[2]) <= ESO_MG_C2G_COLS and tonumber(MessageArray[2]) >= 1) then
					if (C2CurrentPlayer == 0) then
						for i,j in pairs(ESO_MG_C2G_ROWLETTERS) do
							if j == string.upper(MessageArray[1]) then
								C2ToPlace = i + ESO_MG_C2G_ROWS * (MessageArray[2] - 1)
								ESO_MG.C2PlaceGridItem(C2ToPlace)
								break
							end
						end
					else
						log("Its not " .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
					end
				end
			end
			if (string.lower(message) == string.lower(ESO_MG_CAT2CancelText)) then
					ESO_MG_C2G_PWON:SetText("|cff0000Opponent quits.\n|c00ff00You WIN the Game!")
					ESO_MG_C2G_PT:SetText("You\n|c888866won the Game!")
					ESO_MG.Sound(ESO_MG_SN_Quit1)
					ESO_MG.C2EndGame()--END GAME
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C2WaitForPlayer)then
			MessageArray = {}
			if(message:len() == 2) then
				for i = 1, message:len(),1 do
					MessageArray[i] = message:sub(i,i)
				end
				if(tonumber(MessageArray[2]) ~= nil and tonumber(MessageArray[2]) <= ESO_MG_C2G_COLS and tonumber(MessageArray[2]) >= 1) then
					if (C2CurrentPlayer == 1) then
						for i,j in pairs(ESO_MG_C2G_ROWLETTERS) do
							if j == string.upper(MessageArray[1]) then
								C2ToPlace = i + ESO_MG_C2G_ROWS * (MessageArray[2] - 1)
								ESO_MG.C2PlaceGridItem(C2ToPlace)
								break
							end
						end
					else
						log("Its not your turn.")
						ESO_MG.Sound(ESO_MG_SN_Error4)
					end
				end
			end
			if (string.lower(message) == string.lower(ESO_MG_CAT2CancelText)) then
				ESO_MG_C2G_PWON:SetText("|cff0000You quit.\n|cff0000Your Opponent\nwon the Game!")
				ESO_MG_C2G_PT:SetText(ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
				ESO_MG.Sound(ESO_MG_SN_Quit1)
				ESO_MG.C2EndGame()--END GAME
			end
		end
	end
end

--Places at Grid if there is one Free
function ESO_MG.C2PlaceGridItem(C2FieldToPlace)
	C2CouldntPlaceCout = 0
	if(ESO_MG_C2G_GRIDOBJC[C2FieldToPlace].status == 0) then
		if(C2CurrentPlayer == 0) then
			ESO_MG_C2G_GRIDOBJC[C2FieldToPlace].status = 1
			C2CurrentPlayer = 1
			ESO_MG_C2G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Parry1)
		elseif(C2CurrentPlayer == 1) then
			ESO_MG_C2G_GRIDOBJC[C2FieldToPlace].status = 2
			C2CurrentPlayer = 0
			ESO_MG_C2G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Sword1)
		end
		ESO_MG.C2SetTextures()
		ESO_MG.C2CheckForWin()
	else
		C2CouldntPlaceCout = C2CouldntPlaceCout + 1
		if(C2CouldntPlaceCout >= 1) then
			if(C2CurrentPlayer == 0)then
				log("Field is already placed. It's still " .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
			else
				log("Field is already placed. It's still " .. ESO_MG_SELF .. "'s turn.")
				ESO_MG.Sound(ESO_MG_SN_Error4)
			end
		end
	end
end

--Sets the correct Textures depending on status
function ESO_MG.C2SetTextures()
	for i = 1 , ESO_MG_C2G_ROWS * ESO_MG_C2G_COLS , 1 do
		if(ESO_MG_C2G_GRIDOBJC[i].status == 1) then -- O
			ESO_MG_C2G_GRIDOBJC[i]:SetColor(0,1,1,1)
			ESO_MG_C2G_GRIDOBJC[i]:SetTexture("/esoui/art/charactercreate/charactercreate_raceicon_up.dds")
		elseif(ESO_MG_C2G_GRIDOBJC[i].status == 2) then -- X
			ESO_MG_C2G_GRIDOBJC[i]:SetColor(0.8,0,0,1)
			ESO_MG_C2G_GRIDOBJC[i]:SetTexture("/esoui/art/progression/icon_dualwield.dds")
		else
			ESO_MG_C2G_GRIDOBJC[i]:SetColor(0,0,0,0)
			ESO_MG_C2G_GRIDOBJC[i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
		end
	end
end

--SetUp the WinTable
C2CheckForWinTable = {[1]={1,4,7},[2]={2,5,8},[3]={3,6,9},[4]={1,2,3},[5]={4,5,6},[6]={7,8,9},[7]={1,5,9},[8]={7,5,3}}

--CHECK IF A PLAYER HAS ESO_MG_C2G_CONNECTTOWIN CONNECTED and Wins
function ESO_MG.C2CheckForWin()
	--Check if all Fields are Full
	ESO_MG.C2AllFieldsFull()
	--CHECK the CheckForWinArray for Matches
	for i = 1 , table.getn(C2CheckForWinTable) , 1 do
		YouWin = 0
		OppWin = 0
		C2YouWinArray = {}
		C2OppWinArray = {}
		for j = 1 , table.getn(C2CheckForWinTable[i]) , 1 do
			C2CurrentOne = C2CheckForWinTable[i][j]
			if(ESO_MG_C2G_GRIDOBJC[C2CurrentOne].status == 1) then
				YouWin = 0
				C2YouWinArray = {}
				OppWin = OppWin + 1
				table.insert(C2OppWinArray, C2CurrentOne)
				if(OppWin == ESO_MG_C2G_CONNECTTOWIN)then
					ESO_MG.C2DrawWinLine(C2OppWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Lose1)
					ESO_MG_C2G_PWON:SetText("|cff0000Your Opponent \nwon the Game!")
					ESO_MG_C2G_PT:SetText(ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
				end
			elseif(ESO_MG_C2G_GRIDOBJC[C2CurrentOne].status == 2) then
				OppWin = 0
				C2OppWinArray = {}
				YouWin = YouWin + 1
				table.insert(C2YouWinArray, C2CurrentOne)
				if(YouWin == ESO_MG_C2G_CONNECTTOWIN)then
					ESO_MG.C2DrawWinLine(C2YouWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Win2)
					ESO_MG_C2G_PWON:SetText("|c00ff00You won the Game!")
					ESO_MG_C2G_PT:SetText("You\n|c888866won the Game!")
				end
			elseif(ESO_MG_C2G_GRIDOBJC[C2CurrentOne].status == 0) then
				OppWin = 0
				YouWin = 0
			end
		end
	end
end

--Colour the Win Line and Setting Win Text
function ESO_MG.C2DrawWinLine(C2WinArray)
	for i,line in ipairs(C2WinArray) do
		ESO_MG_C2G_GRIDOBJ[line]:SetColor(0,1,0,1)
	end
	ESO_MG.C2EndGame()--END GAME
end

--Reset Game
function ESO_MG.C2ResetGame()
	ESO_MG_C2G_PWON:SetAlpha(1)
	for i = 1 , ESO_MG_C2G_COLS * ESO_MG_C2G_ROWS , 1 do
		ESO_MG_C2G_GRIDOBJ[i]:SetColor(0,0,0,0)
		ESO_MG_C2G_GRIDOBJC[i].status = 0
	end
	if(C2CurrentPlayer == 0) then
		ESO_MG_C2G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
	else
		ESO_MG_C2G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
	end
	ESO_MG.C2SetTextures()
end

--Reset the Game Window Size depending on Grid and Replacing some stuff
function ESO_MG.C2SetGameWindowSize()
	if(ESO_MG_C2GameMaxed == 1)then
		ESO_MG_C2G_MENU:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 60, ESO_MG_C2G_ROWS * ESO_MG_C2G_GRIDOBJDIM +200)
	end
	ESO_MG_C2G_GAMECONT:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 50, 0)
	ESO_MG_C2G_C2L1:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 70,2)
	ESO_MG_C2G_C2L2:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 70,2)	
	ESO_MG_C2G_PWON:SetAnchor(CENTER,ESO_MG_C2G_GAMECONT,CENTER,0,(ESO_MG_C2G_ROWS * ESO_MG_C2G_GRIDOBJDIM +200) / 2)
	ESO_MG_C2G_CONT:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM,ESO_MG_C2G_ROWS * ESO_MG_C2G_GRIDOBJDIM)
end

--Check if all Fields are Full
function ESO_MG.C2AllFieldsFull()
	C2AllFieldsFull = 0
	for i = 1, ESO_MG_C2G_COLS * ESO_MG_C2G_ROWS ,1 do
		if(ESO_MG_C2G_GRIDOBJC[i].status == 0) then
			break
		else
			C2AllFieldsFull = C2AllFieldsFull + 1
		end
	end
	if(C2AllFieldsFull == ESO_MG_C2G_COLS * ESO_MG_C2G_ROWS)then
		ESO_MG_C2G_PWON:SetText("|cffff00DRAW!")
		ESO_MG.Sound(ESO_MG_SN_Draw1)
		ESO_MG.C2EndGame()
	end
end

--End the current Game
function ESO_MG.C2EndGame()
	ESO_MG.RotateTexture(8000,ESO_MG_C2G_PWB1,1,-5)
	ESO_MG.RotateTexture(8000,ESO_MG_C2G_PWB2,1,2)
	ESO_MG.RotateTexture(8000,ESO_MG_C2G_PWB3,1,5)
	zo_callLater(function() ESO_MG.Fade(2000,ESO_MG_C2G_PWON,1,0) end,6000)
	EVENT_MANAGER:UnregisterForEvent("C2WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL)
	ESO_MG_C2G_PWON:SetHidden(false)
	ESO_MG_C2GameEnded = 1
	ESO_MG_C2Running = 0
	EVENT_MANAGER:RegisterForEvent("C2WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C2PlayAgain)
	ESO_MG_C2G_PA:SetEnabled(true)
	ESO_MG_C2G_PATX:SetText("|c888866Play Again|r")
	ESO_MG_C2G_CG:SetEnabled(false)
	ESO_MG_C2G_CGTX:SetText("|c666666Quit Game|r")
end

--Close the Menu Depending on GameStatus
function ESO_MG.C2CloseMenu()
	log(ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1))
	if(ESO_MG_C2GameEnded == 1)then
		ESO_MG_C2G_MENU:SetHidden(true)
		ESO_MG_CN_MENU:SetHidden(true)
	else -- Show the Warning 
		ESO_MG_CN_MENU:SetHidden(false)
		ESO_MG_CN_MENU:ClearAnchors()
		ESO_MG_CN_MENU:SetAnchor(CENTER,ESO_MG_C2G_MENU,CENTER,0,0)
		ESO_MG_CN_TXT:SetText("|c888866If you quit the Game, it will only end for you. |c008888" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .." |c888866will not be notified.\nAre you sure you want to quit?")
		ESO_MG_CN_YES:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Quit1) ESO_MG.C2EndGame() ESO_MG_C2G_MENU:SetHidden(true) ESO_MG_CN_MENU:SetHidden(true) end)
	end
end

--Minimize or Maximize the Menu Depending on Status
function ESO_MG.C2ShowHideMenu()
	if(ESO_MG_C2GameMaxed == 1)then
		ESO_MG_CN_MENU:SetHidden(true)
		ESO_MG_C2G_BTNCLOSE:SetHidden(true)
		ESO_MG_C2GameMaxed = 0
		ESO_MG_C2G_GAMECONT:SetHidden(true)
		ESO_MG_C2G_MENU:SetDimensions(175,30)
		ESO_MG_C2G_va, ESO_MG_C2G_pt, ESO_MG_C2G_rt, ESO_MG_C2G_rpt, ESO_MG_C2G_ox, ESO_MG_C2G_oy =  ESO_MG_C2G_MENU:GetAnchor()
		ESO_MG_C2G_MENU:ClearAnchors()
		ESO_MG_C2G_MENU:SetAnchor(BOTTOMRIGHT,GuiRoot,BOTTOMRIGHT,0,-40*ESO_MG_MinimizedGames)
		ESO_MG_C2G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C2G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames + 1
		ESO_MG_C2G_MENU:SetMovable(false)
		ESO_MG_C2G_BTNINFO:SetHidden(true)
		ESO_MG_C2G_BTNSH:ClearAnchors()
		ESO_MG_C2G_BTNSH:SetAnchor(TOPLEFT,TicTacToeMenu,TOPLEFT,0,0)
		ESO_MG_C2MinimizedPosition = ESO_MG_MinimizedGames
		ESO_MG.Sound(ESO_MG_SN_Fade1)
	else
		ESO_MG_C2G_BTNCLOSE:SetHidden(false)
		ESO_MG_C2GameMaxed = 1
		ESO_MG_C2G_GAMECONT:SetHidden(false)
		ESO_MG_C2G_MENU:SetDimensions(ESO_MG_C2G_COLS * ESO_MG_C2G_GRIDOBJDIM + 60, ESO_MG_C2G_ROWS * ESO_MG_C2G_GRIDOBJDIM +200)
		ESO_MG_C2G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C2G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C2G_MENU:ClearAnchors()
		ESO_MG_C2G_MENU:SetAnchor(ESO_MG_C2G_pt,ESO_MG_C2G_rt,ESO_MG_C2G_rpt,ESO_MG_C2G_ox,ESO_MG_C2G_oy)
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames - 1
		ESO_MG_C2G_MENU:SetMovable(true)
		ESO_MG_C2G_BTNINFO:SetHidden(false)
		ESO_MG_C2G_BTNSH:ClearAnchors()
		ESO_MG_C2G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C2G_BTNCLOSE,TOPLEFT,-5,5)
		ESO_MG.MoveMinimizedDown(ESO_MG_C2MinimizedPosition)
		ESO_MG.Sound(ESO_MG_SN_Fade3)
	end
end

--Fill and Open the InfoWindow
function ESO_MG.C2OpenInfo()
	CurrentGame = ESO_MG_CAT2Name
	HelpText = "|c888866Commands:|r\n- |c888866Tell |c008888" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " |c888866a |cffff00Column |c888866and |cffff00Row |c888866to Play this Field. e.g. '|cffff00/Tell " .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " A1|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT2CancelText .. " |c888866to quit the current Game. e.g. '|cffff00/Tell " .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT2CancelText .. "|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT2AgainText .. " |c888866after a match has ended to play again. e.g. '|cffff00/Tell " .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT2AgainText .. "|c888866'|r\n"
	AnchorWindow = ESO_MG_C2G_MENU
	ESO_MG.OpenInfo(CurrentGame , HelpText , AnchorWindow)
end

--Click function Check if the selected Field is free and if so Enter the Field in Chat
function ESO_MG.ClickedItemC2(item,box,status)
	C2ColumnClicked = math.ceil(item / ESO_MG_C2G_COLS)
	C2RowClicked = item - (C2ColumnClicked -1) * ESO_MG_C2G_COLS
	if(status == 0) then
		CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C2WaitForPlayer .. "" .. C2AccOrRealName .. ESO_MG_C2G_ROWLETTERS[C2RowClicked] .. C2ColumnClicked)
	else
		log(ESO_MG_C2G_ROWLETTERS[C2RowClicked] .. C2ColumnClicked .. " is not Free. Please choose another Field.")
	end
	if(ESO_MG_C2G_DEBUGMODE == 1) then --Function to cycle through the status for Debugging
		log("Clicked " .. item)
		if(status <= 1) then
			box.status = box.status + 1
		else
			box.status = 0
		end
		ESO_MG.C2SetTextures()
		log("Status set to: " .. status + 1)
	end
end