--      ___                       ___                       ___           ___           ___           ___           ___     
--     /__/\        ___          /__/\        ___          /  /\         /  /\         /__/\         /  /\         /  /\    
--    |  |::\      /  /\         \  \:\      /  /\        /  /:/_       /  /::\       |  |::\       /  /:/_       /  /:/_   
--    |  |:|:\    /  /:/          \  \:\    /  /:/       /  /:/ /\     /  /:/\:\      |  |:|:\     /  /:/ /\     /  /:/ /\  
--  __|__|:|\:\  /__/::\      _____\__\:\  /__/::\      /  /:/_/::\   /  /:/~/::\   __|__|:|\:\   /  /:/ /:/_   /  /:/ /::\ 
-- /__/::::| \:\ \__\/\:\__  /__/::::::::\ \__\/\:\__  /__/:/__\/\:\ /__/:/ /:/\:\ /__/::::| \:\ /__/:/ /:/ /\ /__/:/ /:/\:\
-- \  \:\~~\__\/    \  \:\/\ \  \:\~~\~~\/    \  \:\/\ \  \:\ /~~/:/ \  \:\/:/__\/ \  \:\~~\__\/ \  \:\/:/ /:/ \  \:\/:/~/:/
--  \  \:\           \__\::/  \  \:\  ~~~      \__\::/  \  \:\  /:/   \  \::/       \  \:\        \  \::/ /:/   \  \::/ /:/ 
--   \  \:\          /__/:/    \  \:\          /__/:/    \  \:\/:/     \  \:\        \  \:\        \  \:\/:/     \__\/ /:/  
--    \  \:\         \__\/      \  \:\         \__\/      \  \::/       \  \:\        \  \:\        \  \::/        /__/:/   
--     \__\/                     \__\/                     \__\/         \__\/         \__\/         \__\/         \__\/    
--=============================================================================================================================
--=============================================================================================================================
--TODO:
--Maybe Adding AI for Singleplayer
--Some Singleplayer games like Tetris / Lockpicker / SpaceInvaders / MineSweeper / Sudoku etc. depending on Wishes
--Maybe Setting to AutoHide the Chat after Input
--=============================================================================================================================
--=============================================================================================================================
--All Credit and Copyrights go to (ESO EU) Dero - @Deryl
--I did my best to comment the code for others to learn from it ;)

--Creation of the Menu
ESO_MG_MAXWIDTH = 600 --Max Width of the Menu
ESO_MG_MAXHEIGHT = 200 --Max Height of the Menu
ESO_MG_MinimizedGames = 0
ESO_MG_SoundEnabled = 1

--Variables for Game Categories
ESO_MG_CAT1Name = "Connect Four"
ESO_MG_CAT1TEXT = " - |c888866Connect Four |r- (2 Players)"
ESO_MG_CAT1Height = 140
ESO_MG_CAT1InviteTime = 30
ESO_MG_CAT1AnswerTime = 30
ESO_MG_CAT1Watch = "ok"
ESO_MG_CAT1InviteText = "Hey there! Let's play 'Connect Four'"
ESO_MG_CAT1CancelText = "C4Quit"
ESO_MG_CAT1AgainText = "C4Again"

ESO_MG_CAT2Name = "Tic Tac Toe"
ESO_MG_CAT2TEXT = " - |c888866Tic Tac Toe |r- (2 Players)"
ESO_MG_CAT2Height = 90
ESO_MG_CAT2InviteTime = 30
ESO_MG_CAT2AnswerTime = 30
ESO_MG_CAT2Watch = "ok"
ESO_MG_CAT2InviteText = "Hey there! Let's play 'Tic Tac Toe'"
ESO_MG_CAT2CancelText = "XOQuit"
ESO_MG_CAT2AgainText = "XOAgain"

ESO_MG_CAT3Name = "Battleship"
ESO_MG_CAT3TEXT = " - |c888866Battleship |r- (2 Players)"
ESO_MG_CAT3Height = 90
ESO_MG_CAT3InviteTime = 30
ESO_MG_CAT3AnswerTime = 30
ESO_MG_CAT3Watch = "ok"
ESO_MG_CAT3InviteText = "Hey there! Let's play 'Battleship'"
ESO_MG_CAT3CancelText = "BSQuit"
ESO_MG_CAT3AgainText = "BSAgain"
ESO_MG_CAT3ReadyText = "BSReady"

ESO_MG_CAT4Name = "Next Game"
ESO_MG_CAT4TEXT = " - |c888866? Next Game ? |r- (Make a Wish)"
ESO_MG_CAT4Height = 70

ESO_MG_CAT5Name = "Info/Help"
ESO_MG_CAT5TEXT = " - |c888866Info/Help for Games |r-"
ESO_MG_CAT5Height = 400

ESO_MG_SELF = GetUnitName("player") 
		
--Creation of the Menu
function ESO_MG.buildmenu()
	if (MiniGamesMenu == nil) then
--------------------------------------------------------------------------------------------------------------------------
-- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART --
--------------------------------------------------------------------------------------------------------------------------
		--Basemenu
		ESO_MG_MENU = WINDOW_MANAGER:CreateTopLevelWindow("MiniGamesMenu")
		ESO_MG_MENU:SetDrawLayer(1)
		ESO_MG_MENU:SetAnchor(ESO_MG_SavedData.MainAnchor[1],ESO_MG_SavedData.MainAnchor[2],ESO_MG_SavedData.MainAnchor[3],ESO_MG_SavedData.MainAnchor[4],ESO_MG_SavedData.MainAnchor[5])
		ESO_MG_MENU:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_MAXHEIGHT)
		ESO_MG_MENU:SetMouseEnabled(true)
		ESO_MG_MENU:SetMovable(true)
		ESO_MG_MENU:SetHandler("OnMoveStop",ESO_MG.MainWindowMoved)
		ESO_MG_MENU_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_Back",MiniGamesMenu,"ZO_DefaultBackdrop")
		
		--MiniGames icon Left
		ESO_MG_SML_I = WINDOW_MANAGER:CreateControl("ESO_MG_SML_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_SML_I:SetDimensions(50,50)
		ESO_MG_SML_I:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,100,-12)
		ESO_MG_SML_I:SetTexture("/esoui/art/campaign/campaign_tabicon_summary_up.dds")

		--MiniGames icon Right
		ESO_MG_SMR_I = WINDOW_MANAGER:CreateControl("ESO_MG_SMR_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_SMR_I:SetDimensions(50,50)
		ESO_MG_SMR_I:SetAnchor(TOPRIGHT,MiniGamesMenu,TOPRIGHT,-100,-12)
		ESO_MG_SMR_I:SetTexture("esoui/art/campaign/campaign_tabicon_summary_up.dds")
		
		--Headertext
		ESO_MG_HEADER = WINDOW_MANAGER:CreateControl("ESO_MG_HEAD",MiniGamesMenu,CT_LABEL)
		ESO_MG_HEADER:SetText("|c880000MiniGames|r  ver." .. ESO_MG.version)
		ESO_MG_HEADER:SetFont("ZoFontTooltipTitle")
		ESO_MG_HEADER:SetAnchor(TOP,MiniGamesMenu,TOP,0,0)

		--X-Button to Close the Menu
		ESO_MG_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_MG_BTNCLS",MiniGamesMenu,CT_BUTTON)
		ESO_MG_BTNCLOSE:SetDimensions(20,20)
		ESO_MG_BTNCLOSE:SetHandler("OnClicked",ESO_MG.openmenu)
		ESO_MG_BTNCLOSE:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_MG_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_MG_BTNCLOSE:SetAnchor(TOPRIGHT,MiniGamesMenu,TOPRIGHT,0,0)

		--BOTTOMRIGHT LINE
		ESO_MG_LINEBOTTOMRIGHT1 = WINDOW_MANAGER:CreateControl("ESO_MG_L_BOTTOMRIGHT1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_LINEBOTTOMRIGHT1:SetDimensions(375,5)
		ESO_MG_LINEBOTTOMRIGHT1:SetAnchor(BOTTOMRIGHT,MiniGamesMenu,BOTTOMRIGHT,5,35)
		ESO_MG_LINEBOTTOMRIGHT1:SetTexture("/esoui/art/miscellaneous/wide_divider_left.dds")

		--Footertext
		ESO_MG_FOOTER = WINDOW_MANAGER:CreateControl("ESO_MG_FOOT",MiniGamesMenu,CT_LABEL)
		ESO_MG_FOOTER:SetText("Created by: |c880000(ESO-EU) Illuminati - Dero - @Deryl|r")
		ESO_MG_FOOTER:SetFont("ZoFontGame")
		ESO_MG_FOOTER:SetAnchor(BOTTOMRIGHT,MiniGamesMenu,BOTTOMRIGHT,0,30)
		
--------------------------------------------------------------------------------------------------------------------------
-- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CATEGORY1 -- CA
--------------------------------------------------------------------------------------------------------------------------
		
		--CAT1 Line1 -- LINKED: ESO_MG_C1TX1_I, ESO_MG_C1TXSH, ESO_MG_C1L2
		ESO_MG_C1L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1L1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C1L1:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C1L1:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,-6,30)
		ESO_MG_C1L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--CAT1 Text and Icon
		ESO_MG_C1TX1_I = WINDOW_MANAGER:CreateControl("ESO_MG_C1TX1_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C1TX1_I:SetDimensions(40,40)
		ESO_MG_C1TX1_I:SetAnchor(TOPLEFT,ESO_MG_C1L1,TOPLEFT,-5,-5)
		ESO_MG_C1TX1_I:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
		ESO_MG_C1TX1_I:SetColor(1,0,0,1)
		ESO_MG_C1TX1_I2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1TX1_I2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C1TX1_I2:SetDimensions(40,40)
		ESO_MG_C1TX1_I2:SetAnchor(TOPLEFT,ESO_MG_C1TX1_I,TOPRIGHT,-15,0)
		ESO_MG_C1TX1_I2:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
		ESO_MG_C1TX1_I2:SetColor(0,1,1,1)
		ESO_MG_C1TX1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1TX1",MiniGamesMenu,CT_LABEL)
		ESO_MG_C1TX1:SetText(ESO_MG_CAT1TEXT)
		ESO_MG_C1TX1:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C1TX1:SetAnchor(TOPLEFT,ESO_MG_C1TX1_I2,TOPRIGHT,-10,10)

		--Show/Hide CAT1 Button
		ESO_MG_C1TXSH = WINDOW_MANAGER:CreateControl("C1TXSH",MiniGamesMenu,CT_LABEL)
		ESO_MG_C1TXSH:SetFont("ZoFontGame")
		ESO_MG_C1TXSH:SetText("Show " .. ESO_MG_CAT1Name)
		ESO_MG_C1TXSH:SetAnchor(TOPRIGHT,ESO_MG_C1L1,TOPRIGHT,-30,5)
		ESO_MG_C1BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C1BTNSH",MiniGamesMenu,CT_BUTTON)
		ESO_MG_C1BTNSH:SetDimensions(30,30)
		ESO_MG_C1BTNSH:SetHandler("OnClicked",ESO_MG.SwitchCat1)
		ESO_MG_C1BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C1BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C1BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C1BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C1TXSH,TOPRIGHT,31,-5)
		
		--CAT1 Line2 -- LINKED: ESO_MG_C1CONT
		ESO_MG_C1L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1L2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C1L2:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C1L2:SetAnchor(TOPLEFT,ESO_MG_C1L1,TOPLEFT,0,30)
		ESO_MG_C1L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--CAT1 Container -- LINKED:
		ESO_MG_C1CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C1CONT",MiniGamesMenu,CT_CONTROL)
		ESO_MG_C1CONT:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_CAT1Height)
		ESO_MG_C1CONT:SetAnchor(TOPLEFT,ESO_MG_C1L2,TOPLEFT,6,0)
		
		--EditboxText for Invite Player
		ESO_MG_C1BOXIPTX = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXIPTX",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXIPTX:SetText("|c888866Invite Player:")
		ESO_MG_C1BOXIPTX:SetFont("ZoFontGame")
		ESO_MG_C1BOXIPTX:SetAnchor(TOPLEFT,ESO_MG_C1CONT,TOPLEFT,10,10)
		ESO_MG_C1BOXIPBG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXIPBG", ESO_MG_C1BOXIPTX, "ZO_EditBackdrop")
		ESO_MG_C1BOXIPBG:SetDimensions(200,25)
		ESO_MG_C1BOXIPBG:SetAnchor(TOPLEFT,ESO_MG_C1BOXIPTX,TOPLEFT,150,-2)
		ESO_MG_C1BOXIP = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXIP", ESO_MG_C1BOXIPBG, "ZO_DefaultEditForBackdrop")
		ESO_MG_C1BOXIP:SetResizeToFitDescendents(false)
		ESO_MG_C1BOXIP:SetMouseEnabled(true)
		ESO_MG_C1BOXIP:SetText("")
		ESO_MG_C1BOXIPTX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXIPTX2",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXIPTX2:SetText("(|cff0000@PlayerName|r or |cff0000PlayerName|r)")
		ESO_MG_C1BOXIPTX2:SetFont("ZoFontGame")
		ESO_MG_C1BOXIPTX2:SetAnchor(TOPLEFT,ESO_MG_C1BOXIP,TOPRIGHT,10,0)

		--EditboxText for MaxRows
		ESO_MG_C1BOXMRTX = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXMRTX",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXMRTX:SetText("|c888866Number of Rows:")
		ESO_MG_C1BOXMRTX:SetFont("ZoFontGame")
		ESO_MG_C1BOXMRTX:SetAnchor(TOPLEFT,ESO_MG_C1CONT,TOPLEFT,10,36)
		ESO_MG_C1BOXMRBG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXMRBG", ESO_MG_C1BOXMRTX, "ZO_EditBackdrop")
		ESO_MG_C1BOXMRBG:SetDimensions(50,25)
		ESO_MG_C1BOXMRBG:SetAnchor(TOPLEFT,ESO_MG_C1BOXMRTX,TOPLEFT,150,-2)
		ESO_MG_C1BOXMR = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXMR", ESO_MG_C1BOXMRBG, "ZO_DefaultEditForBackdrop")
		ESO_MG_C1BOXMR:SetResizeToFitDescendents(false)
		ESO_MG_C1BOXMR:SetMouseEnabled(true)
		ESO_MG_C1BOXMR:SetText("")
		ESO_MG_C1BOXMRTX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXMRTX2",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXMRTX2:SetText("(Min: |cff00005|r - Max: |cff000010|r)")
		ESO_MG_C1BOXMRTX2:SetFont("ZoFontGame")
		ESO_MG_C1BOXMRTX2:SetAnchor(TOPLEFT,ESO_MG_C1BOXMR,TOPRIGHT,10,0)

		--EditboxText for MaxCols
		ESO_MG_C1BOXMCTX = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXMCTX",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXMCTX:SetText("|c888866Number of Colums:")
		ESO_MG_C1BOXMCTX:SetFont("ZoFontGame")
		ESO_MG_C1BOXMCTX:SetAnchor(TOPLEFT,ESO_MG_C1CONT,TOPLEFT,10,62)
		ESO_MG_C1BOXMCBG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXMCBG", ESO_MG_C1BOXMCTX, "ZO_EditBackdrop")
		ESO_MG_C1BOXMCBG:SetDimensions(50,25)
		ESO_MG_C1BOXMCBG:SetAnchor(TOPLEFT,ESO_MG_C1BOXMCTX,TOPLEFT,150,-2)
		ESO_MG_C1BOXMC = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1BOXMC", ESO_MG_C1BOXMCBG, "ZO_DefaultEditForBackdrop")
		ESO_MG_C1BOXMC:SetResizeToFitDescendents(false)
		ESO_MG_C1BOXMC:SetMouseEnabled(true)
		ESO_MG_C1BOXMC:SetText("")
		ESO_MG_C1BOXMCTX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1BOXMCTX2",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1BOXMCTX2:SetText("(Min: |cff00005|r - Max: |cff000010|r)")
		ESO_MG_C1BOXMCTX2:SetFont("ZoFontGame")
		ESO_MG_C1BOXMCTX2:SetAnchor(TOPLEFT,ESO_MG_C1BOXMC,TOPRIGHT,10,0)
		
		--Button Send Invite
		ESO_MG_C1_SI = WINDOW_MANAGER:CreateControl("ESO_MG_C1_SI",ESO_MG_C1CONT,CT_BUTTON)
		ESO_MG_C1_SI:SetDimensions(150,40)
		ESO_MG_C1_SI:SetHandler("OnClicked",ESO_MG.C1_FUN_SendInvite)
		ESO_MG_C1_SI:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C1_SI:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C1_SI:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C1_SI:SetAnchor(BOTTOMRIGHT,ESO_MG_C1CONT,BOTTOMRIGHT,-10,-10)
		ESO_MG_C1_SITX = WINDOW_MANAGER:CreateControl("ESO_MG_C1_SITX",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1_SITX:SetText("|c888866Send Invite|r")
		ESO_MG_C1_SITX:SetFont("ZoFontGame")
		ESO_MG_C1_SITX:SetAnchor(CENTER,ESO_MG_C1_SI,CENTER,0,0)

		--Countdown for Player Invite Statictext
		ESO_MG_C1CDSI1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1CDSI1",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1CDSI1:SetText("|c888866Send Invite CountDown:")
		ESO_MG_C1CDSI1:SetFont("ZoFontGame")
		ESO_MG_C1CDSI1:SetAnchor(TOPLEFT,ESO_MG_C1CONT,TOPLEFT,10,90)
		--Countdown for Player Invite
		ESO_MG_C1CDSI = WINDOW_MANAGER:CreateControl("ESO_MG_C1CDSI",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1CDSI:SetText("|cff0000No Invite Initialized!")
		ESO_MG_C1CDSI:SetFont("ZoFontGame")
		ESO_MG_C1CDSI:SetAnchor(TOPLEFT,ESO_MG_C1CDSI1,TOPRIGHT,5,0)

		--Countdown for Player Answer Statictext
		ESO_MG_C1CDAR1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1CDAR1",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1CDAR1:SetText("|c888866Get Answer CountDown:")
		ESO_MG_C1CDAR1:SetFont("ZoFontGame")
		ESO_MG_C1CDAR1:SetAnchor(TOPLEFT,ESO_MG_C1CONT,TOPLEFT,10,110)
		--Countdown for Player Answer
		ESO_MG_C1CDAR = WINDOW_MANAGER:CreateControl("ESO_MG_C1CDAR",ESO_MG_C1CONT,CT_LABEL)
		ESO_MG_C1CDAR:SetText("|cff0000No Invite sent!")
		ESO_MG_C1CDAR:SetFont("ZoFontGame")
		ESO_MG_C1CDAR:SetAnchor(TOPLEFT,ESO_MG_C1CDAR1,TOPRIGHT,5,0)
		
		--Place all following Content for Cat1 in Container!!!
		
--------------------------------------------------------------------------------------------------------------------------
-- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CATEGORY2 -- CA
--------------------------------------------------------------------------------------------------------------------------

		--CAT2 Line1 -- LINKED: ESO_MG_C2TX1_I, ESO_MG_C2TXSH, ESO_MG_C2L2
		ESO_MG_C2L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2L1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C2L1:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C2L1:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,-6,30)
		ESO_MG_C2L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--CAT2 Text and Icon
		ESO_MG_C2TX1_I = WINDOW_MANAGER:CreateControl("ESO_MG_C2TX1_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C2TX1_I:SetDimensions(40,40)
		ESO_MG_C2TX1_I:SetAnchor(TOPLEFT,ESO_MG_C2L1,TOPLEFT,-5,-5)
		ESO_MG_C2TX1_I:SetTexture("/esoui/art/progression/icon_dualwield.dds")
		ESO_MG_C2TX1_I:SetColor(0.8,0,0,1)
		ESO_MG_C2TX1_I2 = WINDOW_MANAGER:CreateControl("ESO_MG_C2TX1_I2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C2TX1_I2:SetDimensions(40,40)
		ESO_MG_C2TX1_I2:SetAnchor(TOPLEFT,ESO_MG_C2TX1_I,TOPRIGHT,-15,0)
		ESO_MG_C2TX1_I2:SetTexture("/esoui/art/charactercreate/charactercreate_raceicon_up.dds")
		ESO_MG_C2TX1_I2:SetColor(0,1,1,1)
		ESO_MG_C2TX1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2TX1",MiniGamesMenu,CT_LABEL)
		ESO_MG_C2TX1:SetText(ESO_MG_CAT2TEXT)
		ESO_MG_C2TX1:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C2TX1:SetAnchor(TOPLEFT,ESO_MG_C2TX1_I2,TOPRIGHT,-10,10)

		--Show/Hide CAT2 Button
		ESO_MG_C2TXSH = WINDOW_MANAGER:CreateControl("C2TXSH",MiniGamesMenu,CT_LABEL)
		ESO_MG_C2TXSH:SetFont("ZoFontGame")
		ESO_MG_C2TXSH:SetText("Show " .. ESO_MG_CAT2Name)
		ESO_MG_C2TXSH:SetAnchor(TOPRIGHT,ESO_MG_C2L1,TOPRIGHT,-30,5)
		ESO_MG_C2BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C2BTNSH",MiniGamesMenu,CT_BUTTON)
		ESO_MG_C2BTNSH:SetDimensions(30,30)
		ESO_MG_C2BTNSH:SetHandler("OnClicked",ESO_MG.SwitchCat2)
		ESO_MG_C2BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C2BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C2BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C2BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C2TXSH,TOPRIGHT,31,-5)
		
		--CAT2 Line2 -- LINKED: ESO_MG_C2CONT
		ESO_MG_C2L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C2L2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C2L2:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C2L2:SetAnchor(TOPLEFT,ESO_MG_C2L1,TOPLEFT,0,30)
		ESO_MG_C2L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--CAT2 Container -- LINKED:
		ESO_MG_C2CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C2CONT",MiniGamesMenu,CT_CONTROL)
		ESO_MG_C2CONT:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_CAT2Height)
		ESO_MG_C2CONT:SetAnchor(TOPLEFT,ESO_MG_C2L2,TOPLEFT,6,0)
		
		--EditboxText for Invite Player
		ESO_MG_C2BOXIPTX = WINDOW_MANAGER:CreateControl("ESO_MG_C2BOXIPTX",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2BOXIPTX:SetText("|c888866Invite Player:")
		ESO_MG_C2BOXIPTX:SetFont("ZoFontGame")
		ESO_MG_C2BOXIPTX:SetAnchor(TOPLEFT,ESO_MG_C2CONT,TOPLEFT,10,10)
		ESO_MG_C2BOXIPBG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C2BOXIPBG", ESO_MG_C2BOXIPTX, "ZO_EditBackdrop")
		ESO_MG_C2BOXIPBG:SetDimensions(200,25)
		ESO_MG_C2BOXIPBG:SetAnchor(TOPLEFT,ESO_MG_C2BOXIPTX,TOPLEFT,150,-2)
		ESO_MG_C2BOXIP = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C2BOXIP", ESO_MG_C2BOXIPBG, "ZO_DefaultEditForBackdrop")
		ESO_MG_C2BOXIP:SetResizeToFitDescendents(false)
		ESO_MG_C2BOXIP:SetMouseEnabled(true)
		ESO_MG_C2BOXIP:SetText("")
		ESO_MG_C2BOXIPTX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C2BOXIPTX2",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2BOXIPTX2:SetText("(|cff0000@PlayerName|r or |cff0000PlayerName|r)")
		ESO_MG_C2BOXIPTX2:SetFont("ZoFontGame")
		ESO_MG_C2BOXIPTX2:SetAnchor(TOPLEFT,ESO_MG_C2BOXIP,TOPRIGHT,10,0)

		--Button Send Invite
		ESO_MG_C2_SI = WINDOW_MANAGER:CreateControl("ESO_MG_C2_SI",ESO_MG_C2CONT,CT_BUTTON)
		ESO_MG_C2_SI:SetDimensions(150,40)
		ESO_MG_C2_SI:SetHandler("OnClicked",ESO_MG.C2_FUN_SendInvite)
		ESO_MG_C2_SI:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C2_SI:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C2_SI:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C2_SI:SetAnchor(BOTTOMRIGHT,ESO_MG_C2CONT,BOTTOMRIGHT,-10,-10)
		ESO_MG_C2_SITX = WINDOW_MANAGER:CreateControl("ESO_MG_C2_SITX",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2_SITX:SetText("|c888866Send Invite|r")
		ESO_MG_C2_SITX:SetFont("ZoFontGame")
		ESO_MG_C2_SITX:SetAnchor(CENTER,ESO_MG_C2_SI,CENTER,0,0)

		--Countdown for Player Invite Statictext
		ESO_MG_C2CDSI1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2CDSI1",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2CDSI1:SetText("|c888866Send Invite CountDown:")
		ESO_MG_C2CDSI1:SetFont("ZoFontGame")
		ESO_MG_C2CDSI1:SetAnchor(TOPLEFT,ESO_MG_C2CONT,TOPLEFT,10,40)
		--Countdown for Player Invite
		ESO_MG_C2CDSI = WINDOW_MANAGER:CreateControl("ESO_MG_C2CDSI",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2CDSI:SetText("|cff0000No Invite Initialized!")
		ESO_MG_C2CDSI:SetFont("ZoFontGame")
		ESO_MG_C2CDSI:SetAnchor(TOPLEFT,ESO_MG_C2CDSI1,TOPRIGHT,5,0)

		--Countdown for Player Answer Statictext
		ESO_MG_C2CDAR1 = WINDOW_MANAGER:CreateControl("ESO_MG_C2CDAR1",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2CDAR1:SetText("|c888866Get Answer CountDown:")
		ESO_MG_C2CDAR1:SetFont("ZoFontGame")
		ESO_MG_C2CDAR1:SetAnchor(TOPLEFT,ESO_MG_C2CONT,TOPLEFT,10,60)
		--Countdown for Player Answer
		ESO_MG_C2CDAR = WINDOW_MANAGER:CreateControl("ESO_MG_C2CDAR",ESO_MG_C2CONT,CT_LABEL)
		ESO_MG_C2CDAR:SetText("|cff0000No Invite sent!")
		ESO_MG_C2CDAR:SetFont("ZoFontGame")
		ESO_MG_C2CDAR:SetAnchor(TOPLEFT,ESO_MG_C2CDAR1,TOPRIGHT,5,0)
		
		--Place all following Content for Cat2 in Container!!!

--------------------------------------------------------------------------------------------------------------------------
-- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CATEGORY3 -- CA
--------------------------------------------------------------------------------------------------------------------------
		
		--CAT3 Line1 -- LINKED: ESO_MG_C3TX1_I, ESO_MG_C3TXSH, ESO_MG_C3L2
		ESO_MG_C3L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3L1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C3L1:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C3L1:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,-6,30)
		ESO_MG_C3L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--CAT3 Text and Icon
		ESO_MG_C3TX1_I = WINDOW_MANAGER:CreateControl("ESO_MG_C3TX1_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C3TX1_I:SetDimensions(40,40)
		ESO_MG_C3TX1_I:SetAnchor(TOPLEFT,ESO_MG_C3L1,TOPLEFT,-5,-5)
		ESO_MG_C3TX1_I:SetTexture("/esoui/art/campaign/campaign_tabicon_browser_up.dds")
		ESO_MG_C3TX1_I:SetColor(0.8,0,0,1)
		ESO_MG_C3TX1_I2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3TX1_I2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C3TX1_I2:SetDimensions(40,40)
		ESO_MG_C3TX1_I2:SetAnchor(TOPLEFT,ESO_MG_C3TX1_I,TOPRIGHT,-15,0)
		ESO_MG_C3TX1_I2:SetTexture("/esoui/art/campaign/campaign_tabicon_browser_up.dds")
		ESO_MG_C3TX1_I2:SetColor(0,1,1,1)
		ESO_MG_C3TX1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3TX1",MiniGamesMenu,CT_LABEL)
		ESO_MG_C3TX1:SetText(ESO_MG_CAT3TEXT)
		ESO_MG_C3TX1:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C3TX1:SetAnchor(TOPLEFT,ESO_MG_C3TX1_I2,TOPRIGHT,-10,10)

		--Show/Hide CAT3 Button
		ESO_MG_C3TXSH = WINDOW_MANAGER:CreateControl("ESO_MG_C3TXSH",MiniGamesMenu,CT_LABEL)
		ESO_MG_C3TXSH:SetFont("ZoFontGame")
		ESO_MG_C3TXSH:SetText("Show " .. ESO_MG_CAT3Name)
		ESO_MG_C3TXSH:SetAnchor(TOPRIGHT,ESO_MG_C3L1,TOPRIGHT,-30,5)
		ESO_MG_C3BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C3BTNSH",MiniGamesMenu,CT_BUTTON)
		ESO_MG_C3BTNSH:SetDimensions(30,30)
		ESO_MG_C3BTNSH:SetHandler("OnClicked",ESO_MG.SwitchCat3)
		ESO_MG_C3BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C3BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C3BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C3TXSH,TOPRIGHT,31,-5)
		
		--CAT3 Line2 -- LINKED: ESO_MG_C3CONT
		ESO_MG_C3L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3L2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C3L2:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C3L2:SetAnchor(TOPLEFT,ESO_MG_C3L1,TOPLEFT,0,30)
		ESO_MG_C3L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--CAT3 Container -- LINKED:
		ESO_MG_C3CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C3CONT",MiniGamesMenu,CT_CONTROL)
		ESO_MG_C3CONT:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_CAT3Height)
		ESO_MG_C3CONT:SetAnchor(TOPLEFT,ESO_MG_C3L2,TOPLEFT,6,0)
		
		--EditboxText for Invite Player
		ESO_MG_C3BOXIPTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3BOXIPTX",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3BOXIPTX:SetText("|c888866Invite Player:")
		ESO_MG_C3BOXIPTX:SetFont("ZoFontGame")
		ESO_MG_C3BOXIPTX:SetAnchor(TOPLEFT,ESO_MG_C3CONT,TOPLEFT,10,10)
		ESO_MG_C3BOXIPBG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3BOXIPBG", ESO_MG_C3BOXIPTX, "ZO_EditBackdrop")
		ESO_MG_C3BOXIPBG:SetDimensions(200,25)
		ESO_MG_C3BOXIPBG:SetAnchor(TOPLEFT,ESO_MG_C3BOXIPTX,TOPLEFT,150,-2)
		ESO_MG_C3BOXIP = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3BOXIP", ESO_MG_C3BOXIPBG, "ZO_DefaultEditForBackdrop")
		ESO_MG_C3BOXIP:SetResizeToFitDescendents(false)
		ESO_MG_C3BOXIP:SetMouseEnabled(true)
		ESO_MG_C3BOXIP:SetText("")
		ESO_MG_C3BOXIPTX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3BOXIPTX2",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3BOXIPTX2:SetText("(|cff0000@PlayerName|r or |cff0000PlayerName|r)")
		ESO_MG_C3BOXIPTX2:SetFont("ZoFontGame")
		ESO_MG_C3BOXIPTX2:SetAnchor(TOPLEFT,ESO_MG_C3BOXIP,TOPRIGHT,10,0)

		--Button Send Invite
		ESO_MG_C3_SI = WINDOW_MANAGER:CreateControl("ESO_MG_C3_SI",ESO_MG_C3CONT,CT_BUTTON)
		ESO_MG_C3_SI:SetDimensions(150,40)
		ESO_MG_C3_SI:SetHandler("OnClicked",ESO_MG.C3_FUN_SendInvite)
		ESO_MG_C3_SI:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3_SI:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3_SI:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3_SI:SetAnchor(BOTTOMRIGHT,ESO_MG_C3CONT,BOTTOMRIGHT,-10,-10)
		ESO_MG_C3_SITX = WINDOW_MANAGER:CreateControl("ESO_MG_C3_SITX",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3_SITX:SetText("|c888866Send Invite|r")
		ESO_MG_C3_SITX:SetFont("ZoFontGame")
		ESO_MG_C3_SITX:SetAnchor(CENTER,ESO_MG_C3_SI,CENTER,0,0)

		--Countdown for Player Invite Statictext
		ESO_MG_C3CDSI1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3CDSI1",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3CDSI1:SetText("|c888866Send Invite CountDown:")
		ESO_MG_C3CDSI1:SetFont("ZoFontGame")
		ESO_MG_C3CDSI1:SetAnchor(TOPLEFT,ESO_MG_C3CONT,TOPLEFT,10,40)
		--Countdown for Player Invite
		ESO_MG_C3CDSI = WINDOW_MANAGER:CreateControl("ESO_MG_C3CDSI",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3CDSI:SetText("|cff0000No Invite Initialized!")
		ESO_MG_C3CDSI:SetFont("ZoFontGame")
		ESO_MG_C3CDSI:SetAnchor(TOPLEFT,ESO_MG_C3CDSI1,TOPRIGHT,5,0)

		--Countdown for Player Answer Statictext
		ESO_MG_C3CDAR1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3CDAR1",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3CDAR1:SetText("|c888866Get Answer CountDown:")
		ESO_MG_C3CDAR1:SetFont("ZoFontGame")
		ESO_MG_C3CDAR1:SetAnchor(TOPLEFT,ESO_MG_C3CONT,TOPLEFT,10,60)
		--Countdown for Player Answer
		ESO_MG_C3CDAR = WINDOW_MANAGER:CreateControl("ESO_MG_C3CDAR",ESO_MG_C3CONT,CT_LABEL)
		ESO_MG_C3CDAR:SetText("|cff0000No Invite sent!")
		ESO_MG_C3CDAR:SetFont("ZoFontGame")
		ESO_MG_C3CDAR:SetAnchor(TOPLEFT,ESO_MG_C3CDAR1,TOPRIGHT,5,0)
		
		--Place all following Content for Cat3 in Container!!!

--------------------------------------------------------------------------------------------------------------------------
-- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CATEGORY4 -- CA
--------------------------------------------------------------------------------------------------------------------------

		--CAT4 Line1 -- LINKED: ESO_MG_C4TX1_I, ESO_MG_C4TXSH, ESO_MG_C4L2
		ESO_MG_C4L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C4L1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C4L1:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C4L1:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,-6,30)
		ESO_MG_C4L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--CAT4 Text and Icon
		ESO_MG_C4TX1_I = WINDOW_MANAGER:CreateControl("ESO_MG_C4TX1_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C4TX1_I:SetDimensions(40,40)
		ESO_MG_C4TX1_I:SetAnchor(TOPLEFT,ESO_MG_C4L1,TOPLEFT,-5,-5)
		ESO_MG_C4TX1_I:SetTexture("/esoui/art/charactercreate/charactercreate_faceicon_up.dds")
		ESO_MG_C4TX1 = WINDOW_MANAGER:CreateControl("ESO_MG_C4TX1",MiniGamesMenu,CT_LABEL)
		ESO_MG_C4TX1:SetText(ESO_MG_CAT4TEXT)
		ESO_MG_C4TX1:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C4TX1:SetAnchor(TOPLEFT,ESO_MG_C4TX1_I,TOPLEFT,30,10)

		--Show/Hide CAT4 Button
		ESO_MG_C4TXSH = WINDOW_MANAGER:CreateControl("C4TXSH",MiniGamesMenu,CT_LABEL)
		ESO_MG_C4TXSH:SetFont("ZoFontGame")
		ESO_MG_C4TXSH:SetText("Show " .. ESO_MG_CAT4Name)
		ESO_MG_C4TXSH:SetAnchor(TOPRIGHT,ESO_MG_C4L1,TOPRIGHT,-30,5)
		ESO_MG_C4BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C4BTNSH",MiniGamesMenu,CT_BUTTON)
		ESO_MG_C4BTNSH:SetDimensions(30,30)
		ESO_MG_C4BTNSH:SetHandler("OnClicked",ESO_MG.SwitchCat4)
		ESO_MG_C4BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C4BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C4BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C4BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C4TXSH,TOPRIGHT,31,-5)
		
		--CAT4 Line2 -- LINKED: ESO_MG_C4CONT
		ESO_MG_C4L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C4L2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C4L2:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C4L2:SetAnchor(TOPLEFT,ESO_MG_C4L1,TOPLEFT,0,30)
		ESO_MG_C4L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--CAT4 Container -- LINKED:
		ESO_MG_C4CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C4CONT",MiniGamesMenu,CT_SCROLL)
		ESO_MG_C4CONT:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_CAT4Height)
		ESO_MG_C4CONT:SetAnchor(TOPLEFT,ESO_MG_C4L2,TOPLEFT,6,0)
		
		--NextGameWish Text
		ESO_MG_C4TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C4TX2",ESO_MG_C4CONT,CT_LABEL)
		ESO_MG_C4TX2:SetText("|c888866Do you have any Suggestions / Wishes what the next Game should be?\nThen Post it on www.ESOUI.com at the MiniGames AddOn Comments section!\nThe most wanted Game will be the next Game! ;)")
		ESO_MG_C4TX2:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C4TX2:SetAnchorFill(ESO_MG_C4CONT)
		--Place all following Content for Cat4 in Container!!!


--------------------------------------------------------------------------------------------------------------------------
-- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CATEGORY5 -- CA
--------------------------------------------------------------------------------------------------------------------------

		--CAT5 Line1 -- LINKED: ESO_MG_C5TX1_I, ESO_MG_C5TXSH, ESO_MG_C5L2
		ESO_MG_C5L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C5L1",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C5L1:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C5L1:SetAnchor(TOPLEFT,MiniGamesMenu,TOPLEFT,-6,30)
		ESO_MG_C5L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--CAT5 Text and Icon
		ESO_MG_C5TX1_I = WINDOW_MANAGER:CreateControl("ESO_MG_C5TX1_I",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C5TX1_I:SetDimensions(40,40)
		ESO_MG_C5TX1_I:SetAnchor(TOPLEFT,ESO_MG_C5L1,TOPLEFT,-5,-5)
		ESO_MG_C5TX1_I:SetTexture("/esoui/art/help/help_tabicon_tutorial_up.dds")
		ESO_MG_C5TX1 = WINDOW_MANAGER:CreateControl("ESO_MG_C5TX1",MiniGamesMenu,CT_LABEL)
		ESO_MG_C5TX1:SetText(ESO_MG_CAT5TEXT)
		ESO_MG_C5TX1:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C5TX1:SetAnchor(TOPLEFT,ESO_MG_C5TX1_I,TOPLEFT,30,10)

		--Show/Hide CAT5 Button
		ESO_MG_C5TXSH = WINDOW_MANAGER:CreateControl("C5TXSH",MiniGamesMenu,CT_LABEL)
		ESO_MG_C5TXSH:SetFont("ZoFontGame")
		ESO_MG_C5TXSH:SetText("Show " .. ESO_MG_CAT5Name)
		ESO_MG_C5TXSH:SetAnchor(TOPRIGHT,ESO_MG_C5L1,TOPRIGHT,-30,5)
		ESO_MG_C5BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C5BTNSH",MiniGamesMenu,CT_BUTTON)
		ESO_MG_C5BTNSH:SetDimensions(30,30)
		ESO_MG_C5BTNSH:SetHandler("OnClicked",ESO_MG.SwitchCat5)
		ESO_MG_C5BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C5BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C5BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C5BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C5TXSH,TOPRIGHT,31,-5)
		
		--CAT5 Line2 -- LINKED: ESO_MG_C5CONT
		ESO_MG_C5L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C5L2",MiniGamesMenu,CT_TEXTURE)
		ESO_MG_C5L2:SetDimensions(ESO_MG_MAXWIDTH+10,3)
		ESO_MG_C5L2:SetAnchor(TOPLEFT,ESO_MG_C5L1,TOPLEFT,0,30)
		ESO_MG_C5L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--CAT5 Container -- LINKED:
		ESO_MG_C5CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C5CONT",MiniGamesMenu,CT_SCROLL)
		ESO_MG_C5CONT:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_CAT5Height)
		ESO_MG_C5CONT:SetAnchor(TOPLEFT,ESO_MG_C5L2,TOPLEFT,6,0)
		
		--Upcoming SinglePlayer Games
		ESO_MG_C5TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C5TX2",ESO_MG_C5CONT,CT_LABEL)
		ESO_MG_C5TX2:SetText("|cffff00Every Game has an Info-Button (i) at the TopLeft of the Gamewindow. Click this Button to get more Informations about the current Game-Commands.\nYou can Click the Playfield or the Buttons in the Games to get predefined Commands in the Chat Window.\nYou need to send each Command manually by pressing [Enter] (default), since the API does not allows to send automated Chatmessages. :(|r\n\nSuggested SinglePlayer Games:\nTetris / Lockpicker / SpaceInvaders / MineSweeper / Sudoku\n\nSuggested MultiPlayer Games:\nHangMan (More than 2 Players)\n\n|cff0000Any suggestions for Single-/Multiplayer Games?\nWrite a Comment on www.ESOUI.com at the MiniGames-AddOn.\nOr send an ingame Mail (ESO-EU) to Dero or @Deryl\nPlease report any Errors/Bugs/Wishes to me by Ingame mail or at\nwww.ESOUI.com (at the Forum or at MiniGames Addon-Comments).")
		ESO_MG_C5TX2:SetFont("ZoFontGameLargeBoldShadow")
		ESO_MG_C5TX2:SetAnchorFill(ESO_MG_C5CONT)
		--Place all following Content for Cat5 in Container!!!

		--Set the Mode for the Categories
		ESO_MG.SetCat1()
		ESO_MG.SetCat2()
		ESO_MG.SetCat3()
		ESO_MG.SetCat4()
		ESO_MG.SetCat5()
		
		--Hide the Menu after building it up
		MiniGamesMenu:SetHidden(not MiniGamesMenu:IsHidden())
	end	
end

--======================================================================================================================================
-- SET CORRECT ICON FOR CATEGORYS -- SET CORRECT ICON FOR CATEGORYS -- SET CORRECT ICON FOR CATEGORYS -- SET CORRECT ICON FOR CATEGORYS 
--======================================================================================================================================

--Sets the correct Icon for CAT1 and Anchor for CAT2
function ESO_MG.SetCat1()
	if (ESO_MG_SavedData.Cat1Hidden == 1) then
		ESO_MG_C1TXSH:SetText("Show " .. ESO_MG_CAT1Name)
		ESO_MG_C1BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C1BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C2L1:SetAnchor(TOPLEFT,ESO_MG_C1L2,TOPLEFT,0,0)
		ESO_MG_C1CONT:SetHidden(true)
	else		
		ESO_MG_C1TXSH:SetText("Hide " .. ESO_MG_CAT1Name)
		ESO_MG_C1BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C1BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C2L1:SetAnchor(TOPLEFT,ESO_MG_C1L2,TOPLEFT,0,ESO_MG_CAT1Height)
		ESO_MG_C1CONT:SetHidden(false)
	end
	ESO_MG.AdjustMenuSize()
end

--Sets the correct Icon for CAT2 and Anchor for CAT3
function ESO_MG.SetCat2()
	if (ESO_MG_SavedData.Cat2Hidden == 1) then
		ESO_MG_C2TXSH:SetText("Show " .. ESO_MG_CAT2Name)
		ESO_MG_C2BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C2BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C3L1:SetAnchor(TOPLEFT,ESO_MG_C2L2,TOPLEFT,0,0)
		ESO_MG_C2CONT:SetHidden(true)
	else		
		ESO_MG_C2TXSH:SetText("Hide " .. ESO_MG_CAT2Name)
		ESO_MG_C2BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C2BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C3L1:SetAnchor(TOPLEFT,ESO_MG_C2L2,TOPLEFT,0,ESO_MG_CAT2Height)
		ESO_MG_C2CONT:SetHidden(false)
	end
	ESO_MG.AdjustMenuSize()
end

--Sets the correct Icon for CAT3 and Anchor for CAT4
function ESO_MG.SetCat3()
	if (ESO_MG_SavedData.Cat3Hidden == 1) then
		ESO_MG_C3TXSH:SetText("Show " .. ESO_MG_CAT3Name)
		ESO_MG_C3BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C3BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C4L1:SetAnchor(TOPLEFT,ESO_MG_C3L2,TOPLEFT,0,0)
		ESO_MG_C3CONT:SetHidden(true)
	else		
		ESO_MG_C3TXSH:SetText("Hide " .. ESO_MG_CAT3Name)
		ESO_MG_C3BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C3BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C4L1:SetAnchor(TOPLEFT,ESO_MG_C3L2,TOPLEFT,0,ESO_MG_CAT3Height)
		ESO_MG_C3CONT:SetHidden(false)
	end
	ESO_MG.AdjustMenuSize()
end

--Sets the correct Icon for CAT4 and Anchor for CAT5
function ESO_MG.SetCat4()
	if (ESO_MG_SavedData.Cat4Hidden == 1) then
		ESO_MG_C4TXSH:SetText("Show " .. ESO_MG_CAT4Name)
		ESO_MG_C4BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C4BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_C5L1:SetAnchor(TOPLEFT,ESO_MG_C4L2,TOPLEFT,0,0)
		ESO_MG_C4CONT:SetHidden(true)
	else		
		ESO_MG_C4TXSH:SetText("Hide " .. ESO_MG_CAT4Name)
		ESO_MG_C4BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C4BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C5L1:SetAnchor(TOPLEFT,ESO_MG_C4L2,TOPLEFT,0,ESO_MG_CAT4Height)
		ESO_MG_C4CONT:SetHidden(false)
	end
	ESO_MG.AdjustMenuSize()
end

--Sets the correct Icon for CAT5
function ESO_MG.SetCat5()
	if (ESO_MG_SavedData.Cat5Hidden == 1) then
		ESO_MG_C5TXSH:SetText("Show " .. ESO_MG_CAT5Name)
		ESO_MG_C5BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C5BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		--ANCHOR FOR NEXT CAT
		ESO_MG_C5CONT:SetHidden(true)
	else		
		ESO_MG_C5TXSH:SetText("Hide " .. ESO_MG_CAT5Name)
		ESO_MG_C5BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C5BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		--ANCHOR FOR NEXT CAT
		ESO_MG_C5CONT:SetHidden(false)
	end
	ESO_MG.AdjustMenuSize()
end

--======================================================================================================================================
-- SHOW / HIDE CATEGORYS -- SHOW / HIDE CATEGORYS -- SHOW / HIDE CATEGORYS -- SHOW / HIDE CATEGORYS -- SHOW / HIDE CATEGORYS -- SHOW / H
--======================================================================================================================================

--Shows / Hides CAT1
function ESO_MG.SwitchCat1()
	if (ESO_MG_SavedData.Cat1Hidden == 1) then
		ESO_MG.Sound(ESO_MG_SN_Fade3)
		ESO_MG_SavedData.Cat1Hidden = 0
	else
		ESO_MG.Sound(ESO_MG_SN_Fade1)
		ESO_MG_SavedData.Cat1Hidden = 1
	end
	ESO_MG.SetCat1()
end

--Shows / Hides CAT2
function ESO_MG.SwitchCat2()
	if (ESO_MG_SavedData.Cat2Hidden == 1) then
		ESO_MG.Sound(ESO_MG_SN_Fade3)
		ESO_MG_SavedData.Cat2Hidden = 0
	else
		ESO_MG.Sound(ESO_MG_SN_Fade1)
		ESO_MG_SavedData.Cat2Hidden = 1
	end
	ESO_MG.SetCat2()
end

--Shows / Hides CAT3
function ESO_MG.SwitchCat3()
	if (ESO_MG_SavedData.Cat3Hidden == 1) then
		ESO_MG.Sound(ESO_MG_SN_Fade3)
		ESO_MG_SavedData.Cat3Hidden = 0
	else
		ESO_MG.Sound(ESO_MG_SN_Fade1)
		ESO_MG_SavedData.Cat3Hidden = 1
	end
	ESO_MG.SetCat3()
end

--Shows / Hides CAT4
function ESO_MG.SwitchCat4()
	if (ESO_MG_SavedData.Cat4Hidden == 1) then
		ESO_MG.Sound(ESO_MG_SN_Fade3)
		ESO_MG_SavedData.Cat4Hidden = 0
	else
		ESO_MG.Sound(ESO_MG_SN_Fade1)
		ESO_MG_SavedData.Cat4Hidden = 1
	end
	ESO_MG.SetCat4()
end

--Shows / Hides CAT5
function ESO_MG.SwitchCat5()
	if (ESO_MG_SavedData.Cat5Hidden == 1) then
		ESO_MG.Sound(ESO_MG_SN_Fade3)
		ESO_MG_SavedData.Cat5Hidden = 0
	else
		ESO_MG.Sound(ESO_MG_SN_Fade1)
		ESO_MG_SavedData.Cat5Hidden = 1
	end
	ESO_MG.SetCat5()
end

--======================================================================================================================================
-- ADJUST MENU HEIGHT -- ADJUST MENU HEIGHT -- ADJUST MENU HEIGHT -- ADJUST MENU HEIGHT -- ADJUST MENU HEIGHT -- ADJUST MENU HEIGHT -- A
--======================================================================================================================================

--Adjust the Menu Height depending on open Categories
function ESO_MG.AdjustMenuSize()
	ESO_MG_MAXHEIGHT = 27+30+30+30+30+30
	if (ESO_MG_SavedData.Cat1Hidden == 0) then
		ESO_MG_MAXHEIGHT = ESO_MG_MAXHEIGHT + ESO_MG_CAT1Height
	end
	if (ESO_MG_SavedData.Cat2Hidden == 0) then
		ESO_MG_MAXHEIGHT = ESO_MG_MAXHEIGHT + ESO_MG_CAT2Height
	end
	if (ESO_MG_SavedData.Cat3Hidden == 0) then
		ESO_MG_MAXHEIGHT = ESO_MG_MAXHEIGHT + ESO_MG_CAT3Height
	end
	if (ESO_MG_SavedData.Cat4Hidden == 0) then
		ESO_MG_MAXHEIGHT = ESO_MG_MAXHEIGHT + ESO_MG_CAT4Height
	end
	if (ESO_MG_SavedData.Cat5Hidden == 0) then
		ESO_MG_MAXHEIGHT = ESO_MG_MAXHEIGHT + ESO_MG_CAT5Height
	end
	ESO_MG_MENU:SetDimensions(ESO_MG_MAXWIDTH,ESO_MG_MAXHEIGHT)
end

--======================================================================================================================================
-- CAT1 You INIT A GAME -- CAT1 You INIT A GAME -- CAT1 You INIT A GAME -- CAT1 You INIT A GAME -- CAT1 You INIT A GAME -- CAT1 You INIT
--======================================================================================================================================

--Send Invite for CAT1
function ESO_MG.C1_FUN_SendInvite()
	if(ESO_MG_C1Running == 1) then
		log("Sorry, you are currently playing a Game of '" .. ESO_MG_CAT1Name .. "'. You can't play the same Game more than once at the same Time.")
	else
		if(ESO_MG_C1BOXIP:GetText() == "" or ESO_MG_C1BOXIP:GetText() == nil) then
			log("Sorry, you need to enter a PlayerName.")
		elseif(ESO_MG_C1BOXMR:GetText() == "" or ESO_MG_C1BOXMR:GetText() == nil or tonumber(ESO_MG_C1BOXMR:GetText()) == nil or tonumber(ESO_MG_C1BOXMR:GetText()) <= 4 or tonumber(ESO_MG_C1BOXMR:GetText()) >= 11) then
			log("Sorry, you need to enter a valid Row Number.")
		elseif(ESO_MG_C1BOXMC:GetText() == "" or ESO_MG_C1BOXMC:GetText() == nil or tonumber(ESO_MG_C1BOXMC:GetText()) == nil or tonumber(ESO_MG_C1BOXMC:GetText()) <= 4 or tonumber(ESO_MG_C1BOXMC:GetText()) >= 11) then
			log("Sorry, you need to enter a valid Column Number.")
		else
			ESO_MG_SavedData.Cat1Settings[1] = ESO_MG_C1BOXMR:GetText()
			ESO_MG_SavedData.Cat1Settings[2] = ESO_MG_C1BOXMC:GetText()
			if not ESO_MG.C1_VAR_WaitForOppAnswer then
				if not ESO_MG.C1_VAR_WaitForSentInvite then
					ESO_MG.C1_VAR_WaitForSentInvite = true
					log("Please Press [ENTER] to send the Invite for MiniGame '" .. ESO_MG_CAT1Name .. "' to " .. ESO_MG_C1BOXIP:GetText() .. ".")
					if(string.find(ESO_MG_C1BOXIP:GetText(), "@") ~= nil) then
						C1AccOrRealName = " "
					else
						C1AccOrRealName = ","
					end
					CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C1BOXIP:GetText() .. "" .. C1AccOrRealName .. "Hey there! Let's play '" .. ESO_MG_CAT1Name .. "' - Answer with 'ok' within " .. ESO_MG_CAT1AnswerTime .. " seconds to accept the Invite. (AddOn 'MiniGames' v." .. ESO_MG.version .." requiered!) " .. ESO_MG_C1BOXMR:GetText() .. " " .. ESO_MG_C1BOXMC:GetText())
					ESO_MG_C1WaitForPlayer = string.lower(ESO_MG_C1BOXIP:GetText())
					C1InviteWasSent = 0
					EVENT_MANAGER:RegisterForEvent("C1EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1_FUN_WaitForSentInvite)				
					C1CurrInvCD = ESO_MG_CAT1InviteTime
					zo_callLater(ESO_MG.C1_FUN_WaitForSentInviteCountDown, 1000)
					ESO_MG_C1CDSI:SetText(ESO_MG_CAT1InviteTime)
					log("You have " .. ESO_MG_CAT1InviteTime .. " seconds to send the Invite until it's no longer valid.")			
				else
					log("You already initialized an Invite. Wait " .. ESO_MG_CAT1InviteTime .. " seconds or type /reloadui.")
				end
			else
				log("You are waiting for a response from an invite and cant send another invite.")
			end
		end
	end
end

--CAT1 Listening to chat for sent Invite
function ESO_MG.C1_FUN_WaitForSentInvite(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if string.find(message, ESO_MG_CAT1InviteText) ~= nil then
			if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C1WaitForPlayer)then
				ESO_MG.C1GetGameOptions(message)
				if(C1ValidOptions == 1) then
					ESO_MG.C1_VAR_WaitForSentInvite = false
					C1InviteWasSent = 1
					if not ESO_MG.C1_VAR_WaitForOppAnswer then
						ESO_MG.C1_VAR_WaitForOppAnswer = true
						C1OppAccepted = 0
						EVENT_MANAGER:RegisterForEvent("C1EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1_FUN_WaitForOppAnswer)
						C1OppCurrAnsCD = ESO_MG_CAT1AnswerTime
						zo_callLater(ESO_MG.C1_FUN_WaitForOppAnswerCountDown, 1000)
						ESO_MG_C1CDAR:SetText(ESO_MG_CAT1AnswerTime)
						ESO_MG_C1CDSI:SetText("|c00ff00Invite sent!")
					else
						log("You are already waiting for a response for the Game '" .. ESO_MG_CAT1Name .. "'.")
					end
					EVENT_MANAGER:UnregisterForEvent("C1EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
				else
					log("Game Options are not Valid! Please Check the Game Options!")
				end
			else
				log("An Invite was sent, but the Player you wrote it to (" .. ZO_ChatWindowTextEntry["system"]["currentTarget"] .. ") is not the Player you set in the Settings (" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. ")!")
			end
		end
	end
end

--CAT1 Countdown to send the Invite
function ESO_MG.C1_FUN_WaitForSentInviteCountDown()
	if(C1InviteWasSent == 0) then
		if(C1CurrInvCD >= 1)then
			C1CurrInvCD = C1CurrInvCD - 1
			zo_callLater(ESO_MG.C1_FUN_WaitForSentInviteCountDown, 1000)
			ESO_MG_C1CDSI:SetText(tostring(C1CurrInvCD))
		else			
			ESO_MG_C1CDSI:SetText("|cff0000No Invite Initialized!")
			ESO_MG.C1_FUN_WaitForSentInviteCancel()
		end
	end
end

--CAT1 Cancel the wait for self listening
function ESO_MG.C1_FUN_WaitForSentInviteCancel()
	if(C1InviteWasSent == 0) then
		ESO_MG.C1_VAR_WaitForSentInvite = false
		log("You haven't sent the Invite for " .. ESO_MG_CAT1InviteTime .. " Seconds. Please Initialize a new Invite. Chat input cleared.")
		CHAT_SYSTEM:StartTextEntry(' ')
		EVENT_MANAGER:UnregisterForEvent("C1EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT1 Listening to chat for ok
function ESO_MG.C1_FUN_WaitForOppAnswer(eventCode, messageType, sender, message)
	if (messageType == 2) then
		if string.lower(message) == string.lower(ESO_MG_CAT1Watch) and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C1WaitForPlayer) then
			ESO_MG.C1_VAR_WaitForOppAnswer = false
			C1OppAccepted = 1			
			ESO_MG_C1CDAR:SetText("|c00ff00Invite accepted!")
			C1CurrentPlayer = 0
			ESO_MG.C1_buildmenu()
			ESO_MG_C1G_MENU:SetHidden(false)
			--
			--
			--
			EVENT_MANAGER:UnregisterForEvent("C1EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
		elseif string.lower(message) == "no" and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C1WaitForPlayer) then
			--do something ^^
		end
	end
end

--CAT1 Countdown to receive answer
function ESO_MG.C1_FUN_WaitForOppAnswerCountDown()
	if(C1OppAccepted == 0) then
		if(C1OppCurrAnsCD >= 1)then
			C1OppCurrAnsCD = C1OppCurrAnsCD - 1
			zo_callLater(ESO_MG.C1_FUN_WaitForOppAnswerCountDown, 1000)
			ESO_MG_C1CDAR:SetText(tostring(C1OppCurrAnsCD))
		else
			ESO_MG_C1CDAR:SetText("|cff0000Invite not accepted!")
			ESO_MG.C1_FUN_WaitForOppAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C1_FUN_WaitForOppAnswerCancel()
	if(C1OppAccepted == 0) then
		ESO_MG.C1_VAR_WaitForOppAnswer = false
		log("You haven't got a response in " .. ESO_MG_CAT1InviteTime .. " Seconds. Please Initialize a new Invite.")		
		EVENT_MANAGER:UnregisterForEvent("C1EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--======================================================================================================================================
-- CAT2 You INIT A GAME -- CAT2 You INIT A GAME -- CAT2 You INIT A GAME -- CAT2 You INIT A GAME -- CAT2 You INIT A GAME -- CAT2 You INIT
--======================================================================================================================================

--Send Invite for CAT2
function ESO_MG.C2_FUN_SendInvite()
	if(ESO_MG_C2Running == 1) then
		log("Sorry, you are currently playing a Game of '" .. ESO_MG_CAT2Name .. "'. You can't play the same Game more than once at the same Time.")
	else
		if(ESO_MG_C2BOXIP:GetText() == "" or ESO_MG_C2BOXIP:GetText() == nil) then
			log("Sorry, you need to enter a PlayerName.")		
		else
			if not ESO_MG.C2_VAR_WaitForOppAnswer then
				if not ESO_MG.C2_VAR_WaitForSentInvite then
					ESO_MG.C2_VAR_WaitForSentInvite = true
					log("Please Press [ENTER] to send the Invite for MiniGame '" .. ESO_MG_CAT2Name .. "' to " .. ESO_MG_C2BOXIP:GetText() .. ".")
					if(string.find(ESO_MG_C2BOXIP:GetText(), "@") ~= nil) then
						C2AccOrRealName = " "
					else
						C2AccOrRealName = ","
					end
					CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C2BOXIP:GetText() .. "" .. C2AccOrRealName .. "Hey there! Let's play '" .. ESO_MG_CAT2Name .. "' - Answer with 'ok' withing " .. ESO_MG_CAT2AnswerTime .. " seconds to accept the Invite. (AddOn 'MiniGames' v." .. ESO_MG.version .. " requiered!) ")				
					ESO_MG_C2WaitForPlayer = string.lower(ESO_MG_C2BOXIP:GetText())
					C2InviteWasSent = 0
					EVENT_MANAGER:RegisterForEvent("C2EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C2_FUN_WaitForSentInvite)				
					C2CurrInvCD = ESO_MG_CAT2InviteTime
					zo_callLater(ESO_MG.C2_FUN_WaitForSentInviteCountDown, 1000)
					ESO_MG_C2CDSI:SetText(ESO_MG_CAT2InviteTime)
					log("You have " .. ESO_MG_CAT2InviteTime .. " seconds to send the Invite until it's no longer valid.")			
				else
					log("You already initialized an Invite. Wait " .. ESO_MG_CAT2InviteTime .. " seconds or type /reloadui.")
				end
			else
				log("You are waiting for a response from an invite and cant send another invite.")
			end
		end
	end
end

--CAT2 Listening to chat for sent Invite
function ESO_MG.C2_FUN_WaitForSentInvite(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C2WaitForPlayer)then
			if string.find(message, ESO_MG_CAT2InviteText) ~= nil then
				ESO_MG.C2GetGameOptions(message)
				if(C2ValidOptions == 1) then
					ESO_MG.C2_VAR_WaitForSentInvite = false
					C2InviteWasSent = 1
					if not ESO_MG.C2_VAR_WaitForOppAnswer then
						ESO_MG.C2_VAR_WaitForOppAnswer = true
						C2OppAccepted = 0
						EVENT_MANAGER:RegisterForEvent("C2EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C2_FUN_WaitForOppAnswer)
						C2OppCurrAnsCD = ESO_MG_CAT2AnswerTime
						zo_callLater(ESO_MG.C2_FUN_WaitForOppAnswerCountDown, 1000)
						ESO_MG_C2CDAR:SetText(ESO_MG_CAT2AnswerTime)
						ESO_MG_C2CDSI:SetText("|c00ff00Invite sent!")
					else
						log("You are already waiting for a response for the Game '" .. ESO_MG_CAT2Name .. "'.")
					end
					EVENT_MANAGER:UnregisterForEvent("C2EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
				else
					log("Game Options are not Valid! Please Check the Game Options!")
				end
			end
		else
			log("An Invite was sent, but the Player you wrote to (" .. ZO_ChatWindowTextEntry["system"]["currentTarget"] .. ") is not the Player you set in the Settings (" .. ESO_MG_C2WaitForPlayer:gsub("%a", string.upper, 1) .. ")!")
		end
	end
end

--CAT2 Countdown to send the Invite
function ESO_MG.C2_FUN_WaitForSentInviteCountDown()
	if(C2InviteWasSent == 0) then
		if(C2CurrInvCD >= 1)then
			C2CurrInvCD = C2CurrInvCD - 1
			zo_callLater(ESO_MG.C2_FUN_WaitForSentInviteCountDown, 1000)
			ESO_MG_C2CDSI:SetText(tostring(C2CurrInvCD))
		else			
			ESO_MG_C2CDSI:SetText("|cff0000No Invite Initialized!")
			ESO_MG.C2_FUN_WaitForSentInviteCancel()
		end
	end
end

--CAT2 Cancel the wait for self listening
function ESO_MG.C2_FUN_WaitForSentInviteCancel()
	if(C2InviteWasSent == 0) then
		ESO_MG.C2_VAR_WaitForSentInvite = false
		log("You haven't sent the Invite for " .. ESO_MG_CAT2InviteTime .. " Seconds. Please Initialize a new Invite. Chat input cleared.")
		CHAT_SYSTEM:StartTextEntry(' ')
		EVENT_MANAGER:UnregisterForEvent("C2EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT2 Listening to chat for ok
function ESO_MG.C2_FUN_WaitForOppAnswer(eventCode, messageType, sender, message)
	if (messageType == 2) then
		if string.lower(message) == string.lower(ESO_MG_CAT2Watch) and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C2WaitForPlayer) then
			ESO_MG.C2_VAR_WaitForOppAnswer = false
			C2OppAccepted = 1			
			ESO_MG_C2CDAR:SetText("|c00ff00Invite accepted!")
			C2CurrentPlayer = 0
			ESO_MG.C2_buildmenu()
			ESO_MG_C2G_MENU:SetHidden(false)
			--
			--
			--
			EVENT_MANAGER:UnregisterForEvent("C2EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
		elseif string.lower(message) == "no" and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C2WaitForPlayer) then
			--do something ^^
		end
	end
end

--CAT2 Countdown to receive answer
function ESO_MG.C2_FUN_WaitForOppAnswerCountDown()
	if(C2OppAccepted == 0) then
		if(C2OppCurrAnsCD >= 1)then
			C2OppCurrAnsCD = C2OppCurrAnsCD - 1
			zo_callLater(ESO_MG.C2_FUN_WaitForOppAnswerCountDown, 1000)
			ESO_MG_C2CDAR:SetText(tostring(C2OppCurrAnsCD))
		else
			ESO_MG_C2CDAR:SetText("|cff0000Invite not accepted!")
			ESO_MG.C2_FUN_WaitForOppAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C2_FUN_WaitForOppAnswerCancel()
	if(C2OppAccepted == 0) then
		ESO_MG.C2_VAR_WaitForOppAnswer = false
		log("You haven't got a response in " .. ESO_MG_CAT2InviteTime .. " Seconds. Please Initialize a new Invite.")		
		EVENT_MANAGER:UnregisterForEvent("C2EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--======================================================================================================================================
-- CAT3 You INIT A GAME -- CAT3 You INIT A GAME -- CAT3 You INIT A GAME -- CAT3 You INIT A GAME -- CAT3 You INIT A GAME -- CAT3 You INIT
--======================================================================================================================================

--Send Invite for CAT3
function ESO_MG.C3_FUN_SendInvite()
	if(ESO_MG_C3Running == 1) then
		log("Sorry, you are currently playing a Game of '" .. ESO_MG_CAT3Name .. "'. You can't play the same Game more than once at the same Time.")
	else
		if(ESO_MG_C3BOXIP:GetText() == "" or ESO_MG_C3BOXIP:GetText() == nil) then
			log("Sorry, you need to enter a PlayerName.")		
		else
			if not ESO_MG.C3_VAR_WaitForOppAnswer then
				if not ESO_MG.C3_VAR_WaitForSentInvite then
					ESO_MG.C3_VAR_WaitForSentInvite = true
					log("Please Press [ENTER] to send the Invite for MiniGame '" .. ESO_MG_CAT3Name .. "' to " .. ESO_MG_C3BOXIP:GetText() .. ".")
					if(string.find(ESO_MG_C3BOXIP:GetText(), "@") ~= nil) then
						ESO_MG_C3AccOrRealName = " "
					else
						ESO_MG_C3AccOrRealName = ","
					end
					CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C3BOXIP:GetText() .. "" .. ESO_MG_C3AccOrRealName .. "Hey there! Let's play '" .. ESO_MG_CAT3Name .. "' - Answer with 'ok' withing " .. ESO_MG_CAT3AnswerTime .. " seconds to accept the Invite. (AddOn 'MiniGames' v." .. ESO_MG.version .. " requiered!) ")				
					ESO_MG_C3WaitForPlayer = string.lower(ESO_MG_C3BOXIP:GetText())
					ESO_MG_C3InviteWasSent = 0
					EVENT_MANAGER:RegisterForEvent("C3EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3_FUN_WaitForSentInvite)				
					ESO_MG_C3CurrInvCD = ESO_MG_CAT3InviteTime
					zo_callLater(ESO_MG.C3_FUN_WaitForSentInviteCountDown, 1000)
					ESO_MG_C3CDSI:SetText(ESO_MG_CAT3InviteTime)
					log("You have " .. ESO_MG_CAT3InviteTime .. " seconds to send the Invite until it's no longer valid.")			
				else
					log("You already initialized an Invite. Wait " .. ESO_MG_CAT3InviteTime .. " seconds or type /reloadui.")
				end
			else
				log("You are waiting for a response from an invite and cant send another invite.")
			end
		end
	end
end

--CAT3 Listening to chat for sent Invite
function ESO_MG.C3_FUN_WaitForSentInvite(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C3WaitForPlayer)then
			if string.find(message, ESO_MG_CAT3InviteText) ~= nil then
				ESO_MG.C3GetGameOptions(message)
				if(ESO_MG_C3ValidOptions == 1) then
					ESO_MG.C3_VAR_WaitForSentInvite = false
					ESO_MG_C3InviteWasSent = 1
					if not ESO_MG.C3_VAR_WaitForOppAnswer then
						ESO_MG.C3_VAR_WaitForOppAnswer = true
						ESO_MG_C3OppAccepted = 0
						EVENT_MANAGER:RegisterForEvent("C3EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3_FUN_WaitForOppAnswer)
						ESO_MG_C3OppCurrAnsCD = ESO_MG_CAT3AnswerTime
						zo_callLater(ESO_MG.C3_FUN_WaitForOppAnswerCountDown, 1000)
						ESO_MG_C3CDAR:SetText(ESO_MG_CAT3AnswerTime)
						ESO_MG_C3CDSI:SetText("|c00ff00Invite sent!")
					else
						log("You are already waiting for a response for the Game '" .. ESO_MG_CAT3Name .. "'.")
					end
					EVENT_MANAGER:UnregisterForEvent("C3EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
				else
					log("Game Options are not Valid! Please Check the Game Options!")
				end
			end
		else
			log("An Invite was sent, but the Player you wrote to (" .. ZO_ChatWindowTextEntry["system"]["currentTarget"] .. ") is not the Player you set in the Settings (" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. ")!")
		end
	end
end

--CAT3 Countdown to send the Invite
function ESO_MG.C3_FUN_WaitForSentInviteCountDown()
	if(ESO_MG_C3InviteWasSent == 0) then
		if(ESO_MG_C3CurrInvCD >= 1)then
			ESO_MG_C3CurrInvCD = ESO_MG_C3CurrInvCD - 1
			zo_callLater(ESO_MG.C3_FUN_WaitForSentInviteCountDown, 1000)
			ESO_MG_C3CDSI:SetText(tostring(ESO_MG_C3CurrInvCD))
		else			
			ESO_MG_C3CDSI:SetText("|cff0000No Invite Initialized!")
			ESO_MG.C3_FUN_WaitForSentInviteCancel()
		end
	end
end

--CAT3 Cancel the wait for self listening
function ESO_MG.C3_FUN_WaitForSentInviteCancel()
	if(ESO_MG_C3InviteWasSent == 0) then
		ESO_MG.C3_VAR_WaitForSentInvite = false
		log("You haven't sent the Invite for " .. ESO_MG_CAT3InviteTime .. " Seconds. Please Initialize a new Invite. Chat input cleared.")
		CHAT_SYSTEM:StartTextEntry(' ')
		EVENT_MANAGER:UnregisterForEvent("C3EvWaitSentInvite", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT3 Listening to chat for ok
function ESO_MG.C3_FUN_WaitForOppAnswer(eventCode, messageType, sender, message)
	if (messageType == 2) then
		if string.lower(message) == string.lower(ESO_MG_CAT3Watch) and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C3WaitForPlayer) then
			ESO_MG.C3_VAR_WaitForOppAnswer = false
			ESO_MG_C3OppAccepted = 1			
			ESO_MG_C3CDAR:SetText("|c00ff00Invite accepted!")
			ESO_MG_C3CurrentPlayer = 0
			ESO_MG.C3_buildmenu()
			ESO_MG_C3G_MENU:SetHidden(false)
			--
			--
			--
			EVENT_MANAGER:UnregisterForEvent("C3EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
		elseif string.lower(message) == "no" and string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C3WaitForPlayer) then
			--do something ^^
		end
	end
end

--CAT3 Countdown to receive answer
function ESO_MG.C3_FUN_WaitForOppAnswerCountDown()
	if(ESO_MG_C3OppAccepted == 0) then
		if(ESO_MG_C3OppCurrAnsCD >= 1)then
			ESO_MG_C3OppCurrAnsCD = ESO_MG_C3OppCurrAnsCD - 1
			zo_callLater(ESO_MG.C3_FUN_WaitForOppAnswerCountDown, 1000)
			ESO_MG_C3CDAR:SetText(tostring(ESO_MG_C3OppCurrAnsCD))
		else
			ESO_MG_C3CDAR:SetText("|cff0000Invite not accepted!")
			ESO_MG.C3_FUN_WaitForOppAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C3_FUN_WaitForOppAnswerCancel()
	if(ESO_MG_C3OppAccepted == 0) then
		ESO_MG.C3_VAR_WaitForOppAnswer = false
		log("You haven't got a response in " .. ESO_MG_CAT3InviteTime .. " Seconds. Please Initialize a new Invite.")		
		EVENT_MANAGER:UnregisterForEvent("C3EvWaitForReceivedAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--======================================================================================================================================
-- CAT1-X Opp INIT A GAME -- CAT1-X Opp INIT A GAME -- CAT1-X Opp INIT A GAME -- CAT1-X Opp INIT A GAME -- CAT1-X Opp INIT A GAME -- CAT
--======================================================================================================================================

--Wait for Invite to any Game
function ESO_MG.C1WaitForInvites(eventCode, messageType, sender, message)
	if (messageType == 2) then
		if string.find(message, ESO_MG_CAT1InviteText) ~= nil then
			if(ESO_MG_C1Running == 1) then
				log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT1Name .. "', but you are already playing '" .. ESO_MG_CAT1Name .. "' and can't start another party!")
			else
				ESO_MG.C1GetGameOptions(message)
				if(C1ValidOptions == 1) then
					EVENT_MANAGER:RegisterForEvent("C1YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1_FUN_WaitForYouAnswer)
					C1YouCurrAnsCD = ESO_MG_CAT1AnswerTime
					C1YouAccepted = 0
					zo_callLater(ESO_MG.C1_FUN_WaitForYouAnswerCountDown, 1000)
					log("You have got an Invite for the Game '" .. ESO_MG_CAT1Name .. "' from " .. sender:gsub("%^.+", "") .. ". Answer with 'ok' within " .. ESO_MG_CAT1AnswerTime .. " seconds to accept the Invite.")
					ESO_MG_C1WaitForPlayer = string.lower(sender:gsub("%^.+", ""))
					if(string.find(ESO_MG_C1WaitForPlayer, "@") ~= nil) then
						ESO_MG_C1AccOrRealName = " "
					else
						ESO_MG_C1AccOrRealName = ","
					end
				else
					log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT1Name .. "', but the Game Options are not correct. You can't accept this Game!")
				end
			end
		elseif string.find(message, ESO_MG_CAT2InviteText) ~= nil then
			if(ESO_MG_C2Running == 1) then
				log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT2Name .. "', but you are already playing '" .. ESO_MG_CAT2Name .. "' and can't start another party!")
			else
				ESO_MG.C2GetGameOptions(message)
				if(C2ValidOptions == 1) then
					EVENT_MANAGER:RegisterForEvent("C2YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C2_FUN_WaitForYouAnswer)			
					C2YouCurrAnsCD = ESO_MG_CAT2AnswerTime
					C2YouAccepted = 0
					zo_callLater(ESO_MG.C2_FUN_WaitForYouAnswerCountDown, 1000)
					log("You have got an Invite for the Game '" .. ESO_MG_CAT2Name .. "' from " .. sender:gsub("%^.+", "") .. ". Answer with 'ok' within " .. ESO_MG_CAT2AnswerTime .. " seconds to accept the Invite.")
					ESO_MG_C2WaitForPlayer = string.lower(sender:gsub("%^.+", ""))
					if(string.find(ESO_MG_C2WaitForPlayer, "@") ~= nil) then
						ESO_MG_C2AccOrRealName = " "
					else
						ESO_MG_C2AccOrRealName = ","
					end
				else
					log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT2Name .. "', but the Game Options are not correct. You can't accept this Game!")
				end
			end
		elseif string.find(message, ESO_MG_CAT3InviteText) ~= nil then
			if(ESO_MG_C3Running == 1) then
				log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT3Name .. "', but you are already playing '" .. ESO_MG_CAT3Name .. "' and can't start another party!")
			else
				ESO_MG.C3GetGameOptions(message)
				if(ESO_MG_C3ValidOptions == 1) then
					EVENT_MANAGER:RegisterForEvent("C3YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3_FUN_WaitForYouAnswer)			
					ESO_MG_C3YouCurrAnsCD = ESO_MG_CAT3AnswerTime
					ESO_MG_C3YouAccepted = 0
					zo_callLater(ESO_MG.C3_FUN_WaitForYouAnswerCountDown, 1000)
					log("You have got an Invite for the Game '" .. ESO_MG_CAT3Name .. "' from " .. sender:gsub("%^.+", "") .. ". Answer with 'ok' within " .. ESO_MG_CAT3AnswerTime .. " seconds to accept the Invite.")
					ESO_MG_C3WaitForPlayer = string.lower(sender:gsub("%^.+", ""))
					if(string.find(ESO_MG_C3WaitForPlayer, "@") ~= nil) then
						ESO_MG_C3AccOrRealName = " "
					else
						ESO_MG_C3AccOrRealName = ","
					end
				else
					log(sender:gsub("%^.+", "") .. " sent an Invite for '" .. ESO_MG_CAT3Name .. "', but the Game Options are not correct. You can't accept this Game!")
				end
			end
		--elseif string.find(message, C4InviteText) ~= nil then
		end
	end
end

--======================================================================================================================================
-- CAT1 Opp INIT A GAME -- CAT1 Opp INIT A GAME -- CAT1 Opp INIT A GAME -- CAT1 Opp INIT A GAME -- CAT1 Opp INIT A GAME -- CAT1 Opp INIT
--======================================================================================================================================

--CAT1 Listening to chat for your ok
function ESO_MG.C1_FUN_WaitForYouAnswer(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C1WaitForPlayer)then
			if string.lower(message) == string.lower(ESO_MG_CAT1Watch) then
				C1YouAccepted = 1
				C1CurrentPlayer = 1
				ESO_MG.C1_buildmenu()
				ESO_MG_C1G_MENU:SetHidden(false)
				EVENT_MANAGER:UnregisterForEvent("C1YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
				--
				--KILL THE WAIT FOR OK EVENT
			elseif string.lower(message) == "no" then
				--do something ^^
			end
		end
	end
end

--CAT1 Countdown to receive answer
function ESO_MG.C1_FUN_WaitForYouAnswerCountDown()
	if(C1YouAccepted == 0) then
		if(C1YouCurrAnsCD >= 1)then
			C1YouCurrAnsCD = C1YouCurrAnsCD - 1			
			zo_callLater(ESO_MG.C1_FUN_WaitForYouAnswerCountDown, 1000)			
		else
			ESO_MG.C1_FUN_WaitForYouAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C1_FUN_WaitForYouAnswerCancel()
	if(C1YouAccepted == 0) then
		log("You haven't sent a response in " .. ESO_MG_CAT1InviteTime .. " Seconds. Invite is no longer Valid.")		
		EVENT_MANAGER:UnregisterForEvent("C1YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT1 Get the Game Options for CAT1 GAME
function ESO_MG.C1GetGameOptions(options)
	ESO_MG_C1G_COLS = nil
	ESO_MG_C1G_ROWS = nil
	ArgArrayNum = 1
	ArgArray = {}
	for i in string.gmatch(options, "%S+") do
		ArgArray[ArgArrayNum] = i
		ArgArrayNum = ArgArrayNum + 1
	end
	if(tonumber(ArgArray[table.getn(ArgArray)]) == nil or tonumber(ArgArray[table.getn(ArgArray)]) >= 11 or tonumber(ArgArray[table.getn(ArgArray)]) <= 4) then
		ESO_MG_C1G_COLS = nil
	else
		ESO_MG_C1G_COLS = tonumber(ArgArray[table.getn(ArgArray)])
	end

	if(tonumber(ArgArray[table.getn(ArgArray)-1]) == nil or tonumber(ArgArray[table.getn(ArgArray)-1]) >= 11 or tonumber(ArgArray[table.getn(ArgArray)-1]) <= 4) then
		ESO_MG_C1G_ROWS = nil
	else
		ESO_MG_C1G_ROWS = tonumber(ArgArray[table.getn(ArgArray)-1])
	end 
	if(ESO_MG_C1G_COLS ~= nil and ESO_MG_C1G_ROWS ~= nil) then
		C1ValidOptions = 1
	else
		C1ValidOptions = 0
	end
end

--======================================================================================================================================
-- CAT2 Opp INIT A GAME -- CAT2 Opp INIT A GAME -- CAT2 Opp INIT A GAME -- CAT2 Opp INIT A GAME -- CAT2 Opp INIT A GAME -- CAT2 Opp INIT
--======================================================================================================================================

--CAT2 Listening to chat for your ok
function ESO_MG.C2_FUN_WaitForYouAnswer(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C2WaitForPlayer)then
			if string.lower(message) == string.lower(ESO_MG_CAT2Watch) then
				C2YouAccepted = 1
				C2CurrentPlayer = 1
				ESO_MG.C2_buildmenu()
				ESO_MG_C2G_MENU:SetHidden(false)
				EVENT_MANAGER:UnregisterForEvent("C2YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
				--
				--
			elseif string.lower(message) == "no" then
				--do something ^^
			end
		end
	end
end

--CAT2 Countdown to receive answer
function ESO_MG.C2_FUN_WaitForYouAnswerCountDown()
	if(C2YouAccepted == 0) then
		if(C2YouCurrAnsCD >= 1)then
			C2YouCurrAnsCD = C2YouCurrAnsCD - 1
			zo_callLater(ESO_MG.C2_FUN_WaitForYouAnswerCountDown, 1000)			
		else
			ESO_MG.C2_FUN_WaitForYouAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C2_FUN_WaitForYouAnswerCancel()
	if(C2YouAccepted == 0) then
		log("You haven't sent a response in " .. ESO_MG_CAT2InviteTime .. " Seconds. Invite is no longer Valid.")		
		EVENT_MANAGER:UnregisterForEvent("C2YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT2 Get the Game Options for CAT2 GAME
function ESO_MG.C2GetGameOptions(options)
	--log("there are no Options to check for this Game.")
	C2ValidOptions = 1
end

--======================================================================================================================================
-- CAT3 Opp INIT A GAME -- CAT3 Opp INIT A GAME -- CAT3 Opp INIT A GAME -- CAT3 Opp INIT A GAME -- CAT3 Opp INIT A GAME -- CAT3 Opp INIT
--======================================================================================================================================

--CAT3 Listening to chat for your ok
function ESO_MG.C3_FUN_WaitForYouAnswer(eventCode, messageType, sender, message)
	if (messageType == 4) then
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C3WaitForPlayer)then
			if string.lower(message) == string.lower(ESO_MG_CAT3Watch) then
				ESO_MG_C3YouAccepted = 1
				ESO_MG_C3CurrentPlayer = 1
				ESO_MG.C3_buildmenu()
				ESO_MG_C3G_MENU:SetHidden(false)
				EVENT_MANAGER:UnregisterForEvent("C3YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
				--
				--
			elseif string.lower(message) == "no" then
				--do something ^^
			end
		end
	end
end

--CAT3 Countdown to receive answer
function ESO_MG.C3_FUN_WaitForYouAnswerCountDown()
	if(ESO_MG_C3YouAccepted == 0) then
		if(ESO_MG_C3YouCurrAnsCD >= 1)then
			ESO_MG_C3YouCurrAnsCD = ESO_MG_C3YouCurrAnsCD - 1
			zo_callLater(ESO_MG.C3_FUN_WaitForYouAnswerCountDown, 1000)			
		else
			ESO_MG.C3_FUN_WaitForYouAnswerCancel()
		end
	end
end

--Cancel the wait for ok listening
function ESO_MG.C3_FUN_WaitForYouAnswerCancel()
	if(ESO_MG_C3YouAccepted == 0) then
		log("You haven't sent a response in " .. ESO_MG_CAT3InviteTime .. " Seconds. Invite is no longer Valid.")		
		EVENT_MANAGER:UnregisterForEvent("C3YouAnswer", EVENT_CHAT_MESSAGE_CHANNEL)
	end
end

--CAT3 Get the Game Options for CAT3 GAME
function ESO_MG.C3GetGameOptions(options)
	--log("there are no Options to check for this Game.")
	ESO_MG_C3ValidOptions = 1
end

--======================================================================================================================================
-- Additional -- Additional -- Additional -- Additional -- Additional -- Additional -- Additional -- Additional -- Additional -- Additio
--======================================================================================================================================
--Move minimized Games 1 Down if one is opened
function ESO_MG.MoveMinimizedDown(MovedPosition)
	if(ESO_MG_C1GameMaxed == 0 and ESO_MG_C1MinimizedPosition > MovedPosition)then
		ESO_MG_C1_va, ESO_MG_C1_pt, ESO_MG_C1_rt, ESO_MG_C1_rpt, ESO_MG_C1_ox, ESO_MG_C1_oy =  ESO_MG_C1G_MENU:GetAnchor()
		ESO_MG_C1G_MENU:ClearAnchors()
		ESO_MG_C1G_MENU:SetAnchor(ESO_MG_C1_pt, ESO_MG_C1_rt, ESO_MG_C1_rpt, ESO_MG_C1_ox, ESO_MG_C1_oy + 40)
		ESO_MG_C1MinimizedPosition = ESO_MG_C1MinimizedPosition - 1
	end
	if(ESO_MG_C2GameMaxed == 0 and ESO_MG_C2MinimizedPosition > MovedPosition)then
		ESO_MG_C2_va, ESO_MG_C2_pt, ESO_MG_C2_rt, ESO_MG_C2_rpt, ESO_MG_C2_ox, ESO_MG_C2_oy =  ESO_MG_C2G_MENU:GetAnchor()
		ESO_MG_C2G_MENU:ClearAnchors()
		ESO_MG_C2G_MENU:SetAnchor(ESO_MG_C2_pt, ESO_MG_C2_rt, ESO_MG_C2_rpt, ESO_MG_C2_ox, ESO_MG_C2_oy + 40)
		ESO_MG_C2MinimizedPosition = ESO_MG_C2MinimizedPosition - 1
	end
	if(ESO_MG_C3GameMaxed == 0 and ESO_MG_C3MinimizedPosition > MovedPosition)then
		ESO_MG_C3_va, ESO_MG_C3_pt, ESO_MG_C3_rt, ESO_MG_C3_rpt, ESO_MG_C3_ox, ESO_MG_C3_oy =  ESO_MG_C3G_MENU:GetAnchor()
		ESO_MG_C3G_MENU:ClearAnchors()
		ESO_MG_C3G_MENU:SetAnchor(ESO_MG_C3_pt, ESO_MG_C3_rt, ESO_MG_C3_rpt, ESO_MG_C3_ox, ESO_MG_C3_oy + 40)
		ESO_MG_C3MinimizedPosition = ESO_MG_C3MinimizedPosition - 1
	end
	if(ESO_MG_C4GameMaxed == 0 and ESO_MG_C4MinimizedPosition > MovedPosition)then
		ESO_MG_C4_va, ESO_MG_C4_pt, ESO_MG_C4_rt, ESO_MG_C4_rpt, ESO_MG_C4_ox, ESO_MG_C4_oy =  ESO_MG_C4G_MENU:GetAnchor()
		ESO_MG_C4G_MENU:ClearAnchors()
		ESO_MG_C4G_MENU:SetAnchor(ESO_MG_C4_pt, ESO_MG_C4_rt, ESO_MG_C4_rpt, ESO_MG_C4_ox, ESO_MG_C4_oy + 40)
		ESO_MG_C4MinimizedPosition = ESO_MG_C4MinimizedPosition - 1
	end
end

--Play Sound if sounds are enabled
function ESO_MG.Sound(SoundToPlay)
	if(ESO_MG_SoundEnabled == 1)then
		PlaySound(SoundToPlay)
		--PlaySound(SoundToPlay)
	end
end

--Sounds
ESO_MG_SN_Battle1 = "SkillXP_BossKilled"
ESO_MG_SN_Battle2 = "AvA_Gate_Closed"
ESO_MG_SN_Click1 = "Ability_CasterLevitated"
ESO_MG_SN_Click2 = "Ability_Picked_Up"
ESO_MG_SN_ClickSoft1 = "Ability_Click"
ESO_MG_SN_Tick1 = "Countdown_Warning"
ESO_MG_SN_Error1 = "Ability_CasterPacified"
ESO_MG_SN_Error2 = "Ability_NotEnoughMagicka"
ESO_MG_SN_Error3 = "Ability_NotEnoughStamina"
ESO_MG_SN_Error4 = "PlayerAction_NotEnoughMoney"
ESO_MG_SN_ErrorSoft1 = "Ability_Slotted"
ESO_MG_SN_ErrorSoft2 = "Ability_WrongWeapon"
ESO_MG_SN_Pling1 = "Ability_Synergy_Ready_Sound"
ESO_MG_SN_Pling2 = "Ability_Ultimate_Ready_Sound"
ESO_MG_SN_Pling3 = "Achievement_Awarded"
ESO_MG_SN_Schring1 = "Ability_MorphPurchased"
ESO_MG_SN_Schring2 = "DeathRecap_KillingBlowShown"
ESO_MG_SN_Fade1 = "Alchemy_Closed"
ESO_MG_SN_Fade2 = "Click_Racebutton"
ESO_MG_SN_Fade3 = "Click_CC_Selector"
ESO_MG_SN_Scroll1 = "Alchemy_Reagent_Placed"
ESO_MG_SN_Scroll2 = "Alchemy_Reagent_Removed"
ESO_MG_SN_Scroll3 = "AllianceWarWindow_Close"
ESO_MG_SN_Scroll4 = "AllianceWarWindow_Open"
ESO_MG_SN_Blubb1 = "Alchemy_Solvent_Placed"
ESO_MG_SN_Blubb2 = "Alchemy_Solvent_Removed"
ESO_MG_SN_Parry1 = "AvA_Gate_Opened"
ESO_MG_SN_Reminder1 = "Blacksmith_Improve_Tooltip_Glow_Fail"
ESO_MG_SN_Reminder2 = "Clothier_Improve_Tooltip_Glow_Fail"
ESO_MG_SN_Reminder3 = "Book_Acquired"
ESO_MG_SN_Sword1 = "GuildRoster_Added"
ESO_MG_SN_Win1 = "Book_Collection_Completed"
ESO_MG_SN_Win2 = "LevelUp"
ESO_MG_SN_Quit1 = "Skill_Gained"
ESO_MG_SN_Draw1 = "ElderScroll_Captured_Ebonheart"
ESO_MG_SN_Draw2 = "Emperor_Deposed_Ebonheart"
ESO_MG_SN_Lose1 = "Emperor_Coronated_Ebonheart"

--Save Position if Window is moved
function ESO_MG.MainWindowMoved()
	ESO_MG_MAIN_va, ESO_MG_MAIN_pt, ESO_MG_MAIN_rt, ESO_MG_MAIN_rpt, ESO_MG_MAIN_ox, ESO_MG_MAIN_oy =  ESO_MG_MENU:GetAnchor()
	if(ESO_MG_MAIN_va) then
		ESO_MG_SavedData.MainAnchor[1] = ESO_MG_MAIN_pt
		ESO_MG_SavedData.MainAnchor[2] = ESO_MG_MAIN_rt
		ESO_MG_SavedData.MainAnchor[3] = ESO_MG_MAIN_rpt
		ESO_MG_SavedData.MainAnchor[4] = ESO_MG_MAIN_ox
		ESO_MG_SavedData.MainAnchor[5] = ESO_MG_MAIN_oy
	end
end

--Open the Info/Help Window for Games
function ESO_MG.OpenInfo(CurrentGame , HelpText , AnchorWindow)
	ESO_MG.Sound(ESO_MG_SN_Fade3)
	ESO_MG_HI_HEADER:SetText("|c880000" .. CurrentGame .. "|r - |c880000Info / Help")
	ESO_MG_HI_INFOTXT:SetText(HelpText)
	ESO_MG_HI_MENU:ClearAnchors()
	ESO_MG_HI_MENU:SetAnchor(TOPLEFT,AnchorWindow,TOPRIGHT,12,0)
	ESO_MG_HI_MENU:SetHidden(false)
end

--Close the Info/Help Window for Games
function ESO_MG.CloseInfo()
	ESO_MG.Sound(ESO_MG_SN_Click2)
	ESO_MG_HI_MENU:SetHidden(true)
end

--Init CAT1 Settings
function ESO_MG.C1Init()
	ESO_MG_C1BOXMR:SetText("" .. ESO_MG_SavedData.Cat1Settings[1])
	ESO_MG_C1BOXMC:SetText("" .. ESO_MG_SavedData.Cat1Settings[2])
end