--      ___                       ___                       ___           ___           ___           ___           ___     
--     /__/\        ___          /__/\        ___          /  /\         /  /\         /__/\         /  /\         /  /\    
--    |  |::\      /  /\         \  \:\      /  /\        /  /:/_       /  /::\       |  |::\       /  /:/_       /  /:/_   
--    |  |:|:\    /  /:/          \  \:\    /  /:/       /  /:/ /\     /  /:/\:\      |  |:|:\     /  /:/ /\     /  /:/ /\  
--  __|__|:|\:\  /__/::\      _____\__\:\  /__/::\      /  /:/_/::\   /  /:/~/::\   __|__|:|\:\   /  /:/ /:/_   /  /:/ /::\ 
-- /__/::::| \:\ \__\/\:\__  /__/::::::::\ \__\/\:\__  /__/:/__\/\:\ /__/:/ /:/\:\ /__/::::| \:\ /__/:/ /:/ /\ /__/:/ /:/\:\
-- \  \:\~~\__\/    \  \:\/\ \  \:\~~\~~\/    \  \:\/\ \  \:\ /~~/:/ \  \:\/:/__\/ \  \:\~~\__\/ \  \:\/:/ /:/ \  \:\/:/~/:/
--  \  \:\           \__\::/  \  \:\  ~~~      \__\::/  \  \:\  /:/   \  \::/       \  \:\        \  \::/ /:/   \  \::/ /:/ 
--   \  \:\          /__/:/    \  \:\          /__/:/    \  \:\/:/     \  \:\        \  \:\        \  \:\/:/     \__\/ /:/  
--    \  \:\         \__\/      \  \:\         \__\/      \  \::/       \  \:\        \  \:\        \  \::/        /__/:/   
--     \__\/                     \__\/                     \__\/         \__\/         \__\/         \__\/         \__\/    
--=============================================================================================================================
--=============================================================================================================================
--TODO:
--Keep playing after crashing by saving the statuses in Savedvariables (low prio)
--Cancel the Animations when starting a new game
--Replace some Sounds
--Auto activate the Chat on Click like when clicking a button 2 times
--Function to see if you killed one of the opponents Ships
--=============================================================================================================================
--=============================================================================================================================
--All Credit and Copyrights go to (ESO EU) Dero - @Deryl
--I did my best to comment the code for others to learn from it ;)

--Basic Variables
ESO_MG_C3G_MAXWIDTH = 400
ESO_MG_C3G_MAXHEIGHT = 500
ESO_MG_C3G_COLS = 10
ESO_MG_C3G_ROWS = 10
ESO_MG_C3G_DEBUGMODE = 0

--Creation of the Menu
function ESO_MG.C3_buildmenu()
	if (BattleShipMenu == nil) then
		ESO_MG_C3G_GRIDOBJDIM = ESO_MG_SavedData.Cat3GridDim --50 Default
--------------------------------------------------------------------------------------------------------------------------
-- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART --
--------------------------------------------------------------------------------------------------------------------------
		--Basemenu
		ESO_MG_C3G_MENU = WINDOW_MANAGER:CreateTopLevelWindow("BattleShipMenu")
		ESO_MG_C3G_MENU:SetDrawLayer(1)
		ESO_MG_C3G_MENU:SetAnchor(ESO_MG_SavedData.Cat3Anchor[1],ESO_MG_SavedData.Cat3Anchor[2],ESO_MG_SavedData.Cat3Anchor[3],ESO_MG_SavedData.Cat3Anchor[4],ESO_MG_SavedData.Cat3Anchor[5])
		ESO_MG_C3G_MENU:SetDimensions(ESO_MG_C3G_MAXWIDTH,ESO_MG_C3G_MAXHEIGHT)
		ESO_MG_C3G_MENU:SetMouseEnabled(true)
		ESO_MG_C3G_MENU:SetMovable(true)
		ESO_MG_C3G_MENU:SetClampedToScreen(true)
		ESO_MG_C3G_MENU:SetHandler("OnMoveStop",ESO_MG.C3WindowMoved)
		ESO_MG_C3G_MENU_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3G_Back",BattleShipMenu,"ZO_DefaultBackdrop")
		
		--Headertext
		ESO_MG_C3G_HEADER = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_HEADER",BattleShipMenu,CT_LABEL)
		ESO_MG_C3G_HEADER:SetText("|c880000" .. ESO_MG_CAT3Name)
		ESO_MG_C3G_HEADER:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_HEADER:SetAnchor(TOP,BattleShipMenu,TOP,0,0)

		--X-Button to Close the Menu
		ESO_MG_C3G_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_BTNCLOSE",BattleShipMenu,CT_BUTTON)
		ESO_MG_C3G_BTNCLOSE:SetDimensions(20,20)
		ESO_MG_C3G_BTNCLOSE:SetHandler("OnClicked",ESO_MG.C3CloseMenu)
		ESO_MG_C3G_BTNCLOSE:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3G_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_MG_C3G_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_MG_C3G_BTNCLOSE:SetAnchor(TOPRIGHT,BattleShipMenu,TOPRIGHT,0,0)
		
		--_-Button to Show / Hide the Menu
		ESO_MG_C3G_BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_BTNSH",BattleShipMenu,CT_BUTTON)
		ESO_MG_C3G_BTNSH:SetDimensions(20,20)
		ESO_MG_C3G_BTNSH:SetHandler("OnClicked",ESO_MG.C3ShowHideMenu)
		ESO_MG_C3G_BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C3G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C3G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C3G_BTNCLOSE,TOPLEFT,-5,5)
		
		--Info button to Open the Help/Info for the current Game
		ESO_MG_C3G_BTNINFO = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_BTNINFO",BattleShipMenu,CT_BUTTON)
		ESO_MG_C3G_BTNINFO:SetDimensions(25,25)
		ESO_MG_C3G_BTNINFO:SetHandler("OnClicked",ESO_MG.C3OpenInfo)
		ESO_MG_C3G_BTNINFO:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3G_BTNINFO:SetNormalTexture("/esoui/art/help/help_tabicon_tutorial_up.dds")
		ESO_MG_C3G_BTNINFO:SetMouseOverTexture("/esoui/art/help/help_tabicon_tutorial_over.dds")
		ESO_MG_C3G_BTNINFO:SetAnchor(TOPLEFT,BattleShipMenu,TOPLEFT,0,0)
		
		--Zoomtext
		ESO_MG_C3G_ZT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_ZT",ESO_MG_C3G_BTNINFO,CT_LABEL)
		ESO_MG_C3G_ZT:SetText("|c888866Zoom: ")
		ESO_MG_C3G_ZT:SetFont("ZoFontGame")
		ESO_MG_C3G_ZT:SetHorizontalAlignment(2)
		ESO_MG_C3G_ZT:SetWidth(80)
		ESO_MG_C3G_ZT:SetAnchor(LEFT,ESO_MG_C3G_BTNINFO,RIGHT,20,0)
		
		--Zoom - Button
		ESO_MG_C3G_BTNZM = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_BTNZM",ESO_MG_C3G_BTNINFO,CT_BUTTON)
		ESO_MG_C3G_BTNZM:SetDimensions(25,25)
		ESO_MG_C3G_BTNZM:SetHandler("OnClicked",function() if(ESO_MG_C3G_GRIDOBJDIM > 30) then ESO_MG_C3G_GRIDOBJDIM = ESO_MG_C3G_GRIDOBJDIM - 1 ESO_MG_C3G_CZT:SetText("|c888866" .. ESO_MG_C3G_GRIDOBJDIM/10-5) ESO_MG_SavedData.Cat3GridDim = ESO_MG_C3G_GRIDOBJDIM ESO_MG.C3SetGameWindowSize() end end)
		ESO_MG_C3G_BTNZM:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3G_BTNZM:SetNormalTexture("/esoui/art/charactercreate/charactercreate_zoom-_up.dds")
		ESO_MG_C3G_BTNZM:SetMouseOverTexture("/esoui/art/charactercreate/charactercreate_zoom-_over.dds")
		ESO_MG_C3G_BTNZM:SetAnchor(LEFT,ESO_MG_C3G_ZT,RIGHT,10,0)

		--CurrentZoomtext
		ESO_MG_C3G_CZT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CZT",ESO_MG_C3G_BTNINFO,CT_LABEL)
		ESO_MG_C3G_CZT:SetText("|c888866" .. ESO_MG_C3G_GRIDOBJDIM/10-5)
		ESO_MG_C3G_CZT:SetFont("ZoFontGame")
		ESO_MG_C3G_CZT:SetHorizontalAlignment(1)
		ESO_MG_C3G_CZT:SetWidth(30)
		ESO_MG_C3G_CZT:SetAnchor(LEFT,ESO_MG_C3G_BTNZM,RIGHT,0,0)
		
		--Zoom + Button
		ESO_MG_C3G_BTNZP2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_BTNZP2",ESO_MG_C3G_BTNINFO,CT_BUTTON)
		ESO_MG_C3G_BTNZP2:SetDimensions(25,25)
		ESO_MG_C3G_BTNZP2:SetHandler("OnClicked",function() if(ESO_MG_C3G_GRIDOBJDIM < 70) then ESO_MG_C3G_GRIDOBJDIM = ESO_MG_C3G_GRIDOBJDIM + 1 ESO_MG_C3G_CZT:SetText("|c888866" .. ESO_MG_C3G_GRIDOBJDIM/10-5) ESO_MG_SavedData.Cat3GridDim = ESO_MG_C3G_GRIDOBJDIM ESO_MG.C3SetGameWindowSize() end end)
		ESO_MG_C3G_BTNZP2:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C3G_BTNZP2:SetNormalTexture("/esoui/art/charactercreate/charactercreate_zoom+_up.dds")
		ESO_MG_C3G_BTNZP2:SetMouseOverTexture("/esoui/art/charactercreate/charactercreate_zoom+_over.dds")
		ESO_MG_C3G_BTNZP2:SetAnchor(LEFT,ESO_MG_C3G_CZT,RIGHT,0,0)
		
		--Game Container
		ESO_MG_C3G_GAMECONT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_GAMECONT",BattleShipMenu,CT_TEXTURE)
		ESO_MG_C3G_GAMECONT:SetDimensions(0,0)
		ESO_MG_C3G_GAMECONT:SetAnchor(TOPLEFT,BattleShipMenu,TOPLEFT,0,0)
		
		--Player WON text
		ESO_MG_C3G_PWON = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PWON",ESO_MG_C3G_GAMECONT,CT_LABEL)
		ESO_MG_C3G_PWON:SetText("|cff0000PLAYER WON!|r")
		ESO_MG_C3G_PWON:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_PWON:SetHorizontalAlignment(1)
		ESO_MG_C3G_PWON:SetDimensions(ESO_MG_C1G_MAXWIDTH,0)
		ESO_MG_C3G_PWON:SetAnchor(CENTER,ESO_MG_C3G_GAMECONT,CENTER,0,0)

		--Player WON burst 1 - 3
		ESO_MG_C3G_PWB1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PWB1",ESO_MG_C3G_PWON,CT_TEXTURE)
		ESO_MG_C3G_PWB1:SetDimensions(512,512)
		ESO_MG_C3G_PWB1:SetAnchor(CENTER,ESO_MG_C3G_PWON,CENTER,0,0)
		ESO_MG_C3G_PWB1:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C3G_PWB1:SetColor(1,1,1,0.5)
		ESO_MG_C3G_PWB2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PWB2",ESO_MG_C3G_PWON,CT_TEXTURE)
		ESO_MG_C3G_PWB2:SetDimensions(512,512)
		ESO_MG_C3G_PWB2:SetAnchor(CENTER,ESO_MG_C3G_PWON,CENTER,0,0)
		ESO_MG_C3G_PWB2:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C3G_PWB2:SetColor(1,1,1,0.5)
		ESO_MG_C3G_PWB3 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PWB3",ESO_MG_C3G_PWON,CT_TEXTURE)
		ESO_MG_C3G_PWB3:SetDimensions(512,512)
		ESO_MG_C3G_PWB3:SetAnchor(CENTER,ESO_MG_C3G_PWON,CENTER,0,0)
		ESO_MG_C3G_PWB3:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C3G_PWB3:SetColor(1,1,1,0.5)
		
		--Line1
		ESO_MG_C3G_C2L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_C2L1",ESO_MG_C3G_GAMECONT,CT_TEXTURE)
		ESO_MG_C3G_C2L1:SetDimensions(ESO_MG_C3G_MAXWIDTH+10,3)
		ESO_MG_C3G_C2L1:SetAnchor(TOPLEFT,ESO_MG_C3G_GAMECONT,TOPLEFT,-6,30)
		ESO_MG_C3G_C2L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--Match between text
		ESO_MG_C3G_MB = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_MB",ESO_MG_C3G_GAMECONT,CT_LABEL)
		ESO_MG_C3G_MB:SetText("")
		ESO_MG_C3G_MB:SetFont("ZoFontGame")
		ESO_MG_C3G_MB:SetHorizontalAlignment(1)
		ESO_MG_C3G_MB:SetDimensions(ESO_MG_C3G_MAXWIDTH,0)
		ESO_MG_C3G_MB:SetAnchor(TOP,ESO_MG_C3G_GAMECONT,TOP,0,30)
		
		--Line2
		ESO_MG_C3G_C2L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_C2L2",ESO_MG_C3G_GAMECONT,CT_TEXTURE)
		ESO_MG_C3G_C2L2:SetDimensions(ESO_MG_C3G_MAXWIDTH+10,3)
		ESO_MG_C3G_C2L2:SetAnchor(TOPLEFT,ESO_MG_C3G_GAMECONT,TOPLEFT,-6,55)
		ESO_MG_C3G_C2L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--UserVariables
		ESO_MG_C3G_CONT = {}
		ESO_MG_C3G_CONT_BG = {}
		ESO_MG_C3G_COLORS = {"|caa0000","|c008888"}
		ESO_MG_C3G_AT = {}
		ESO_MG_C3G_CN = {}
		ESO_MG_C3G_CL = {}
		ESO_MG_C3G_ROWLETTERS = {"A","B","C","D","E","F","G","H","I","J"}
		ESO_MG_C3G_ROWLETTERSLIST = ESO_MG_C3G_ROWLETTERS
		ESO_MG_C3G_RN = {}
		ESO_MG_C3G_RL = {}
		ESO_MG_C3G_GRIDOBJ = {}
		ESO_MG_C3G_GRIDOBJC = {}
		ESO_MG_C3G_GRIDOBJB = {}
		ESO_MG_AREANAME = {ESO_MG_SELF .. "'s |c888866Area (Your Ships)", ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s |c888866Area (" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s Ships)"}
		--Creating two Fields - ID 1 = Your Field ID 2 = Opponents Field
		for j = 1 , 2 , 1 do

			--Grid Container
			ESO_MG_C3G_CONT[j] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CONT" .. j,ESO_MG_C3G_GAMECONT,CT_TEXTURE)
			ESO_MG_C3G_CONT[j]:SetDimensions(0,0)
			ESO_MG_C3G_CONT[j]:SetAnchor(TOPLEFT,ESO_MG_C3G_GAMECONT,TOPLEFT,30 + (j-1) * (ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM + 60),130)
			ESO_MG_C3G_CONT[j]:SetTexture("/esoui/art/crafting/crafting_alchemy_goodslot.dds")
			ESO_MG_C3G_CONT[j]:SetColor(0.3,0.3,0.5,1) -- ESO_MG_C3G_CONT[j]:SetColor(0.5,0.5,0.3,1)
			ESO_MG_C3G_CONT_BG[j] = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3G_CONT_BG" .. j,ESO_MG_C3G_CONT[j],"ZO_DefaultBackdrop")
			
			--Creating Your / Opponents Area Text
			ESO_MG_C3G_AT[j] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_AT" .. j,ESO_MG_C3G_CONT[j],CT_LABEL)
			ESO_MG_C3G_AT[j]:SetText(ESO_MG_C3G_COLORS[j] .. ESO_MG_AREANAME[j])
			ESO_MG_C3G_AT[j]:SetFont("ZoFontGame")
			ESO_MG_C3G_AT[j]:SetAnchor(TOP,ESO_MG_C3G_CONT[j],TOP,0,-60)
			
			--Creating the Column Numbers
			ESO_MG_C3G_CN[j] = {}
			for i = 0 , ESO_MG_C3G_COLS - 1 , 1 do
				ESO_MG_C3G_CN[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CN" .. j .. i,ESO_MG_C3G_CONT[j],CT_LABEL)
				ESO_MG_C3G_CN[j][i]:SetText("|c888866" .. i )
				ESO_MG_C3G_CN[j][i]:SetFont("ZoFontGame")
				ESO_MG_C3G_CN[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,((ESO_MG_C3G_GRIDOBJDIM/2)-5)+((i)*ESO_MG_C3G_GRIDOBJDIM),-30)
			end
			
			--Creating the Lines between Cols
			ESO_MG_C3G_CL[j] = {}
			for i = 1 , ESO_MG_C3G_COLS -1 , 1 do
				ESO_MG_C3G_CL[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CL" .. j .. i,ESO_MG_C3G_CONT[j],CT_TEXTURE)
				ESO_MG_C3G_CL[j][i]:SetDimensions(3,ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM + 10)
				ESO_MG_C3G_CL[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT, i * ESO_MG_C3G_GRIDOBJDIM,-6)
				ESO_MG_C3G_CL[j][i]:SetTexture("/esoui/art/miscellaneous/window_edge.dds")
			end
			
			--Creating the Rows Letters
			ESO_MG_C3G_RN[j] = {}
			for i = 1 , ESO_MG_C3G_ROWS , 1 do
				ESO_MG_C3G_RN[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RN" .. j .. i,ESO_MG_C3G_CONT[j],CT_LABEL)
				ESO_MG_C3G_RN[j][i]:SetText("|c888866" .. ESO_MG_C3G_ROWLETTERS[i] )
				ESO_MG_C3G_RN[j][i]:SetFont("ZoFontGame")
				ESO_MG_C3G_RN[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,-25,((ESO_MG_C3G_GRIDOBJDIM/2)-10)+((i-1)*ESO_MG_C3G_GRIDOBJDIM))
			end
			
			--Creating the Lines between Rows
			ESO_MG_C3G_RL[j] = {}
			for i = 1 , ESO_MG_C3G_ROWS -1 , 1 do
				ESO_MG_C3G_RL[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RL" .. j .. i,ESO_MG_C3G_CONT[j],CT_TEXTURE)
				ESO_MG_C3G_RL[j][i]:SetDimensions(ESO_MG_C3G_COLS  * ESO_MG_C3G_GRIDOBJDIM + 10 + (ESO_MG_C3G_GRIDOBJDIM / 2),3)
				ESO_MG_C3G_RL[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,-6 - (ESO_MG_C3G_GRIDOBJDIM / 4),i * ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_RL[j][i]:SetTexture("/esoui/art/miscellaneous/centerscreen_topdivider.dds")
			end

			-- Creating the Grid
			ESO_MG_C3G_GRIDOBJ[j] = {}
			ESO_MG_C3G_GRIDOBJC[j] = {}
			ESO_MG_C3G_GRIDOBJB[j] = {}
			for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
				--Grid object for Ships
				ESO_MG_C3G_GRIDOBJ[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_GRIDOBJ" .. j .. i,ESO_MG_C3G_CONT[j],CT_TEXTURE)
				ESO_MG_C3G_GRIDOBJ[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJ[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJ[j][i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_disabled.dds")
				ESO_MG_C3G_GRIDOBJ[j][i]:SetColor(0,0,0,1)

				--Object to set the Texture for Hit
				ESO_MG_C3G_GRIDOBJC[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_GRIDOBJC" .. j .. i,ESO_MG_C3G_CONT[j],CT_TEXTURE)
				ESO_MG_C3G_GRIDOBJC[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJC[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJC[j][i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
				ESO_MG_C3G_GRIDOBJC[j][i]:SetColor(0,0,0,1)
				ESO_MG_C3G_GRIDOBJC[j][i].status = 0 --Status of the GridItem 0 = No Stone, 1 = Opponents Stone, 2 = Your Stone
			
				--Clickable GridObject without texture (Texture to Highlight on Mouseover will be attached)
				ESO_MG_C3G_GRIDOBJB[j][i] = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_GRIDOBJB" .. j .. i,ESO_MG_C3G_CONT[j],CT_BUTTON)
				ESO_MG_C3G_GRIDOBJB[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJB[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
				ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnClicked",function() ESO_MG.C3ClickedItem(i,ESO_MG_C3G_GRIDOBJC[j][i],ESO_MG_C3G_GRIDOBJC[j][i].status) end)			
				ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_GRIDOBJB[j][i],TOPLEFT,0,0) if(ESO_MG_C3G_GRIDOBJC[j][i].status == 0 or ESO_MG_C3G_GRIDOBJC[j][i].status == 5)then ESO_MG_C3G_HL:SetColor(1,1,1,1) else ESO_MG_C3G_HL:SetColor(1,0,0,1) end ESO_MG_C3G_HL:SetHidden(false) end)
				ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseExit",function() ESO_MG_C3G_HL:SetHidden(true) end)
			end
		end

		-- Texture to Highlight on MouseOver
		ESO_MG_C3G_HL = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_HL",ESO_MG_C3G_CONT[1],CT_TEXTURE)
		ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[1],TOPLEFT,0,0)
		ESO_MG_C3G_HL:SetTexture("/esoui/art/buttons/minmax_mouseover.dds")
		ESO_MG_C3G_HL:SetHidden(true)

		--Players turn text
		ESO_MG_C3G_PT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PT",ESO_MG_C3G_CONT[1],CT_LABEL)
		ESO_MG_C3G_PT:SetFont("ZoFontGame")
		ESO_MG_C3G_PT:SetHorizontalAlignment(1)
		ESO_MG_C3G_PT:SetVerticalAlignment(1)
		ESO_MG_C3G_PT:SetDimensions(ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM + 60,50)
		ESO_MG_C3G_PT:SetAnchor(TOP,ESO_MG_C3G_CONT[1],BOTTOM,0,5)

		--Button Quit Game
		ESO_MG_C3G_CG = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CG",ESO_MG_C3G_CONT[1],CT_BUTTON)
		ESO_MG_C3G_CG:SetDimensions(100,25)
		ESO_MG_C3G_CG:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C3WaitForPlayer .. "" .. ESO_MG_C3AccOrRealName .. ESO_MG_CAT3CancelText) end)
		ESO_MG_C3G_CG:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_CG:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_CG:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_CG:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_CG:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_CG:SetAnchor(BOTTOM,ESO_MG_C3G_CONT[1],BOTTOM,-55,80)
		ESO_MG_C3G_CGTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CGTX",ESO_MG_C3G_CG,CT_LABEL)
		ESO_MG_C3G_CGTX:SetText("|c888866Quit Game|r")
		ESO_MG_C3G_CGTX:SetFont("ZoFontGame")
		ESO_MG_C3G_CGTX:SetAnchor(CENTER,ESO_MG_C3G_CG,CENTER,0,0)
		
		--Button Play Again
		ESO_MG_C3G_PA = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PA",ESO_MG_C3G_CONT[1],CT_BUTTON)
		ESO_MG_C3G_PA:SetDimensions(100,25)
		ESO_MG_C3G_PA:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C3WaitForPlayer .. "" .. ESO_MG_C3AccOrRealName .. ESO_MG_CAT3AgainText) end)
		ESO_MG_C3G_PA:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_PA:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_PA:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_PA:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_PA:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_PA:SetAnchor(BOTTOM,ESO_MG_C3G_CONT[1],BOTTOM,55,80)
		ESO_MG_C3G_PATX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PATX",ESO_MG_C3G_PA,CT_LABEL)
		ESO_MG_C3G_PATX:SetText("|c888866Play Again|r")
		ESO_MG_C3G_PATX:SetFont("ZoFontGame")
		ESO_MG_C3G_PATX:SetAnchor(CENTER,ESO_MG_C3G_PA,CENTER,0,0)

		--Key to Symbols Container
		ESO_MG_C3G_LCONT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_LCONT",ESO_MG_C3G_CONT[2],CT_TEXTURE)
		ESO_MG_C3G_LCONT:SetDimensions(ESO_MG_C3G_GRIDOBJDIM*ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM+20)
		ESO_MG_C3G_LCONT:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[2],BOTTOMLEFT,0,20)
		ESO_MG_C3G_LCONT:SetTexture("/esoui/art/crafting/crafting_alchemy_goodslot.dds")
		ESO_MG_C3G_LCONT:SetColor(0.3,0.3,0.5,1)
		ESO_MG_C3G_LCONT_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3G_LCONT_BG",ESO_MG_C3G_LCONT,"ZO_DefaultBackdrop")
		
		--Number of Key Elements and Positions
		ESO_MG_C3KeyElements = 3
		ESO_MG_C3KeyElementsPosi = ((ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS) / ESO_MG_C3KeyElements) / 2
		
		--Key Ship
		ESO_MG_C3G_K1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K1",ESO_MG_C3G_LCONT,CT_TEXTURE)
		ESO_MG_C3G_K1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_K1:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi,0)
		ESO_MG_C3G_K1:SetTexture("/esoui/art/campaign/campaign_tabicon_browser_up.dds")
		ESO_MG_C3G_K1T = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K1T",ESO_MG_C3G_K1,CT_LABEL)
		ESO_MG_C3G_K1T:SetText("|c888866- Ship -")
		ESO_MG_C3G_K1T:SetFont("ZoFontGame")
		ESO_MG_C3G_K1T:SetHorizontalAlignment(1)
		ESO_MG_C3G_K1T:SetAnchor(TOP,ESO_MG_C3G_K1,BOTTOM,0,0)

		--Key Ship Hit
		ESO_MG_C3G_K2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K2",ESO_MG_C3G_LCONT,CT_TEXTURE)
		ESO_MG_C3G_K2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_K2:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi * 3,0)
		ESO_MG_C3G_K2:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_hardcore_up.dds")
		ESO_MG_C3G_K21 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K21",ESO_MG_C3G_K2,CT_TEXTURE)
		ESO_MG_C3G_K21:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_K21:SetAnchor(TOPLEFT,ESO_MG_C3G_K2,TOPLEFT,0,0)
		ESO_MG_C3G_K21:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_normal_up.dds")
		ESO_MG_C3G_K2T = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K2T",ESO_MG_C3G_K2,CT_LABEL)
		ESO_MG_C3G_K2T:SetText("|c888866- Hit Ship -")
		ESO_MG_C3G_K2T:SetFont("ZoFontGame")
		ESO_MG_C3G_K2T:SetHorizontalAlignment(1)
		ESO_MG_C3G_K2T:SetAnchor(TOP,ESO_MG_C3G_K2,BOTTOM,0,0)

		--Key Water Hit
		ESO_MG_C3G_K3 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K3",ESO_MG_C3G_LCONT,CT_TEXTURE)
		ESO_MG_C3G_K3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_K3:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi * 5,0)
		ESO_MG_C3G_K3:SetTexture("/esoui/art/campaign/overview_indexicon_scoring_over.dds")
		ESO_MG_C3G_K3T = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_K3T",ESO_MG_C3G_K3,CT_LABEL)
		ESO_MG_C3G_K3T:SetText("|c888866- Hit Water -")
		ESO_MG_C3G_K3T:SetFont("ZoFontGame")
		ESO_MG_C3G_K3T:SetHorizontalAlignment(1)
		ESO_MG_C3G_K3T:SetAnchor(TOP,ESO_MG_C3G_K3,BOTTOM,0,0)

		--Place Ship Container
		ESO_MG_C3G_SCONT = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SCONT",ESO_MG_C3G_GAMECONT,CT_TEXTURE)
		ESO_MG_C3G_SCONT:SetDimensions(0,0)
		ESO_MG_C3G_SCONT:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[1],TOPRIGHT,60,0)
		ESO_MG_C3G_SCONT:SetTexture("/esoui/art/crafting/crafting_alchemy_goodslot.dds")
		ESO_MG_C3G_SCONT:SetColor(0.3,0.3,0.5,1) -- ESO_MG_C3G_CONT[j]:SetColor(0.5,0.5,0.3,1)
		ESO_MG_C3G_SCONT_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C3G_SCONT_BG",ESO_MG_C3G_SCONT,"ZO_DefaultBackdrop")
		
		--Ship Selector Text
		ESO_MG_C3G_PSTXH = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PSTXH",ESO_MG_C3G_SCONT,CT_LABEL)
		ESO_MG_C3G_PSTXH:SetText("|c888866Ship selector")
		ESO_MG_C3G_PSTXH:SetFont("ZoFontGame")
		ESO_MG_C3G_PSTXH:SetAnchor(TOP,ESO_MG_C3G_SCONT,TOP,0,-60)

		--Place Your Ships Text
		ESO_MG_C3G_PSTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PSTX",ESO_MG_C3G_SCONT,CT_LABEL)
		ESO_MG_C3G_PSTX:SetText("|c888866- Select your Ships to place -")
		ESO_MG_C3G_PSTX:SetFont("ZoFontGame")
		ESO_MG_C3G_PSTX:SetVerticalAlignment(1)
		ESO_MG_C3G_PSTX:SetHorizontalAlignment(1)
		ESO_MG_C3G_PSTX:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_PSTX:SetAnchor(TOP,ESO_MG_C3G_SCONT,TOP,0,0)

		--Line1
		ESO_MG_C3G_PSL1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PSL1",ESO_MG_C3G_SCONT,CT_TEXTURE)
		ESO_MG_C3G_PSL1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
		ESO_MG_C3G_PSL1:SetAnchor(TOP,ESO_MG_C3G_PSTX,BOTTOM,0,0)
		ESO_MG_C3G_PSL1:SetTexture("/esoui/art/progression/ability_line.dds")

		--Number of Ships
		ESO_MG_C3NumShips = 5
		
		--Ship1 (length 5)
		ESO_MG_C3Ship1Length = 5
		ESO_MG_C3G_SHIP1 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SHIP1",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SHIP1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship1Length,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_SHIP1.ShipOffset = "X1"
		ESO_MG_C3G_SHIP1:SetHandler("OnClicked",function() ESO_MG_C3PlacedShipItems = {} ESO_MG_C3NewShip = true ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3Ship1Length,ESO_MG_C3G_SHIP1,ESO_MG_C3G_SHIP1.ShipOffset) end)
		ESO_MG_C3G_SHIP1:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SHIP1:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SHIP1:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_SHIP1:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_SHIP1:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_SHIP1.Ships = ""
		ESO_MG_C3G_SHIP1:SetAnchor(TOP,ESO_MG_C3G_PSL1,BOTTOM,0,10)
		--Ship 1 Text
		ESO_MG_C3G_S1TX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S1TX",ESO_MG_C3G_SHIP1,CT_LABEL)
		ESO_MG_C3G_S1TX:SetText("|c888866Aircraft Carrier")
		ESO_MG_C3G_S1TX:SetFont("ZoFontGame")
		ESO_MG_C3G_S1TX:SetAnchor(CENTER,ESO_MG_C3G_SHIP1,CENTER,0,0)
		--Ship 1 Text XxX
		ESO_MG_C3G_S1TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S1TX2",ESO_MG_C3G_SHIP1,CT_LABEL)
		ESO_MG_C3G_S1TX2:SetText("|c8888661x" .. ESO_MG_C3Ship1Length)
		ESO_MG_C3G_S1TX2:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_S1TX2:SetAnchor(LEFT,ESO_MG_C3G_SHIP1,LEFT,-50,0)

		--Ship2 (length 4)
		ESO_MG_C3Ship2Length = 4
		ESO_MG_C3G_SHIP2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SHIP2",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SHIP2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship2Length,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_SHIP2.ShipOffset = "X2"
		ESO_MG_C3G_SHIP2:SetHandler("OnClicked",function() ESO_MG_C3PlacedShipItems = {} ESO_MG_C3NewShip = true ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3Ship2Length,ESO_MG_C3G_SHIP2,ESO_MG_C3G_SHIP2.ShipOffset) end)
		ESO_MG_C3G_SHIP2:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SHIP2:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SHIP2:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_SHIP2:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_SHIP2:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_SHIP2.Ships = ""
		ESO_MG_C3G_SHIP2:SetAnchor(TOP,ESO_MG_C3G_SHIP1,BOTTOM,0,0)
		--Ship 2 Text
		ESO_MG_C3G_S2TX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S2TX",ESO_MG_C3G_SHIP2,CT_LABEL)
		ESO_MG_C3G_S2TX:SetText("|c888866Battleship")
		ESO_MG_C3G_S2TX:SetFont("ZoFontGame")
		ESO_MG_C3G_S2TX:SetAnchor(CENTER,ESO_MG_C3G_SHIP2,CENTER,0,0)
		--Ship 2 Text XxX
		ESO_MG_C3G_S2TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S2TX2",ESO_MG_C3G_SHIP2,CT_LABEL)
		ESO_MG_C3G_S2TX2:SetText("|c8888661x" .. ESO_MG_C3Ship2Length)
		ESO_MG_C3G_S2TX2:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_S2TX2:SetAnchor(LEFT,ESO_MG_C3G_SHIP2,LEFT,-50,0)

		--Ship3 (length 3)
		ESO_MG_C3Ship3Length = 3
		ESO_MG_C3G_SHIP3 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SHIP3",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SHIP3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship3Length,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_SHIP3.ShipOffset = "X3"
		ESO_MG_C3G_SHIP3:SetHandler("OnClicked",function() ESO_MG_C3PlacedShipItems = {} ESO_MG_C3NewShip = true ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3Ship3Length,ESO_MG_C3G_SHIP3,ESO_MG_C3G_SHIP3.ShipOffset) end)
		ESO_MG_C3G_SHIP3:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SHIP3:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SHIP3:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_SHIP3:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_SHIP3:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_SHIP3.Ships = ""
		ESO_MG_C3G_SHIP3:SetAnchor(TOP,ESO_MG_C3G_SHIP2,BOTTOM,0,0)
		--Ship 3 Text
		ESO_MG_C3G_S3TX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S3TX",ESO_MG_C3G_SHIP3,CT_LABEL)
		ESO_MG_C3G_S3TX:SetText("|c888866Destroyer 1")
		ESO_MG_C3G_S3TX:SetFont("ZoFontGame")
		ESO_MG_C3G_S3TX:SetAnchor(CENTER,ESO_MG_C3G_SHIP3,CENTER,0,0)
		--Ship 3 Text XxX
		ESO_MG_C3G_S3TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S3TX2",ESO_MG_C3G_SHIP3,CT_LABEL)
		ESO_MG_C3G_S3TX2:SetText("|c8888661x" .. ESO_MG_C3Ship3Length)
		ESO_MG_C3G_S3TX2:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_S3TX2:SetAnchor(LEFT,ESO_MG_C3G_SHIP3,LEFT,-50,0)
		
		--Ship4 (length 3)
		ESO_MG_C3Ship4Length = 3
		ESO_MG_C3G_SHIP4 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SHIP4",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SHIP4:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship4Length,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_SHIP4.ShipOffset = "X4"
		ESO_MG_C3G_SHIP4:SetHandler("OnClicked",function() ESO_MG_C3PlacedShipItems = {} ESO_MG_C3NewShip = true ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3Ship4Length,ESO_MG_C3G_SHIP4,ESO_MG_C3G_SHIP4.ShipOffset) end)
		ESO_MG_C3G_SHIP4:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SHIP4:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SHIP4:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_SHIP4:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_SHIP4:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_SHIP4.Ships = ""
		ESO_MG_C3G_SHIP4:SetAnchor(TOP,ESO_MG_C3G_SHIP3,BOTTOM,0,0)
		--Ship 4 Text
		ESO_MG_C3G_S4TX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S4TX",ESO_MG_C3G_SHIP4,CT_LABEL)
		ESO_MG_C3G_S4TX:SetText("|c888866Destroyer 2")
		ESO_MG_C3G_S4TX:SetFont("ZoFontGame")
		ESO_MG_C3G_S4TX:SetAnchor(CENTER,ESO_MG_C3G_SHIP4,CENTER,0,0)
		--Ship 4 Text XxX
		ESO_MG_C3G_S4TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S4TX2",ESO_MG_C3G_SHIP4,CT_LABEL)
		ESO_MG_C3G_S4TX2:SetText("|c8888661x" .. ESO_MG_C3Ship4Length)
		ESO_MG_C3G_S4TX2:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_S4TX2:SetAnchor(LEFT,ESO_MG_C3G_SHIP4,LEFT,-50,0)
		
		--Ship5 (length 2)
		ESO_MG_C3Ship5Length = 2
		ESO_MG_C3G_SHIP5 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SHIP5",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SHIP5:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship5Length,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_SHIP5.ShipOffset = "X5"
		ESO_MG_C3G_SHIP5:SetHandler("OnClicked",function() ESO_MG_C3PlacedShipItems = {} ESO_MG_C3NewShip = true ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3Ship5Length,ESO_MG_C3G_SHIP5,ESO_MG_C3G_SHIP5.ShipOffset) end)
		ESO_MG_C3G_SHIP5:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SHIP5:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SHIP5:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_SHIP5:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_SHIP5:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_SHIP5.Ships = ""
		ESO_MG_C3G_SHIP5:SetAnchor(TOP,ESO_MG_C3G_SHIP4,BOTTOM,0,0)
		--Ship 5 Text
		ESO_MG_C3G_S5TX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S5TX",ESO_MG_C3G_SHIP5,CT_LABEL)
		ESO_MG_C3G_S5TX:SetText("|c888866U-Boat")
		ESO_MG_C3G_S5TX:SetFont("ZoFontGame")
		ESO_MG_C3G_S5TX:SetAnchor(CENTER,ESO_MG_C3G_SHIP5,CENTER,0,0)
		--Ship 5 Text XxX
		ESO_MG_C3G_S5TX2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_S5TX2",ESO_MG_C3G_SHIP5,CT_LABEL)
		ESO_MG_C3G_S5TX2:SetText("|c8888661x" .. ESO_MG_C3Ship5Length)
		ESO_MG_C3G_S5TX2:SetFont("ZoFontTooltipTitle")
		ESO_MG_C3G_S5TX2:SetAnchor(LEFT,ESO_MG_C3G_SHIP5,LEFT,-50,0)
		
		--Length of all Ships
		ESO_MG_C3AllShipsLen = ESO_MG_C3Ship1Length + ESO_MG_C3Ship2Length + ESO_MG_C3Ship3Length + ESO_MG_C3Ship4Length + ESO_MG_C3Ship5Length

		--Change Rotation Button
		ESO_MG_C3G_SCR = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SCR",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_SCR:SetDimensions(ESO_MG_C3G_GRIDOBJDIM+20,ESO_MG_C3G_GRIDOBJDIM+20)
		ESO_MG_C3G_SCR:SetHandler("OnClicked",function() if(ESO_MG_C3ShipRotation == 1)then ESO_MG_C3ShipRotation = 0 ESO_MG_C3G_SCRTXH:SetText("|c444422Horizontal") ESO_MG_C3G_SCRTXV:SetText("|c888866Vertical") else 	ESO_MG_C3ShipRotation = 1 ESO_MG_C3G_SCRTXH:SetText("|c888866Horizontal") ESO_MG_C3G_SCRTXV:SetText("|c444422Vertical") end end)
		ESO_MG_C3G_SCR:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_SCR:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_SCR:SetNormalTexture("ESOUI/art/characterwindow/weaponswap_up.dds")
		ESO_MG_C3G_SCR:SetMouseOverTexture("ESOUI/art/characterwindow/weaponswap_over.dds")
		ESO_MG_C3G_SCR:SetDisabledTexture("ESOUI/art/characterwindow/weaponswap_disabled.dds")
		ESO_MG_C3G_SCR:SetAnchor(TOP,ESO_MG_C3G_SHIP5,BOTTOM,0,0)

		--Horizontal Text
		ESO_MG_C3G_SCRTXH = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SCRTXH",ESO_MG_C3G_SCR,CT_LABEL)
		ESO_MG_C3G_SCRTXH:SetText("|c888866Horizontal")
		ESO_MG_C3G_SCRTXH:SetFont("ZoFontGame")
		ESO_MG_C3G_SCRTXH:SetAnchor(TOPLEFT,ESO_MG_C3G_SCR,TOPLEFT,-60,5)
		
		--Vertical Text
		ESO_MG_C3G_SCRTXV = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_SCRTXV",ESO_MG_C3G_SCR,CT_LABEL)
		ESO_MG_C3G_SCRTXV:SetText("|c444422Vertical")
		ESO_MG_C3G_SCRTXV:SetFont("ZoFontGame")
		ESO_MG_C3G_SCRTXV:SetAnchor(BOTTOMLEFT,ESO_MG_C3G_SCR,BOTTOMLEFT,-60,-5)

		--Line2
		ESO_MG_C3G_PSL2 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PSL2",ESO_MG_C3G_SCONT,CT_TEXTURE)
		ESO_MG_C3G_PSL2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
		ESO_MG_C3G_PSL2:SetAnchor(TOP,ESO_MG_C3G_SCR,BOTTOM,0,0)
		ESO_MG_C3G_PSL2:SetTexture("/esoui/art/progression/ability_line.dds")

		--Ready / Replace Ships
		ESO_MG_C3G_CRTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_CRTX",ESO_MG_C3G_SCONT,CT_LABEL)
		ESO_MG_C3G_CRTX:SetText("|c888866- Get Ready / Replace All Ships -")
		ESO_MG_C3G_CRTX:SetFont("ZoFontGame")
		ESO_MG_C3G_CRTX:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM)
		ESO_MG_C3G_CRTX:SetVerticalAlignment(1)
		ESO_MG_C3G_CRTX:SetHorizontalAlignment(1)
		ESO_MG_C3G_CRTX:SetAnchor(TOP,ESO_MG_C3G_PSL2,BOTTOM,0,0)

		--Line3
		ESO_MG_C3G_PSL3 = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_PSL3",ESO_MG_C3G_SCONT,CT_TEXTURE)
		ESO_MG_C3G_PSL3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
		ESO_MG_C3G_PSL3:SetAnchor(TOP,ESO_MG_C3G_CRTX,BOTTOM,0,0)
		ESO_MG_C3G_PSL3:SetTexture("/esoui/art/progression/ability_line.dds")

		--Position for Buttons
		ESO_MG_C3ButtonPosi = ((ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS) / 2) / 2

		--Replace Ships Button
		ESO_MG_C3G_RSHIP = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RSHIP",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_RSHIP:SetDimensions(200,25)
		ESO_MG_C3G_RSHIP:SetHandler("OnClicked",function() ESO_MG.C3ReplaceAllShips() end)
		ESO_MG_C3G_RSHIP:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_RSHIP:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_RSHIP:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_RSHIP:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_RSHIP:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_RSHIP:SetAnchor(TOP,ESO_MG_C3G_PSL3,BOTTOMLEFT,ESO_MG_C3ButtonPosi*3,ESO_MG_C3G_GRIDOBJDIM-30)
		--Replace Ships Text
		ESO_MG_C3G_RSHIPTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RSHIPTX",ESO_MG_C3G_RSHIP,CT_LABEL)
		ESO_MG_C3G_RSHIPTX:SetText("|c880000Replace Ships")
		ESO_MG_C3G_RSHIPTX:SetFont("ZoFontGame")
		ESO_MG_C3G_RSHIPTX:SetAnchor(CENTER,ESO_MG_C3G_RSHIP,CENTER,0,0)
		
		--Ready Button
		ESO_MG_C3G_RDY = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RDY",ESO_MG_C3G_SCONT,CT_BUTTON)
		ESO_MG_C3G_RDY:SetDimensions(200,50)
		ESO_MG_C3G_RDY:SetHandler("OnClicked",function() ESO_MG.C3GenerateReadyText() end)
		ESO_MG_C3G_RDY:SetHandler("OnMouseEnter",function() if(ESO_MG_C3G_RDY:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C3G_RDY:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C3G_RDY:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C3G_RDY:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C3G_RDY:SetAnchor(TOP,ESO_MG_C3G_PSL3,BOTTOMLEFT,ESO_MG_C3ButtonPosi,ESO_MG_C3G_GRIDOBJDIM-30)
		--Ready Text
		ESO_MG_C3G_RDYTX = WINDOW_MANAGER:CreateControl("ESO_MG_C3G_RDYTX",ESO_MG_C3G_RDY,CT_LABEL)
		ESO_MG_C3G_RDYTX:SetText("|c888866Ready")
		ESO_MG_C3G_RDYTX:SetFont("ZoFontGame")
		ESO_MG_C3G_RDYTX:SetAnchor(CENTER,ESO_MG_C3G_RDY,CENTER,0,0)
	end
	
	ESO_MG_C3G_MENU:SetHidden(true)
	ESO_MG.C3InitGame()
end

--Get the Ready string, code it and prepare Chat
function ESO_MG.C3GenerateReadyText()
	--Reset all GridButton functions to wait for Player until ready
	ESO_MG_C3G_HL:SetColor(1,0,0,1)
	for j = 1 , 2 , 1 do
		for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Error1) log("Please send your GameCode by pressing 'Ready' and hitting [ENTER] afterwards and then wait for " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " to get ready!") end)
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_GRIDOBJB[j][i],TOPLEFT,0,0) ESO_MG_C3G_HL:SetHidden(false) end)
		end
	end
	--Set the correct Dimensions for the Hover
	ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	
	ESO_MG_C3G_RSHIP:SetEnabled(false)
	ESO_MG_C3G_SCR:SetEnabled(false)
	ESO_MG_C3EncodeText = ""
	ESO_MG_C3EncodeText = ESO_MG_C3G_SHIP5.Ships .. ESO_MG_C3G_SHIP4.Ships .. ESO_MG_C3G_SHIP3.Ships .. ESO_MG_C3G_SHIP2.Ships .. ESO_MG_C3G_SHIP1.Ships
	EncodedString = ESO_MG.Encode(ESO_MG_C3EncodeText)
	if(string.len(EncodedString) == ESO_MG_C3AllShipsLen*4 + ESO_MG_C3NumShips*4)then
		CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C3WaitForPlayer .. "" .. ESO_MG_C3AccOrRealName .. ESO_MG_CAT3ReadyText .. " " .. EncodedString)
		log("Your GameCode has been prepared in Chat.\n|cff0000DO NOT Change anything within this Text!|r\nPlease send the GameCode by pressing [ENTER].")
	else
		log("Your encoded Ship positions are not Valid. Please replace your Ships and try again")
		ESO_MG.C3ReplaceAllShips()
	end
end

--Check if All Ships are placed and if so enable the ready button
function ESO_MG.C3AllShipsPlaced()
	if(ESO_MG_C3G_SHIP5:GetState() == 2 and ESO_MG_C3G_SHIP4:GetState() == 2 and ESO_MG_C3G_SHIP3:GetState() == 2 and ESO_MG_C3G_SHIP2:GetState() == 2 and ESO_MG_C3G_SHIP1:GetState() == 2)then
		ESO_MG_C3G_RDY:SetEnabled(true)
	end
end

--Replace all Ships
function ESO_MG.C3ReplaceAllShips()
	for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
		ESO_MG_C3G_GRIDOBJC[1][i].status = 0
	end
	ESO_MG.C3SetTextures()
	ESO_MG_C3G_SHIP1:SetEnabled(true)
	ESO_MG_C3G_SHIP2:SetEnabled(true)
	ESO_MG_C3G_SHIP3:SetEnabled(true)
	ESO_MG_C3G_SHIP4:SetEnabled(true)
	ESO_MG_C3G_SHIP5:SetEnabled(true)
	ESO_MG_C3G_RDY:SetEnabled(false)
	ESO_MG_C3G_RSHIP:SetEnabled(true)
end

--Reset the ButtonHover and Click depending on ShipLength
function ESO_MG.C3ResetButtonHoverAndClick(ESO_MG_C3ShipLength,ShipButton,ShipOffset)
	ESO_MG_C3PlaceShipLength = ESO_MG_C3ShipLength
	
	for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
		ESO_MG_C3G_GRIDOBJB[1][i]:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Error1) log("The selected Ship doesn't fits here. Please select another Spot!") end)
		ESO_MG_C3G_GRIDOBJB[1][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG.C3ResetHoverHighlighter(i,ESO_MG_C3G_GRIDOBJC[1][i],ESO_MG_C3PlaceShipLength,ShipButton,ShipOffset) ESO_MG_C3G_HL:SetHidden(false) end)
	end
end

--Reset the HoverHighlighter and Click if Status is okay depending on Position and ShipLength
function ESO_MG.C3ResetHoverHighlighter(item, box, shiplength, ShipButton, ShipOffset)
	ESO_MG_C3AllFreeToPlace = true
	FirstInCol = (math.ceil(item / ESO_MG_C3G_ROWS)-1) * ESO_MG_C3G_ROWS + 1
	if(ESO_MG_C3ShipRotation == 0)then
		if(item <= FirstInCol + ESO_MG_C3G_ROWS - shiplength)then
			for i = 1 , shiplength , 1 do
				if(ESO_MG_C3G_GRIDOBJC[1][item + i - 1].status ~= 0 )then
					ESO_MG_C3AllFreeToPlace = false
					break
				end
			end
			if(ESO_MG_C3AllFreeToPlace == true)then
				ESO_MG_C3G_HL:SetColor(1,1,1,1)
				--Set the Button to be able to be clicked
				ESO_MG_C3G_GRIDOBJB[1][item]:SetHandler("OnClicked",function() ESO_MG.C3PlaceShip(item,shiplength,ShipButton,ShipOffset) end)
			else
				ESO_MG_C3G_HL:SetColor(1,0,0,1)
			end
			ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM , (ESO_MG_C3G_GRIDOBJDIM + 10) * shiplength)
			ESO_MG_C3G_HL:SetAnchor(TOPLEFT,box,TOPLEFT,0,-5*shiplength)
		else
			ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM , ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_HL:SetAnchor(TOPLEFT,box,TOPLEFT,0,0)
			ESO_MG_C3G_HL:SetColor(1,0,0,1)
		end
	elseif(ESO_MG_C3ShipRotation == 1)then
		CurrentCol = math.ceil(item / ESO_MG_C3G_COLS)
		if(CurrentCol <= ESO_MG_C3G_COLS - shiplength + 1)then
			for i = 1 , shiplength , 1 do
				if(ESO_MG_C3G_GRIDOBJC[1][item + (i - 1) * ESO_MG_C3G_ROWS].status ~= 0 )then
					ESO_MG_C3AllFreeToPlace = false
					break
				end
			end
			if(ESO_MG_C3AllFreeToPlace == true)then
				ESO_MG_C3G_HL:SetColor(1,1,1,1)
				--Set the Button to be able to be clicked
				ESO_MG_C3G_GRIDOBJB[1][item]:SetHandler("OnClicked",function() ESO_MG.C3PlaceShip(item,shiplength,ShipButton,ShipOffset) end)
			else
				ESO_MG_C3G_HL:SetColor(1,0,0,1)
			end
			ESO_MG_C3G_HL:SetDimensions((ESO_MG_C3G_GRIDOBJDIM + 10) * shiplength , ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_HL:SetAnchor(TOPLEFT,box,TOPLEFT,-5*shiplength,0)
		else
			ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM , ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_HL:SetAnchor(TOPLEFT,box,TOPLEFT,0,0)
			ESO_MG_C3G_HL:SetColor(1,0,0,1)
		end
	end
end

--Place the selected Ship
function ESO_MG.C3PlaceShip(StartPoint,shiplength,ShipButton,ShipOffset)
	ESO_MG_C3ShipsText = ""
	if(ESO_MG_C3NewShip == false)then
		for i = 1 , table.getn(ESO_MG_C3PlacedShipItems),1 do
			ESO_MG_C3G_GRIDOBJC[1][ESO_MG_C3PlacedShipItems[i]].status = 0
		end
		ESO_MG_C3PlacedShipItems = {}
	end

	if(ESO_MG_C3ShipRotation == 0)then
		for i = 1 , shiplength , 1 do
			ESO_MG_C3G_GRIDOBJC[1][StartPoint + i - 1].status = 3
			ESO_MG_C3PlacedShipItems[i] = StartPoint + i - 1
			ESO_MG_C3ColumnClicked = math.ceil((StartPoint + i - 1) / ESO_MG_C3G_COLS) - 1
			ESO_MG_C3RowClicked = (StartPoint + i - 1) - ESO_MG_C3ColumnClicked * ESO_MG_C3G_COLS
			ESO_MG_C3ShipsText = ESO_MG_C3ShipsText .. ESO_MG_C3G_ROWLETTERS[ESO_MG_C3RowClicked] .. ESO_MG_C3ColumnClicked
		end
		ESO_MG.Sound(ESO_MG_SN_Blubb1)
		ESO_MG_C3NewShip = false
		ShipButton.Ships = ShipOffset .. ESO_MG_C3ShipsText
		ShipButton:SetEnabled(false)
	elseif(ESO_MG_C3ShipRotation == 1)then
		for i = 1 , shiplength , 1 do
			ESO_MG_C3G_GRIDOBJC[1][StartPoint + (i - 1) * ESO_MG_C3G_ROWS].status = 3
			ESO_MG_C3PlacedShipItems[i] = StartPoint + (i - 1) * ESO_MG_C3G_ROWS
			ESO_MG_C3ColumnClicked = math.ceil((StartPoint + (i - 1) * ESO_MG_C3G_ROWS) / ESO_MG_C3G_COLS) - 1
			ESO_MG_C3RowClicked = (StartPoint + (i - 1) * ESO_MG_C3G_ROWS) - ESO_MG_C3ColumnClicked * ESO_MG_C3G_COLS
			ESO_MG_C3ShipsText = ESO_MG_C3ShipsText .. ESO_MG_C3G_ROWLETTERS[ESO_MG_C3RowClicked] .. ESO_MG_C3ColumnClicked
		end
		ESO_MG.Sound(ESO_MG_SN_Blubb1)
		ESO_MG_C3NewShip = false
		ShipButton.Ships = ShipOffset .. ESO_MG_C3ShipsText
		ShipButton:SetEnabled(false)
	end
	ESO_MG.C3AllShipsPlaced()
	ESO_MG.C3SetTextures()
end

--Save Position if Window is moved
function ESO_MG.C3WindowMoved()
	ESO_MG_C3G_va, ESO_MG_C3G_pt, ESO_MG_C3G_rt, ESO_MG_C3G_rpt, ESO_MG_C3G_ox, ESO_MG_C3G_oy =  ESO_MG_C3G_MENU:GetAnchor()
	if(ESO_MG_C3G_va) then
		ESO_MG_SavedData.Cat3Anchor[1] = ESO_MG_C3G_pt
		ESO_MG_SavedData.Cat3Anchor[2] = ESO_MG_C3G_rt
		ESO_MG_SavedData.Cat3Anchor[3] = ESO_MG_C3G_rpt
		ESO_MG_SavedData.Cat3Anchor[4] = ESO_MG_C3G_ox
		ESO_MG_SavedData.Cat3Anchor[5] = ESO_MG_C3G_oy
	end
end

--Initialize the Game
function ESO_MG.C3InitGame()
	--Play the StartGame Sound
	ESO_MG.Sound(ESO_MG_SN_Battle1)

	--Sets the Game Status
	ESO_MG_C3GameEnded = 0
	if(ESO_MG_C3GameMaxed == nil)then
		ESO_MG_C3GameMaxed = 1
	end
	ESO_MG_C3Running = 1
	ESO_MG_C3YouAgain = 0
	ESO_MG_C3OppAgain = 0
	ESO_MG_C3YouReady = 0
	ESO_MG_C3OppReady = 0
	ESO_MG_C3ShipRotation = 1
	
	--Set the ButtonStates for ShipPlacing
	ESO_MG_C3G_SHIP1:SetEnabled(true)
	ESO_MG_C3G_SHIP2:SetEnabled(true)
	ESO_MG_C3G_SHIP3:SetEnabled(true)
	ESO_MG_C3G_SHIP4:SetEnabled(true)
	ESO_MG_C3G_SHIP5:SetEnabled(true)
	ESO_MG_C3G_RDY:SetEnabled(false)
	ESO_MG_C3G_RSHIP:SetEnabled(true)
	ESO_MG_C3G_SCR:SetEnabled(true)
	
	--Reset all GridButton functions to place Ships
	ESO_MG_C3G_HL:SetColor(1,0,0,1)
	for j = 1 , 2 , 1 do
		for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Error1) log("Please select a Ship to place!") end)
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_GRIDOBJB[j][i],TOPLEFT,0,0) ESO_MG_C3G_HL:SetHidden(false) end)
		end
	end
	
	--Hide GridContainer2 until Ships are places
	ESO_MG_C3G_CONT[2]:SetHidden(true)
	
	--Show the Place Ships Container until Ships are places
	ESO_MG_C3G_SCONT:SetHidden(false)
	
	--Update the texts with PlayerNames in it
	ESO_MG_C3G_MB:SetText("|c888866Player 1: |c008888" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "|r - |c888866Player 2: |caa0000" .. ESO_MG_SELF)
	
	--Hide the Winner Text
	ESO_MG_C3G_PWON:SetHidden(true)

	--Register the wait for Command Event
	EVENT_MANAGER:RegisterForEvent("C3WaitPlayerReady", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3PlayerReady)
	
	--Resets the PlayGrid
	ESO_MG.C3ResetGame()
	
	--Sets the Window Dimensions depending on PlayGrid
	ESO_MG.C3SetGameWindowSize()
	
	--Unregister Events you Dont need anymore
	EVENT_MANAGER:UnregisterForEvent("C3WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL)
	EVENT_MANAGER:UnregisterForEvent("C3WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL)
	
	--Disable the Play Again button
	ESO_MG_C3G_PA:SetEnabled(false)
	ESO_MG_C3G_PATX:SetText("|c666666Play Again|r")

	--Enable the Quit Game Button
	ESO_MG_C3G_CG:SetEnabled(true)
	ESO_MG_C3G_CGTX:SetText("|c888866Quit Game|r")
end

--Check the TellChat for ESO_MG_CAT3AgainText after game ended
function ESO_MG.C3PlayAgain(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C3WaitForPlayer)) then
			if(string.lower(message) == string.lower(ESO_MG_CAT3AgainText)) then
				ESO_MG_C3OppAgain = 1
				ESO_MG.Sound(ESO_MG_SN_Reminder3)
				ESO_MG_C3G_PT:SetText(ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866wants to Play again!")
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C3WaitForPlayer)then
			if(string.lower(message) == string.lower(ESO_MG_CAT3AgainText))then
				ESO_MG_C3YouAgain = 1
			end
		end
	end
	if(ESO_MG_C3OppAgain == 1 and ESO_MG_C3YouAgain == 1)then
		ESO_MG.C3InitGame()
	end
end

--Check the TellChat for ESO_MG_CAT3ReadyText and check Options
function ESO_MG.C3PlayerReady(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if(ESO_MG_C3OppReady == 0)then
			if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C3WaitForPlayer)) then
				if(string.find(string.lower(message), string.lower(ESO_MG_CAT3ReadyText)) ~= nil) then
					ValidShipPositions = ESO_MG.C3GetEncodedShipPosition(message,messageType)
					if(ValidShipPositions == true)then
						ESO_MG_C3OppReady = 1
						ESO_MG.Sound(ESO_MG_SN_Reminder3)
						ESO_MG_C3G_PT:SetText(ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866is Ready!")
					else
						ESO_MG.Sound(ESO_MG_SN_Error1)
						log("The GameCode you received is not Valid! Waiting for Opponent to send a Valid GameCode!")
					end
				elseif (string.lower(message) == string.lower(ESO_MG_CAT3CancelText)) then
					ESO_MG_C3G_PWON:SetText("|cff0000Opponent quits.\n|c00ff00You WIN the Game!")
					ESO_MG_C3G_PT:SetText("You\n|c888866won the Game!")
					ESO_MG.Sound(ESO_MG_SN_Quit1)
					ESO_MG_C3G_SCONT:SetHidden(true)
					ESO_MG.C3EndGame()--END GAME
				end
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(ESO_MG_C3YouReady == 0)then
			if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C3WaitForPlayer)then
				if(string.find(string.lower(message), string.lower(ESO_MG_CAT3ReadyText)) ~= nil)then
					ValidShipPositions = ESO_MG.C3GetEncodedShipPosition(message,messageType)
					if(ValidShipPositions == true)then
						ESO_MG_C3YouReady = 1
						ESO_MG_C3G_PT:SetText("|c888866Waiting for |r" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "|c888866to get Ready!")
						ESO_MG_C3G_SCONT:SetHidden(true)
						ESO_MG_C3G_CONT[2]:SetHidden(false)
					else
						ESO_MG.Sound(ESO_MG_SN_Error1)
						log("The GameCode you have sent is not Valid! Please click the Button 'Ready' again and send the GameCode again.")
					end
				elseif (string.lower(message) == string.lower(ESO_MG_CAT3CancelText)) then
					ESO_MG_C3G_PWON:SetText("|cff0000You quit.\n|cff0000Your Opponent\nwon the Game!")
					ESO_MG_C3G_PT:SetText(ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
					ESO_MG.Sound(ESO_MG_SN_Quit1)
					ESO_MG_C3G_SCONT:SetHidden(true)
					ESO_MG.C3EndGame()--END GAME
				end
			end
		end
	end
	if(ESO_MG_C3OppReady == 1 and ESO_MG_C3YouReady == 1)then
		--Unregister the WaitForReady Event
		EVENT_MANAGER:UnregisterForEvent("C3WaitPlayerReady", EVENT_CHAT_MESSAGE_CHANNEL)
		--Set the correct functions for the Buttons to Prepare Chat
		for j = 1 , 2 , 1 do
			for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
				ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnClicked",function() ESO_MG.C3ClickedItem(i,ESO_MG_C3G_GRIDOBJC[2][i],ESO_MG_C3G_GRIDOBJC[2][i].status) end)			
				ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_GRIDOBJB[2][i],TOPLEFT,0,0) if(ESO_MG_C3G_GRIDOBJC[2][i].status == 0 or ESO_MG_C3G_GRIDOBJC[2][i].status == 5)then ESO_MG_C3G_HL:SetColor(1,1,1,1) else ESO_MG_C3G_HL:SetColor(1,0,0,1) end ESO_MG_C3G_HL:SetHidden(false) end)
			end
		end
		--Register the Wait for Input event
		EVENT_MANAGER:RegisterForEvent("C3WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3WFO)
		--Set the CurrentPlayerText
		if (ESO_MG_C3CurrentPlayer == 0) then
			ESO_MG_C3G_PT:SetText("|c888866All ready! It's |r" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s |c888866turn.")
		elseif (ESO_MG_C3CurrentPlayer == 1) then
			ESO_MG_C3G_PT:SetText("|c888866All ready! It's |r" .. ESO_MG_SELF .. "'s |c888866turn.")
		end
	end
end

--Get Ship Positions out of the Encoded String
function ESO_MG.C3GetEncodedShipPosition(EncodedString,messageType)
	MinusReadyTextPosition = string.len(ESO_MG_CAT3ReadyText) + 2 -- +2 for the space and first real letter
	EncodedShipPositions =  string.sub(EncodedString, MinusReadyTextPosition) -- Get rid of the ReadyText
	if(string.len(EncodedShipPositions) %2 == 0 and string.len(EncodedShipPositions) == ESO_MG_C3AllShipsLen*4 + ESO_MG_C3NumShips*4)then --Check if the String has the desired length and is dividable by 2
		DecodedShipPositions = ESO_MG.Decode(EncodedShipPositions)
		if(DecodedShipPositions ~= false)then --If the Decoded String is Valid decoded
			FoundShips = {}
			FoundShipPositions = {}
			for i = 1 , ESO_MG_C3NumShips , 1 do
				FoundShipPositions[i] = {}
				FoundShips[i] = {string.find(DecodedShipPositions,"X"..i),string.find(DecodedShipPositions,"X"..i) + 1}
				for j = 1 , _G["ESO_MG_C3Ship" .. i .. "Length"] , 1 do
					CurrentLetter = string.sub(DecodedShipPositions,FoundShips[i][1] + j * 2,FoundShips[i][1] + j * 2)
					CurrentNum = string.sub(DecodedShipPositions,FoundShips[i][2] + j * 2,FoundShips[i][2] + j * 2)
					if(tonumber(CurrentNum) ~= nil)then --if the CurrentNum is a Number
						ClearedShipPosition = 0
						for k,l in pairs(ESO_MG_C3G_ROWLETTERS) do -- for each letter in the letters array
							if (CurrentLetter == l) then -- if the currentletter matches the current element of letters array
								ClearedShipPosition = CurrentNum * ESO_MG_C3G_ROWS + k
								table.insert(FoundShipPositions[i], ClearedShipPosition)
								break
							end
						end
						if(ClearedShipPosition == 0)then --if Currentletter is not in the Letterarray
							return false
						end
					else
						return false
					end
				end
			end
			if(table.getn(FoundShips) == ESO_MG_C3NumShips)then --If the Found ships within the String matches the MaxShips
				for i = 1 , ESO_MG_C3NumShips , 1 do
					FirstShipPosition = FoundShipPositions[i][1]
					ShipHorizontal = 1
					ShipVertical =  1
					for j = 2 , table.getn(FoundShipPositions[i]) , 1 do
						if(FoundShipPositions[i][j] == FirstShipPosition + (j-1) * ESO_MG_C3G_ROWS)then --Check if next position is horizontal
							ShipHorizontal = ShipHorizontal + 1
						elseif(FoundShipPositions[i][j] == FirstShipPosition + (j - 1))then --Check if next position is vertical
							ShipVertical = ShipVertical + 1
						else
							return false
						end
					end
					if(ShipVertical ~= table.getn(FoundShipPositions[i]) and ShipHorizontal ~= table.getn(FoundShipPositions[i])) then --If not all are Horizontal or Vertical
						return false
					end
				end
				--If the Sender is the Opponent then Set the Status at Field 2
				if(messageType == 2) then
					for i = 1 , ESO_MG_C3NumShips , 1 do
						for j = 1 , table.getn(FoundShipPositions[i]) , 1 do
							PlaceThisShipPosition = FoundShipPositions[i][j]
							ESO_MG_C3G_GRIDOBJC[2][PlaceThisShipPosition].status = 5
						end
					end
				end
				return true
			else
				return false
			end
		else
			return false
		end
	else
		return false
	end
end

--Check the TellChat for Input
function ESO_MG.C3WFO(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C3WaitForPlayer)) then
			MessageArray = {}
			if(message:len() == 2) then
				for i = 1, message:len(),1 do
					MessageArray[i] = message:sub(i,i)
				end
				if(tonumber(MessageArray[2]) ~= nil and tonumber(MessageArray[2]) <= ESO_MG_C3G_COLS-1 and tonumber(MessageArray[2]) >= 0) then
					if (ESO_MG_C3CurrentPlayer == 0) then
						for i,j in pairs(ESO_MG_C3G_ROWLETTERS) do
							if j == string.upper(MessageArray[1]) then
								ESO_MG_C3ToPlace = i + ESO_MG_C3G_ROWS * (MessageArray[2])
								ESO_MG.C3PlaceGridItem(ESO_MG_C3ToPlace)
								break
							end
						end
					else
						log("Its not " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
					end
				end
			end
			if (string.lower(message) == string.lower(ESO_MG_CAT3CancelText)) then
				ESO_MG_C3G_PWON:SetText("|cff0000Opponent quits.\n|c00ff00You WIN the Game!")
				ESO_MG_C3G_PT:SetText("You\n|c888866won the Game!")
				ESO_MG.Sound(ESO_MG_SN_Quit1)
				ESO_MG.C3EndGame()--END GAME
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C3WaitForPlayer)then
			MessageArray = {}
			if(message:len() == 2) then
				for i = 1, message:len(),1 do
					MessageArray[i] = message:sub(i,i)
				end
				if(tonumber(MessageArray[2]) ~= nil and tonumber(MessageArray[2]) <= ESO_MG_C3G_COLS-1 and tonumber(MessageArray[2]) >= 0) then
					if (ESO_MG_C3CurrentPlayer == 1) then
						for i,j in pairs(ESO_MG_C3G_ROWLETTERS) do
							if j == string.upper(MessageArray[1]) then
								ESO_MG_C3ToPlace = i + ESO_MG_C3G_ROWS * MessageArray[2]
								ESO_MG.C3PlaceGridItem(ESO_MG_C3ToPlace)
								break
							end
						end
					else
						log("Its not your turn.")
						ESO_MG.Sound(ESO_MG_SN_Error4)
					end
				end
			end
			if (string.lower(message) == string.lower(ESO_MG_CAT3CancelText)) then
				ESO_MG_C3G_PWON:SetText("|cff0000You quit.\n|cff0000Your Opponent\nwon the Game!")
				ESO_MG_C3G_PT:SetText(ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
				ESO_MG.Sound(ESO_MG_SN_Quit1)
				ESO_MG.C3EndGame()--END GAME
			end
		end
	end
end

--Places at Grid if there is no shot
function ESO_MG.C3PlaceGridItem(ESO_MG_C3FieldToPlace)
	if(ESO_MG_C3CurrentPlayer == 0)then
		ESO_MG_ContToPlace = 1
	else
		ESO_MG_ContToPlace = 2
	end
	if(ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status == 0) then
		if(ESO_MG_C3CurrentPlayer == 0) then
			ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status = 2
			ESO_MG_C3CurrentPlayer = 1
			ESO_MG_C3G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Blubb2)
		elseif(ESO_MG_C3CurrentPlayer == 1) then
			ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status = 1
			ESO_MG_C3CurrentPlayer = 0
			ESO_MG_C3G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Blubb2)
		end
		ESO_MG.C3SetTextures()
		ESO_MG.C3CheckForWin()
	elseif(ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status == 5) then
		if(ESO_MG_C3CurrentPlayer == 1) then
			ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status = 6
			ESO_MG_C3CurrentPlayer = 0
			ESO_MG_C3G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Sword1)
		end
		ESO_MG.C3SetTextures()
		ESO_MG.C3CheckForWin()
	elseif(ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status == 3) then
		if(ESO_MG_C3CurrentPlayer == 0) then
			ESO_MG_C3G_GRIDOBJC[ESO_MG_ContToPlace][ESO_MG_C3FieldToPlace].status = 4
			ESO_MG_C3CurrentPlayer = 1
			ESO_MG_C3G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
			ESO_MG.Sound(ESO_MG_SN_Sword1)
		end
		ESO_MG.C3SetTextures()
		ESO_MG.C3CheckForWin()
	else
		if(ESO_MG_C3CurrentPlayer == 0)then
			log("Field is already placed. It's still " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
		else
			log("Field is already placed. It's still " .. ESO_MG_SELF .. "'s turn.")
			ESO_MG.Sound(ESO_MG_SN_Error1)
		end
	end
end

--Sets the correct Textures depending on status
function ESO_MG.C3SetTextures()
	for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
		for j = 1 , 2 , 1 do
			shipcontrol = ESO_MG_C3G_GRIDOBJ[j][i]
			hitcontrol = ESO_MG_C3G_GRIDOBJC[j][i]
			if(hitcontrol.status == 0) then --Nothing
				shipcontrol:SetColor(0,0,0,0)
				shipcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
				hitcontrol:SetColor(0,0,0,0)
				hitcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
			elseif(hitcontrol.status == 1) then -- You Hit but nothing
				shipcontrol:SetColor(0,0,0,0)
				shipcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
				hitcontrol:SetColor(0.8,0,0,0.8)
				hitcontrol:SetTexture("/esoui/art/campaign/overview_indexicon_scoring_over.dds")
			elseif(hitcontrol.status == 2) then -- Opponent Hit but nothing
				shipcontrol:SetColor(0,0,0,0)
				shipcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
				hitcontrol:SetColor(0,1,1,0.8)
				hitcontrol:SetTexture("/esoui/art/campaign/overview_indexicon_scoring_over.dds")
			elseif(hitcontrol.status == 3) then -- YourShip
				shipcontrol:SetColor(0.8,0,0,1)
				shipcontrol:SetTexture("/esoui/art/campaign/campaign_tabicon_browser_up.dds")
				hitcontrol:SetColor(0,0,0,0)
				hitcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
			elseif(hitcontrol.status == 4) then -- YourShip Hit
				shipcontrol:SetColor(0.8,0,0,1)
				shipcontrol:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_hardcore_up.dds")
				hitcontrol:SetColor(0,1,1,1)
				hitcontrol:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_normal_up.dds")
			elseif(hitcontrol.status == 5) then -- OpponentShip
				shipcontrol:SetColor(0,0,0,0)
				shipcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
				hitcontrol:SetColor(0,0,0,0)
				hitcontrol:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
			elseif(hitcontrol.status == 6) then -- OpponentShip Hit
				shipcontrol:SetColor(0,1,1,1)
				shipcontrol:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_hardcore_up.dds")
				hitcontrol:SetColor(0.8,0,0,1)
				hitcontrol:SetTexture("/esoui/art/campaign/campaignbrowser_indexicon_normal_up.dds")
			end
		end
	end
end

--CHECK IF A PLAYER HAS KILLED EVERY SHIP
function ESO_MG.C3CheckForWin()
	YouWinCount = 0
	OppWinCount = 0
	for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
		for j = 1 , 2 , 1 do
			if(ESO_MG_C3G_GRIDOBJC[j][i].status == 4)then
				OppWinCount = OppWinCount + 1
			elseif(ESO_MG_C3G_GRIDOBJC[j][i].status == 6)then
				YouWinCount = YouWinCount + 1
			end
		end
	end
	if(OppWinCount == ESO_MG_C3AllShipsLen)then
		ESO_MG.Sound(ESO_MG_SN_Lose1)
		ESO_MG_C3G_PT:SetText(ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
		ESO_MG_C3G_PWON:SetText("|cff0000" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "\nwon the Game!")
		ESO_MG.C3ShowOppShips()
		ESO_MG.C3EndGame()
	elseif(YouWinCount == ESO_MG_C3AllShipsLen)then
		ESO_MG.Sound(ESO_MG_SN_Win2)
		ESO_MG_C3G_PT:SetText("You\n|c888866won the Game!")
		ESO_MG_C3G_PWON:SetText("|c00ff00You won the Game!")
		ESO_MG.C3ShowOppShips()
		ESO_MG.C3EndGame()
	end
end

--Show Opponents Ships after Game Ended
function ESO_MG.C3ShowOppShips()
	for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
		if(ESO_MG_C3G_GRIDOBJC[2][i].status == 5)then
			ESO_MG_C3G_GRIDOBJ[2][i]:SetColor(0,1,1,1)
			ESO_MG_C3G_GRIDOBJ[2][i]:SetTexture("/esoui/art/campaign/campaign_tabicon_browser_up.dds")
		end
	end
end

--Colour the Win Line and Setting Win Text
function ESO_MG.C3DrawWinLine(ESO_MG_C3WinArray)
	for i,line in ipairs(ESO_MG_C3WinArray) do
		ESO_MG_C3G_GRIDOBJ[line]:SetColor(0,1,0,1)
	end
	ESO_MG.C3EndGame()--END GAME
end

--Reset Game
function ESO_MG.C3ResetGame()
	ESO_MG_C3G_PWON:SetAlpha(1)
	for i = 1 , ESO_MG_C3G_COLS * ESO_MG_C3G_ROWS , 1 do
		for j = 1 , 2 , 1 do
			ESO_MG_C3G_GRIDOBJ[j][i]:SetColor(0,0,0,0)
			ESO_MG_C3G_GRIDOBJC[j][i].status = 0
		end
	end
	ESO_MG_C3G_PT:SetText("|c888866Please place your Ships and hit Ready!|r")
	ESO_MG.C3SetTextures()
end

--Reset the Game Window Size depending on Grid and Replacing some stuff
function ESO_MG.C3SetGameWindowSize()
	ESO_MG_C3G_C2L1:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 130,3)
	ESO_MG_C3G_C2L2:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 130,3)
	ESO_MG_C3G_PWON:SetAnchor(CENTER,ESO_MG_C3G_GAMECONT,CENTER,0,(ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM +250) / 2)
	if(ESO_MG_C3GameMaxed == 1)then
		ESO_MG_C3G_MENU:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 120, ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM +250)
	end
	ESO_MG_C3G_GAMECONT:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 130, 0)
	ESO_MG_C3G_MB:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 120,0)
	ESO_MG_C3G_SCONT:SetDimensions(ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM)

	ESO_MG_AREANAME = {ESO_MG_SELF .. "'s |c888866Area (Your Ships)", ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s |c888866Area (" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. "'s Ships)"}
	
	ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_LCONT:SetDimensions(ESO_MG_C3G_GRIDOBJDIM*ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM+20)
	ESO_MG_C3KeyElementsPosi = ((ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS) / ESO_MG_C3KeyElements) / 2
	ESO_MG_C3G_K1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_K1:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi,0)
	ESO_MG_C3G_K2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_K2:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi * 3,0)
	ESO_MG_C3G_K21:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_K21:SetAnchor(TOPLEFT,ESO_MG_C3G_K2,TOPLEFT,0,0)
	ESO_MG_C3G_K3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_K3:SetAnchor(TOP,ESO_MG_C3G_LCONT,TOPLEFT,ESO_MG_C3KeyElementsPosi * 5,0)
	--Place Ships Text
	ESO_MG_C3G_PSTX:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM-5)
	--Line1
	ESO_MG_C3G_PSL1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
	--Ship1 Button
	ESO_MG_C3G_SHIP1:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship1Length,ESO_MG_C3G_GRIDOBJDIM)
	--Ship2 Button
	ESO_MG_C3G_SHIP2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship2Length,ESO_MG_C3G_GRIDOBJDIM)
	--Ship3 Button
	ESO_MG_C3G_SHIP3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship3Length,ESO_MG_C3G_GRIDOBJDIM)
	--Ship4 Button
	ESO_MG_C3G_SHIP4:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship4Length,ESO_MG_C3G_GRIDOBJDIM)
	--Ship5 Button
	ESO_MG_C3G_SHIP5:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3Ship5Length,ESO_MG_C3G_GRIDOBJDIM)
	--Replace Ships Button
	ESO_MG_C3G_SCR:SetDimensions(ESO_MG_C3G_GRIDOBJDIM+20,ESO_MG_C3G_GRIDOBJDIM+20)
	--Line2
	ESO_MG_C3G_PSL2:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
	--Ready / Replace Ships
	ESO_MG_C3G_CRTX:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS,ESO_MG_C3G_GRIDOBJDIM-5)
	--Line3
	ESO_MG_C3G_PSL3:SetDimensions(ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS + 10,3)
	--Position for Buttons
	ESO_MG_C3ButtonPosi = ((ESO_MG_C3G_GRIDOBJDIM * ESO_MG_C3G_COLS) / 2) / 2
	--Replace Ships Button
	ESO_MG_C3G_RSHIP:SetAnchor(TOP,ESO_MG_C3G_PSL3,BOTTOMLEFT,ESO_MG_C3ButtonPosi*3,ESO_MG_C3G_GRIDOBJDIM-30)
	ESO_MG_C3G_RSHIP:SetDimensions(ESO_MG_C3G_GRIDOBJDIM*4,ESO_MG_C3G_GRIDOBJDIM)
	--Ready Button
	ESO_MG_C3G_RDY:SetAnchor(TOP,ESO_MG_C3G_PSL3,BOTTOMLEFT,ESO_MG_C3ButtonPosi,ESO_MG_C3G_GRIDOBJDIM-30)
	ESO_MG_C3G_RDY:SetDimensions(ESO_MG_C3G_GRIDOBJDIM*4,ESO_MG_C3G_GRIDOBJDIM)

	for j = 1 , 2 , 1 do
		ESO_MG_C3G_CONT[j]:SetAnchor(TOPLEFT,ESO_MG_C3G_GAMECONT,TOPLEFT,30 + (j-1) * (ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM + 60),130)
		for i = 0 , ESO_MG_C3G_COLS - 1 , 1 do --Replace the Column Numbers
			ESO_MG_C3G_CN[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,((ESO_MG_C3G_GRIDOBJDIM/2)-5)+((i)*ESO_MG_C3G_GRIDOBJDIM),-30)
		end
		for i = 1 , ESO_MG_C3G_COLS - 1 , 1 do --Replace the Column Lines and set Dimensions
			ESO_MG_C3G_CL[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT, i * ESO_MG_C3G_GRIDOBJDIM,-6)
			ESO_MG_C3G_CL[j][i]:SetDimensions(3,ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM + 10)
		end
		for i = 1 , ESO_MG_C3G_ROWS , 1 do --Replace the Row Letters
			ESO_MG_C3G_RN[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,-25,((ESO_MG_C3G_GRIDOBJDIM/2)-10)+((i-1)*ESO_MG_C3G_GRIDOBJDIM))
		end
		for i = 1 , ESO_MG_C3G_ROWS -1 , 1 do --Replace the Row Lines and set Dimensions
			ESO_MG_C3G_RL[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,-6 - (ESO_MG_C3G_GRIDOBJDIM / 4),i * ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_RL[j][i]:SetDimensions(ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM + 10 + (ESO_MG_C3G_GRIDOBJDIM / 2),3)
		end
		for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
			ESO_MG_C3G_GRIDOBJ[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_GRIDOBJ[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_GRIDOBJC[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_GRIDOBJC[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_GRIDOBJB[j][i]:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
			ESO_MG_C3G_GRIDOBJB[j][i]:SetAnchor(TOPLEFT,ESO_MG_C3G_CONT[j],TOPLEFT,math.floor((i-1)/ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM,((i-1)%ESO_MG_C3G_ROWS)*ESO_MG_C3G_GRIDOBJDIM)
		end
				
		ESO_MG_C3G_AT[j]:SetText(ESO_MG_C3G_COLORS[j] .. ESO_MG_AREANAME[j])
		ESO_MG_C3G_CONT[j]:SetDimensions(ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM)
	end
end

--End the current Game
function ESO_MG.C3EndGame()
	ESO_MG.RotateTexture(8000,ESO_MG_C3G_PWB1,1,-5)
	ESO_MG.RotateTexture(8000,ESO_MG_C3G_PWB2,1,2)
	ESO_MG.RotateTexture(8000,ESO_MG_C3G_PWB3,1,5)
	zo_callLater(function() ESO_MG.Fade(2000,ESO_MG_C3G_PWON,1,0) end,6000)
	EVENT_MANAGER:UnregisterForEvent("C3WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL)
	EVENT_MANAGER:UnregisterForEvent("C3WaitPlayerReady", EVENT_CHAT_MESSAGE_CHANNEL)
	ESO_MG_C3G_PWON:SetHidden(false)
	ESO_MG_C3GameEnded = 1
	ESO_MG_C3Running = 0
	EVENT_MANAGER:RegisterForEvent("C3WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C3PlayAgain)
	ESO_MG_C3G_PA:SetEnabled(true)
	ESO_MG_C3G_PATX:SetText("|c888866Play Again|r")
	ESO_MG_C3G_CG:SetEnabled(false)
	ESO_MG_C3G_CGTX:SetText("|c666666Quit Game|r")
	
	--Reset all GridButton functions
	ESO_MG_C3G_HL:SetDimensions(ESO_MG_C3G_GRIDOBJDIM,ESO_MG_C3G_GRIDOBJDIM)
	ESO_MG_C3G_HL:SetColor(1,0,0,1)
	for j = 1 , 2 , 1 do
		for i = 1 , ESO_MG_C3G_ROWS * ESO_MG_C3G_COLS , 1 do
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Error1) log("Game ended!") end)
			ESO_MG_C3G_GRIDOBJB[j][i]:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) ESO_MG_C3G_HL:SetAnchor(TOPLEFT,ESO_MG_C3G_GRIDOBJB[2][i],TOPLEFT,0,0) ESO_MG_C3G_HL:SetHidden(false) end)
		end
	end
end

--Close the Menu Depending on GameStatus
function ESO_MG.C3CloseMenu()
	if(ESO_MG_C3GameEnded == 1)then
		ESO_MG_C3G_MENU:SetHidden(true)
		ESO_MG_CN_MENU:SetHidden(true)
	else -- Show the Warning 
		ESO_MG_CN_MENU:SetHidden(false)
		ESO_MG_CN_MENU:ClearAnchors()
		ESO_MG_CN_MENU:SetAnchor(CENTER,ESO_MG_C3G_MENU,CENTER,0,0)
		ESO_MG_CN_TXT:SetText("|c888866If you quit the Game, it will only end for you. |c008888" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .." |c888866will not be notified.\nAre you sure you want to quit?")
		ESO_MG_CN_YES:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Quit1) ESO_MG.C3EndGame() ESO_MG_C3G_MENU:SetHidden(true) ESO_MG_CN_MENU:SetHidden(true) end)
	end
end

--Minimize or Maximize the Menu Depending on Status
function ESO_MG.C3ShowHideMenu()
	if(ESO_MG_C3GameMaxed == 1)then
		ESO_MG_CN_MENU:SetHidden(true)
		ESO_MG_C3G_BTNCLOSE:SetHidden(true)
		ESO_MG_C3GameMaxed = 0
		ESO_MG_C3G_GAMECONT:SetHidden(true)
		ESO_MG_C3G_MENU:SetDimensions(175,30)
		ESO_MG_C3G_va, ESO_MG_C3G_pt, ESO_MG_C3G_rt, ESO_MG_C3G_rpt, ESO_MG_C3G_ox, ESO_MG_C3G_oy =  ESO_MG_C3G_MENU:GetAnchor()
		ESO_MG_C3G_MENU:ClearAnchors()
		ESO_MG_C3G_MENU:SetAnchor(BOTTOMRIGHT,GuiRoot,BOTTOMRIGHT,0,-40*ESO_MG_MinimizedGames)
		ESO_MG_C3G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C3G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames + 1
		ESO_MG_C3G_MENU:SetMovable(false)
		ESO_MG_C3G_BTNINFO:SetHidden(true)
		ESO_MG_C3G_BTNSH:ClearAnchors()
		ESO_MG_C3G_BTNSH:SetAnchor(TOPLEFT,BattleShipMenu,TOPLEFT,0,0)
		ESO_MG_C3MinimizedPosition = ESO_MG_MinimizedGames
		ESO_MG.Sound(ESO_MG_SN_Fade1)
	else
		ESO_MG_C3G_BTNCLOSE:SetHidden(false)
		ESO_MG_C3GameMaxed = 1
		ESO_MG_C3G_GAMECONT:SetHidden(false)
		ESO_MG_C3G_MENU:SetDimensions((ESO_MG_C3G_COLS * ESO_MG_C3G_GRIDOBJDIM) * 2 + 120, ESO_MG_C3G_ROWS * ESO_MG_C3G_GRIDOBJDIM +250)
		ESO_MG_C3G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C3G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C3G_MENU:ClearAnchors()
		ESO_MG_C3G_MENU:SetAnchor(ESO_MG_C3G_pt,ESO_MG_C3G_rt,ESO_MG_C3G_rpt,ESO_MG_C3G_ox,ESO_MG_C3G_oy)
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames - 1
		ESO_MG_C3G_MENU:SetMovable(true)
		ESO_MG_C3G_BTNINFO:SetHidden(false)
		ESO_MG_C3G_BTNSH:ClearAnchors()
		ESO_MG_C3G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C3G_BTNCLOSE,TOPLEFT,-5,5)
		ESO_MG.MoveMinimizedDown(ESO_MG_C3MinimizedPosition)
		ESO_MG.Sound(ESO_MG_SN_Fade3)
	end
end

--Fill and Open the InfoWindow
function ESO_MG.C3OpenInfo()
	CurrentGame = ESO_MG_CAT3Name
	HelpText = "|c888866Commands:|r\n- |c888866Tell |c008888" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " |c888866a |cffff00Column |c888866and |cffff00Row |c888866to Play this Field. e.g. '|cffff00/Tell " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " A1|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT3CancelText .. " |c888866to quit the current Game. e.g. '|cffff00/Tell " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT3CancelText .. "|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT3AgainText .. " |c888866after a match has ended to play again. e.g. '|cffff00/Tell " .. ESO_MG_C3WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT3AgainText .. "|c888866'|r\n"
	AnchorWindow = ESO_MG_C3G_MENU
	ESO_MG.OpenInfo(CurrentGame , HelpText , AnchorWindow)
end

--Click function Check if the selected Field is free and if so Enter the Field in Chat
function ESO_MG.C3ClickedItem(item,box,status)
	ESO_MG_C3ColumnClicked = math.ceil(item / ESO_MG_C3G_COLS)
	ESO_MG_C3ColumnClickedZeroed = ESO_MG_C3ColumnClicked - 1
	ESO_MG_C3RowClicked = item - (ESO_MG_C3ColumnClicked -1) * ESO_MG_C3G_COLS
	if(status == 0 or status == 5) then
		CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C3WaitForPlayer .. "" .. ESO_MG_C3AccOrRealName .. ESO_MG_C3G_ROWLETTERS[ESO_MG_C3RowClicked] .. ESO_MG_C3ColumnClickedZeroed)
	else
		log("You already shot at " .. ESO_MG_C3G_ROWLETTERS[ESO_MG_C3RowClicked] .. ESO_MG_C3ColumnClickedZeroed .. ". Please choose another Field.")
	end
	if(ESO_MG_C3G_DEBUGMODE == 1) then --Function to cycle through the status for Debugging
		log("Clicked " .. item)
		if(status < 6) then
			box.status = box.status + 1
		else
			box.status = 0
		end
		ESO_MG.C3SetTextures()
		log("Status set to: " .. status + 1)
	end
end