--      ___                       ___                       ___           ___           ___           ___           ___     
--     /__/\        ___          /__/\        ___          /  /\         /  /\         /__/\         /  /\         /  /\    
--    |  |::\      /  /\         \  \:\      /  /\        /  /:/_       /  /::\       |  |::\       /  /:/_       /  /:/_   
--    |  |:|:\    /  /:/          \  \:\    /  /:/       /  /:/ /\     /  /:/\:\      |  |:|:\     /  /:/ /\     /  /:/ /\  
--  __|__|:|\:\  /__/::\      _____\__\:\  /__/::\      /  /:/_/::\   /  /:/~/::\   __|__|:|\:\   /  /:/ /:/_   /  /:/ /::\ 
-- /__/::::| \:\ \__\/\:\__  /__/::::::::\ \__\/\:\__  /__/:/__\/\:\ /__/:/ /:/\:\ /__/::::| \:\ /__/:/ /:/ /\ /__/:/ /:/\:\
-- \  \:\~~\__\/    \  \:\/\ \  \:\~~\~~\/    \  \:\/\ \  \:\ /~~/:/ \  \:\/:/__\/ \  \:\~~\__\/ \  \:\/:/ /:/ \  \:\/:/~/:/
--  \  \:\           \__\::/  \  \:\  ~~~      \__\::/  \  \:\  /:/   \  \::/       \  \:\        \  \::/ /:/   \  \::/ /:/ 
--   \  \:\          /__/:/    \  \:\          /__/:/    \  \:\/:/     \  \:\        \  \:\        \  \:\/:/     \__\/ /:/  
--    \  \:\         \__\/      \  \:\         \__\/      \  \::/       \  \:\        \  \:\        \  \::/        /__/:/   
--     \__\/                     \__\/                     \__\/         \__\/         \__\/         \__\/         \__\/    
--=============================================================================================================================
--=============================================================================================================================
--TODO:
--Keep playing after crashing by saving the statuses in Savedvariables (low Prio)
--Maybe Adding the Option to set ESO_MG_C1G_CONNECTTOWIN
--Cancel the Animations when starting a new game
--Auto activate the Chat on Click like when clicking a button 2 times
--Zoomfunction
--=============================================================================================================================
--=============================================================================================================================
--All Credit and Copyrights go to (ESO EU) Dero - @Deryl
--I did my best to comment the code for others to learn from it ;)

--Basic Variables
ESO_MG_C1G_MAXWIDTH = 400
ESO_MG_C1G_MAXHEIGHT = 500
ESO_MG_C1G_GRIDOBJDIM = 50
ESO_MG_C1G_CONNECTTOWIN = 4
ESO_MG_C1G_DEBUGMODE = 1

--Creation of the Menu
function ESO_MG.C1_buildmenu()
	if (ConnectFourMenu == nil) then
--------------------------------------------------------------------------------------------------------------------------
-- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART -- MAINPART --
--------------------------------------------------------------------------------------------------------------------------
		--Basemenu
		ESO_MG_C1G_MENU = WINDOW_MANAGER:CreateTopLevelWindow("ConnectFourMenu")
		ESO_MG_C1G_MENU:SetDrawLayer(1)
		ESO_MG_C1G_MENU:SetAnchor(ESO_MG_SavedData.Cat1Anchor[1],ESO_MG_SavedData.Cat1Anchor[2],ESO_MG_SavedData.Cat1Anchor[3],ESO_MG_SavedData.Cat1Anchor[4],ESO_MG_SavedData.Cat1Anchor[5])
		ESO_MG_C1G_MENU:SetDimensions(ESO_MG_C1G_MAXWIDTH,ESO_MG_C1G_MAXHEIGHT)
		ESO_MG_C1G_MENU:SetMouseEnabled(true)
		ESO_MG_C1G_MENU:SetMovable(true)
		ESO_MG_C1G_MENU:SetClampedToScreen(true)
		ESO_MG_C1G_MENU:SetHandler("OnMoveStop",ESO_MG.C1WindowMoved)
		ESO_MG_C1G_MENU_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1G_Back",ConnectFourMenu,"ZO_DefaultBackdrop")
		
		--Headertext
		ESO_MG_C1G_HEADER = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_HEADER",ConnectFourMenu,CT_LABEL)
		ESO_MG_C1G_HEADER:SetText("|c880000" .. ESO_MG_CAT1Name)
		ESO_MG_C1G_HEADER:SetFont("ZoFontTooltipTitle")
		ESO_MG_C1G_HEADER:SetAnchor(TOP,ConnectFourMenu,TOP,0,0)

		--X-Button to Close the Menu
		ESO_MG_C1G_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_BTNCLOSE",ConnectFourMenu,CT_BUTTON)
		ESO_MG_C1G_BTNCLOSE:SetDimensions(20,20)
		ESO_MG_C1G_BTNCLOSE:SetHandler("OnClicked",ESO_MG.C1CloseMenu)
		ESO_MG_C1G_BTNCLOSE:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C1G_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_MG_C1G_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_MG_C1G_BTNCLOSE:SetAnchor(TOPRIGHT,ConnectFourMenu,TOPRIGHT,0,0)
		
		--_-Button to Show / Hide the Menu
		ESO_MG_C1G_BTNSH = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_BTNSH",ConnectFourMenu,CT_BUTTON)
		ESO_MG_C1G_BTNSH:SetDimensions(20,20)
		ESO_MG_C1G_BTNSH:SetHandler("OnClicked",ESO_MG.C1ShowHideMenu)
		ESO_MG_C1G_BTNSH:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C1G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C1G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C1G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C1G_BTNCLOSE,TOPLEFT,-5,5)
		
		--Info button to Open the Help/Info for the current Game
		ESO_MG_C1G_BTNINFO = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_BTNINFO",ConnectFourMenu,CT_BUTTON)
		ESO_MG_C1G_BTNINFO:SetDimensions(25,25)
		ESO_MG_C1G_BTNINFO:SetHandler("OnClicked",ESO_MG.C1OpenInfo)
		ESO_MG_C1G_BTNINFO:SetHandler("OnMouseEnter",function() ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end)
		ESO_MG_C1G_BTNINFO:SetNormalTexture("/esoui/art/help/help_tabicon_tutorial_up.dds")
		ESO_MG_C1G_BTNINFO:SetMouseOverTexture("/esoui/art/help/help_tabicon_tutorial_over.dds")
		ESO_MG_C1G_BTNINFO:SetAnchor(TOPLEFT,ConnectFourMenu,TOPLEFT,0,0)
		
		--Game Container
		ESO_MG_C1G_GAMECONT = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_GAMECONT",ConnectFourMenu,CT_TEXTURE)
		ESO_MG_C1G_GAMECONT:SetDimensions(0,0)
		ESO_MG_C1G_GAMECONT:SetAnchor(TOPLEFT,ConnectFourMenu,TOPLEFT,0,0)
		
		--Player WON text
		ESO_MG_C1G_PWON = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PWON",ESO_MG_C1G_GAMECONT,CT_LABEL)
		ESO_MG_C1G_PWON:SetText("|cff0000PLAYER WON!|r")
		ESO_MG_C1G_PWON:SetFont("ZoFontTooltipTitle")
		ESO_MG_C1G_PWON:SetHorizontalAlignment(1)
		ESO_MG_C1G_PWON:SetDimensions(ESO_MG_C1G_MAXWIDTH,0)
		ESO_MG_C1G_PWON:SetAnchor(CENTER,ESO_MG_C1G_GAMECONT,CENTER,0,0)

		--Player WON burst 1 - 3
		ESO_MG_C1G_PWB1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PWB1",ESO_MG_C1G_PWON,CT_TEXTURE)
		ESO_MG_C1G_PWB1:SetDimensions(512,512)
		ESO_MG_C1G_PWB1:SetAnchor(CENTER,ESO_MG_C1G_PWON,CENTER,0,0)
		ESO_MG_C1G_PWB1:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C1G_PWB1:SetColor(1,1,1,0.5)
		ESO_MG_C1G_PWB2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PWB2",ESO_MG_C1G_PWON,CT_TEXTURE)
		ESO_MG_C1G_PWB2:SetDimensions(512,512)
		ESO_MG_C1G_PWB2:SetAnchor(CENTER,ESO_MG_C1G_PWON,CENTER,0,0)
		ESO_MG_C1G_PWB2:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C1G_PWB2:SetColor(1,1,1,0.5)
		ESO_MG_C1G_PWB3 = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PWB3",ESO_MG_C1G_PWON,CT_TEXTURE)
		ESO_MG_C1G_PWB3:SetDimensions(512,512)
		ESO_MG_C1G_PWB3:SetAnchor(CENTER,ESO_MG_C1G_PWON,CENTER,0,0)
		ESO_MG_C1G_PWB3:SetTexture("/esoui/art/crafting/white_burst.dds")
		ESO_MG_C1G_PWB3:SetColor(1,1,1,0.5)

		--Line1
		ESO_MG_C1G_C1L1 = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_C1L1",ESO_MG_C1G_GAMECONT,CT_TEXTURE)
		ESO_MG_C1G_C1L1:SetDimensions(ESO_MG_C1G_MAXWIDTH+10,3)
		ESO_MG_C1G_C1L1:SetAnchor(TOPLEFT,ESO_MG_C1G_GAMECONT,TOPLEFT,-6,30)
		ESO_MG_C1G_C1L1:SetTexture("/esoui/art/progression/ability_line.dds")

		--Match between text
		ESO_MG_C1G_MB = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_MB",ESO_MG_C1G_GAMECONT,CT_LABEL)
		ESO_MG_C1G_MB:SetText("")
		ESO_MG_C1G_MB:SetFont("ZoFontGame")
		ESO_MG_C1G_MB:SetHorizontalAlignment(1)
		ESO_MG_C1G_MB:SetDimensions(ESO_MG_C1G_MAXWIDTH,0)
		ESO_MG_C1G_MB:SetAnchor(TOP,ESO_MG_C1G_GAMECONT,TOP,0,30)
		
		--Line2
		ESO_MG_C1G_C1L2 = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_C1L2",ESO_MG_C1G_GAMECONT,CT_TEXTURE)
		ESO_MG_C1G_C1L2:SetDimensions(ESO_MG_C1G_MAXWIDTH+10,3)
		ESO_MG_C1G_C1L2:SetAnchor(TOPLEFT,ESO_MG_C1G_GAMECONT,TOPLEFT,-6,75)
		ESO_MG_C1G_C1L2:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--Grid Container
		ESO_MG_C1G_CONT = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_CONT",ESO_MG_C1G_GAMECONT,CT_TEXTURE)
		ESO_MG_C1G_CONT:SetDimensions(0,0)
		ESO_MG_C1G_CONT:SetAnchor(TOPLEFT,ESO_MG_C1G_GAMECONT,TOPLEFT,20,110)
		ESO_MG_C1G_CONT:SetTexture("/esoui/art/crafting/crafting_alchemy_goodslot.dds")
		ESO_MG_C1G_CONT:SetColor(0.5,0.5,0.3,1)
		ESO_MG_C1G_CONT_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_MG_C1G_CONT_BG",ESO_MG_C1G_CONT,"ZO_DefaultBackdrop")

		--Creating the Column Numbers
		ESO_MG_C1G_CN = {}
		for i = 1 , 10 , 1 do
			ESO_MG_C1G_CN[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_CN" .. i,ESO_MG_C1G_CONT,CT_LABEL)
			ESO_MG_C1G_CN[i]:SetText("|c888866" .. i )
			ESO_MG_C1G_CN[i]:SetFont("ZoFontGame")
			ESO_MG_C1G_CN[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,((ESO_MG_C1G_GRIDOBJDIM/2)-5)+((i-1)*ESO_MG_C1G_GRIDOBJDIM),-30)
		end

		--Creating the Lines between Cols
		ESO_MG_C1G_CL = {}
		for i = 1 , 10 -1 , 1 do
			ESO_MG_C1G_CL[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_CL" .. i,ESO_MG_C1G_CONT,CT_TEXTURE)
			ESO_MG_C1G_CL[i]:SetDimensions(3,ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM + 10)
			ESO_MG_C1G_CL[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT, i * ESO_MG_C1G_GRIDOBJDIM,-6)
			ESO_MG_C1G_CL[i]:SetTexture("/esoui/art/miscellaneous/window_edge.dds")
		end
		
		-- Texture to Highlight on MouseOver
		ESO_MG_C1G_HL = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_HL",ESO_MG_C1G_CONT,CT_TEXTURE)
		ESO_MG_C1G_HL:SetDimensions(ESO_MG_C1G_GRIDOBJDIM,ESO_MG_C1G_ROWS*(ESO_MG_C1G_GRIDOBJDIM+12))
		ESO_MG_C1G_HL:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,0,-(ESO_MG_C1G_ROWS*6))
		ESO_MG_C1G_HL:SetTexture("/esoui/art/buttons/minmax_mouseover.dds")
		ESO_MG_C1G_HL:SetHidden(true)

		-- Creating the Grid
		ESO_MG_C1G_GRIDOBJ = {}
		ESO_MG_C1G_GRIDOBJC = {}
		ESO_MG_C1G_GRIDOBJB = {}
		for i = 1 , 100 , 1 do
			--Grid object round Border
			ESO_MG_C1G_GRIDOBJ[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_GRIDOBJ" .. i,ESO_MG_C1G_CONT,CT_TEXTURE)
			ESO_MG_C1G_GRIDOBJ[i]:SetDimensions(ESO_MG_C1G_GRIDOBJDIM-10,ESO_MG_C1G_GRIDOBJDIM-10)
			ESO_MG_C1G_GRIDOBJ[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM+5,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM+5)
			ESO_MG_C1G_GRIDOBJ[i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_disabled.dds")

			--Object to set the Color for
			ESO_MG_C1G_GRIDOBJC[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_GRIDOBJC" .. i,ESO_MG_C1G_CONT,CT_TEXTURE)
			ESO_MG_C1G_GRIDOBJC[i]:SetDimensions(ESO_MG_C1G_GRIDOBJDIM,ESO_MG_C1G_GRIDOBJDIM)
			ESO_MG_C1G_GRIDOBJC[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM)
			ESO_MG_C1G_GRIDOBJC[i]:SetTexture("/esoui/art/charactercreate/triangle_selector_pip_mouseover.dds")
			ESO_MG_C1G_GRIDOBJC[i]:SetColor(0,0,0,1)
			ESO_MG_C1G_GRIDOBJC[i].status = 0 --Status of the GridItem 0 = No Stone, 1 = Opponents Stone, 2 = Your Stone
		
			--Clickable GridObject without texture
			ESO_MG_C1G_GRIDOBJB[i] = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_GRIDOBJB" .. i,ESO_MG_C1G_CONT,CT_BUTTON)
			ESO_MG_C1G_GRIDOBJB[i]:SetDimensions(ESO_MG_C1G_GRIDOBJDIM,ESO_MG_C1G_GRIDOBJDIM)
			ESO_MG_C1G_GRIDOBJB[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM)
			ESO_MG_C1G_GRIDOBJB[i]:SetHandler("OnClicked",function() ESO_MG.ClickedItemC1(i,ESO_MG_C1G_GRIDOBJC[i],ESO_MG_C1G_GRIDOBJC[i].status) end)
			ESO_MG_C1G_GRIDOBJB[i]:SetHandler("OnMouseEnter",function() ESO_MG.C1SetHighlightAnchor(i) ESO_MG_C1G_HL:SetHidden(false) end)
			ESO_MG_C1G_GRIDOBJB[i]:SetHandler("OnMouseExit",function() ESO_MG_C1G_HL:SetHidden(true) end)
		end
		
		--Players turn text
		ESO_MG_C1G_PT = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PT",ESO_MG_C1G_CONT,CT_LABEL)
		ESO_MG_C1G_PT:SetFont("ZoFontGame")
		ESO_MG_C1G_PT:SetHorizontalAlignment(1)
		ESO_MG_C1G_PT:SetVerticalAlignment(1)
		ESO_MG_C1G_PT:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 40,50)
		ESO_MG_C1G_PT:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,BOTTOMLEFT,-20,5)

		--Button Quit Game
		ESO_MG_C1G_CG = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_CG",ESO_MG_C1G_CONT,CT_BUTTON)
		ESO_MG_C1G_CG:SetDimensions(100,25)
		ESO_MG_C1G_CG:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C1WaitForPlayer .. "" .. C1AccOrRealName .. ESO_MG_CAT1CancelText) end)
		ESO_MG_C1G_CG:SetHandler("OnMouseEnter",function() if(ESO_MG_C1G_CG:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C1G_CG:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C1G_CG:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C1G_CG:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C1G_CG:SetAnchor(BOTTOM,ESO_MG_C1G_CONT,BOTTOM,-55,80)
		ESO_MG_C1G_CGTX = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_CGTX",ESO_MG_C1G_CG,CT_LABEL)
		ESO_MG_C1G_CGTX:SetText("|c888866Quit Game|r")
		ESO_MG_C1G_CGTX:SetFont("ZoFontGame")
		ESO_MG_C1G_CGTX:SetAnchor(CENTER,ESO_MG_C1G_CG,CENTER,0,0)
		
		--Button Play Again
		ESO_MG_C1G_PA = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PA",ESO_MG_C1G_CONT,CT_BUTTON)
		ESO_MG_C1G_PA:SetDimensions(100,25)
		ESO_MG_C1G_PA:SetHandler("OnClicked",function() CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C1WaitForPlayer .. "" .. C1AccOrRealName .. ESO_MG_CAT1AgainText) end)
		ESO_MG_C1G_PA:SetHandler("OnMouseEnter",function() if(ESO_MG_C1G_PA:GetState() == 0) then ESO_MG.Sound(ESO_MG_SN_ClickSoft1) end end)
		ESO_MG_C1G_PA:SetNormalTexture("ESOUI/art/buttons/blade_closed_up.dds")
		ESO_MG_C1G_PA:SetMouseOverTexture("ESOUI/art/buttons/blade_mouseover.dds")
		ESO_MG_C1G_PA:SetDisabledTexture("ESOUI/art/buttons/blade_disabled.dds")
		ESO_MG_C1G_PA:SetAnchor(BOTTOM,ESO_MG_C1G_CONT,BOTTOM,55,80)
		ESO_MG_C1G_PATX = WINDOW_MANAGER:CreateControl("ESO_MG_C1G_PATX",ESO_MG_C1G_PA,CT_LABEL)
		ESO_MG_C1G_PATX:SetText("|c888866Play Again|r")
		ESO_MG_C1G_PATX:SetFont("ZoFontGame")
		ESO_MG_C1G_PATX:SetAnchor(CENTER,ESO_MG_C1G_PA,CENTER,0,0)
	end
	ESO_MG_C1G_MENU:SetHidden(true)
	ESO_MG.InitGameC1()
end

--Save Position if Window is moved
function ESO_MG.C1WindowMoved()
	ESO_MG_C1G_va, ESO_MG_C1G_pt, ESO_MG_C1G_rt, ESO_MG_C1G_rpt, ESO_MG_C1G_ox, ESO_MG_C1G_oy =  ESO_MG_C1G_MENU:GetAnchor()
	if(ESO_MG_C1G_va) then
		ESO_MG_SavedData.Cat1Anchor[1] = ESO_MG_C1G_pt
		ESO_MG_SavedData.Cat1Anchor[2] = ESO_MG_C1G_rt
		ESO_MG_SavedData.Cat1Anchor[3] = ESO_MG_C1G_rpt
		ESO_MG_SavedData.Cat1Anchor[4] = ESO_MG_C1G_ox
		ESO_MG_SavedData.Cat1Anchor[5] = ESO_MG_C1G_oy
	end
end

--Sets the Anchor for the Column to Highlight
function ESO_MG.C1SetHighlightAnchor(item)
	ButtonNumToHighLight = (math.ceil(item / ESO_MG_C1G_ROWS)-1) * ESO_MG_C1G_ROWS + 1
	ESO_MG_C1G_HL:SetAnchor(TOPLEFT,ESO_MG_C1G_GRIDOBJB[ButtonNumToHighLight],TOPLEFT,0,-(ESO_MG_C1G_ROWS*6))
	if(ButtonNumToHighLight ~= OldButtonNumToHighLight)then
		ESO_MG.Sound(ESO_MG_SN_ClickSoft1)
	end
	OldButtonNumToHighLight = ButtonNumToHighLight
	for i = 1 , ESO_MG_C1G_ROWS , 1 do
		CheckCurrentItem = ButtonNumToHighLight+i-1
		if(ESO_MG_C1G_GRIDOBJC[CheckCurrentItem].status == 0)then
			ESO_MG_C1G_HL:SetColor(1,1,1,1)
			break
		else
			ESO_MG_C1G_HL:SetColor(1,0,0,1)
		end
	end
end

--Initialize the Game
function ESO_MG.InitGameC1()
	--Play the StartGame Sound
	ESO_MG.Sound(ESO_MG_SN_Battle1)
	
	--Sets the Game Status
	ESO_MG_C1GameEnded = 0
	if(ESO_MG_C1GameMaxed == nil)then
		ESO_MG_C1GameMaxed = 1
	end
	ESO_MG_C1Running = 1
	ESO_MG_C1YouAgain = 0
	ESO_MG_C1OppAgain = 0
	
	--Update the texts with PlayerNames in it
	ESO_MG_C1G_MB:SetText("|c888866Player 1: |c008888" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866Player 2: |caa0000" .. ESO_MG_SELF)
	
	--Hide the Winner Text
	ESO_MG_C1G_PWON:SetHidden(true)

	--Register the wait for Command Event
	EVENT_MANAGER:RegisterForEvent("C1WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1WFO)

	--Resets the PlayGrid
	ESO_MG.C1ResetGame()

	--Sets the Window Dimensions depending on PlayGrid
	ESO_MG.C1SetGameWindowSize()

	--Unregister Events you Dont need anymore
	EVENT_MANAGER:UnregisterForEvent("C1WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL)

	--Disable the Play Again button
	ESO_MG_C1G_PA:SetEnabled(false)
	ESO_MG_C1G_PATX:SetText("|c666666Play Again|r")

	--Enable the Quit Game Button
	ESO_MG_C1G_CG:SetEnabled(true)
	ESO_MG_C1G_CGTX:SetText("|c888866Quit Game|r")
end

--Check the TellChat for ESO_MG_CAT1AgainText after game ended
function ESO_MG.C1PlayAgain(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C1WaitForPlayer)) then
			if(string.lower(message) == string.lower(ESO_MG_CAT1AgainText)) then
				ESO_MG_C1OppAgain = 1
				ESO_MG.Sound(ESO_MG_SN_Reminder3)
				ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866wants to Play again!")
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C1WaitForPlayer)then
			if(string.lower(message) == string.lower(ESO_MG_CAT1AgainText))then
				ESO_MG_C1YouAgain = 1
			end
		end
	end
	if(ESO_MG_C1OppAgain == 1 and ESO_MG_C1YouAgain == 1)then
		ESO_MG.InitGameC1()
	end
end

--Check the TellChat for Input
function ESO_MG.C1WFO(eventCode, messageType, sender, message)
	if (messageType == 2) then -- Message Tell from someone else
		if (string.lower(sender:gsub("%^.+", "")) == string.lower(ESO_MG_C1WaitForPlayer)) then
			if tonumber(message) ~= nil and tonumber(message) <= ESO_MG_C1G_COLS and tonumber(message) >= 1 then
				if (C1CurrentPlayer == 0) then
					ESO_MG.C1PlaceGridItem(message) --Try to place Grid Item
				else
					log("It's not " .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
				end
			end
			if (string.lower(message) == string.lower(ESO_MG_CAT1CancelText)) then
				ESO_MG_C1G_PWON:SetText("|cff0000Opponent quits.\n|c00ff00You WIN the Game!")
				ESO_MG_C1G_PT:SetText("You\n|c888866won the Game!")
				ESO_MG.Sound(ESO_MG_SN_Quit1)
				ESO_MG.C1EndGame()--END GAME
			end
		end
	elseif (messageType == 4) then --Messages from self
		if(string.lower(ZO_ChatWindowTextEntry["system"]["currentTarget"]) == ESO_MG_C1WaitForPlayer)then
			if tonumber(message) ~= nil and tonumber(message) <= ESO_MG_C1G_COLS and tonumber(message) >= 1 then
				if (C1CurrentPlayer == 1) then
					ESO_MG.C1PlaceGridItem(message) --Try to place Grid Item
				else
					log("It's not your turn.")
					ESO_MG.Sound(ESO_MG_SN_Error4)
				end
				if (string.lower(message) == string.lower(ESO_MG_CAT1CancelText)) then
					ESO_MG_C1G_PWON:SetText("|cff0000Opponent quits.\n|c00ff00You WIN the Game!")
					ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
					ESO_MG.Sound(ESO_MG_SN_Quit1)
					ESO_MG.C1EndGame()--END GAME
				end
			end
		end
	end
end

--Places at Grid if there is one Free
function ESO_MG.C1PlaceGridItem(ColumnToPlace)
	C1CorrectStart = ColumnToPlace * ESO_MG_C1G_ROWS
	C1CouldntPlaceCout = 0
	for i = tonumber(C1CorrectStart), tonumber(C1CorrectStart)-ESO_MG_C1G_ROWS+1 , -1 do
		if(ESO_MG_C1G_GRIDOBJC[i].status == 0) then
			if(C1CurrentPlayer == 0) then
				ESO_MG_C1G_GRIDOBJC[i].status = 1
				C1CurrentPlayer = 1
				ESO_MG_C1G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
				ESO_MG.Sound(ESO_MG_SN_Click1)
			elseif(C1CurrentPlayer == 1) then
				ESO_MG_C1G_GRIDOBJC[i].status = 2
				C1CurrentPlayer = 0
				ESO_MG_C1G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
				ESO_MG.Sound(ESO_MG_SN_Click1)
			end
			ESO_MG.C1SetColors()
			ESO_MG.C1CheckForWin()			
			break
		else
			C1CouldntPlaceCout = C1CouldntPlaceCout + 1
			if(C1CouldntPlaceCout == ESO_MG_C1G_ROWS) then
				if(C1CurrentPlayer == 0)then
					log("There is no free Space at Column " .. ColumnToPlace .. ". It's still " .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "'s turn.")
				else
					log("There is no free Space at Column " .. ColumnToPlace .. ". It's still " .. ESO_MG_SELF .. "'s turn.")
					ESO_MG.Sound(ESO_MG_SN_Error4)
				end
			end
		end
	end
end

--Sets the correct Colors depending on status
function ESO_MG.C1SetColors()
	for i = 1 , ESO_MG_C1G_ROWS * ESO_MG_C1G_COLS , 1 do
		if(ESO_MG_C1G_GRIDOBJC[i].status == 1) then
			ESO_MG_C1G_GRIDOBJC[i]:SetColor(0,1,1,1)
		elseif(ESO_MG_C1G_GRIDOBJC[i].status == 2) then
			ESO_MG_C1G_GRIDOBJC[i]:SetColor(1,0,0,1)
		else
			ESO_MG_C1G_GRIDOBJC[i]:SetColor(0,0,0,1)
		end
	end
end

--CHECK IF A PLAYER HAS ESO_MG_C1G_CONNECTTOWIN CONNECTED and Wins
function ESO_MG.C1CheckForWin()
	--Check if All Fields are Full
	ESO_MG.C1AllFieldsFull()
	--Horizontal CHECK
	for i = 1 , ESO_MG_C1G_ROWS , 1 do
		OpponentWinH = 0
		YouWinH = 0
		C1YouWinArray = {}
		C1OppWinArray = {}
		for j = 1 , ESO_MG_C1G_COLS , 1 do
			C1CurrentOne = i + ((j-1) * (ESO_MG_C1G_ROWS))
			if(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 1) then
				YouWinH = 0
				C1YouWinArray = {}
				OpponentWinH = OpponentWinH + 1
				table.insert(C1OppWinArray, C1CurrentOne)
				if(OpponentWinH == ESO_MG_C1G_CONNECTTOWIN)then
					ESO_MG.C1DrawWinLine(C1OppWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Lose1)
					ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
					ESO_MG_C1G_PWON:SetText("|cff0000" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\nwon the Game!")
				end
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 2) then
				OpponentWinH = 0
				C1OppWinArray = {}
				YouWinH = YouWinH + 1
				table.insert(C1YouWinArray, C1CurrentOne)
				if(YouWinH == ESO_MG_C1G_CONNECTTOWIN)then
					ESO_MG.C1DrawWinLine(C1YouWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Win2)
					ESO_MG_C1G_PT:SetText("You\n|c888866won the Game!")
					ESO_MG_C1G_PWON:SetText("|c00ff00You won the Game!")
				end
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 0) then
				OpponentWinH = 0
				YouWinH = 0
			end
		end
	end
	
	--Vertical CHECK
	for i = 1 , ESO_MG_C1G_COLS , 1 do
		OpponentWinV = 0
		YouWinV = 0
		C1YouWinArray = {}
		C1OppWinArray = {}
		for j = 1 , ESO_MG_C1G_ROWS , 1 do
			C1CurrentOne = (i-1) * ESO_MG_C1G_ROWS + j
			if(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 1) then
				YouWinV = 0
				C1YouWinArray = {}
				OpponentWinV = OpponentWinV + 1
				table.insert(C1OppWinArray, C1CurrentOne)
				if(OpponentWinV == ESO_MG_C1G_CONNECTTOWIN)then
					ESO_MG.C1DrawWinLine(C1OppWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Lose1)
					ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
					ESO_MG_C1G_PWON:SetText("|cff0000" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\nwon the Game!")
				end
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 2) then
				OpponentWinV = 0
				C1OppWinArray = {}
				YouWinV = YouWinV + 1
				table.insert(C1YouWinArray, C1CurrentOne)
				if(YouWinV == ESO_MG_C1G_CONNECTTOWIN)then
					ESO_MG.C1DrawWinLine(C1YouWinArray)--DRAW WIN Line
					ESO_MG.Sound(ESO_MG_SN_Win2)
					ESO_MG_C1G_PT:SetText("You\n|c888866won the Game!")
					ESO_MG_C1G_PWON:SetText("|c00ff00You won the Game!")
				end
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 0) then
				OpponentWinV = 0
				YouWinV = 0
			end
		end
	end
	
	--Diagonal CHECK
	MaxColToCheck = ESO_MG_C1G_COLS - ESO_MG_C1G_CONNECTTOWIN + 1
	MaxRowToCheck = ESO_MG_C1G_ROWS - ESO_MG_C1G_CONNECTTOWIN + 1
	WinChecks = MaxColToCheck * MaxRowToCheck
	for i = 1 , WinChecks , 1 do
		--Check TopLeft to BottomRight
		OpponentWinD = 0
		YouWinD = 0
		C1YouWinArray = {}
		C1OppWinArray = {}
		CurrentStartCheck = math.floor((i-1)/MaxRowToCheck) * ESO_MG_C1G_ROWS + ((i-1)%MaxRowToCheck) + 1
		for j = 1 , ESO_MG_C1G_CONNECTTOWIN , 1 do
			C1CurrentOne = CurrentStartCheck + (j-1) * (ESO_MG_C1G_ROWS + 1)
			if(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 0) then
				break
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 1) then
				OpponentWinD = OpponentWinD + 1
				table.insert(C1OppWinArray, C1CurrentOne)
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 2) then
				YouWinD = YouWinD + 1
				table.insert(C1YouWinArray, C1CurrentOne)
			end
			if(OpponentWinD == ESO_MG_C1G_CONNECTTOWIN)then
				ESO_MG.C1DrawWinLine(C1OppWinArray)--DRAW WIN Line
				ESO_MG.Sound(ESO_MG_SN_Lose1)
				ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
				ESO_MG_C1G_PWON:SetText("|cff0000" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\nwon the Game!")
			elseif(YouWinD == ESO_MG_C1G_CONNECTTOWIN)then
				ESO_MG.C1DrawWinLine(C1YouWinArray)--DRAW WIN Line
				ESO_MG.Sound(ESO_MG_SN_Win2)
				ESO_MG_C1G_PT:SetText("You\n|c888866won the Game!")
				ESO_MG_C1G_PWON:SetText("|c00ff00You won the Game!")
			end
		end
		--Check BottomLeft to TopRight
		OpponentWinD = 0
		YouWinD = 0
		C1YouWinArray = {}
		C1OppWinArray = {}
		CurrentStartCheck = math.floor((i-1)/MaxRowToCheck) * ESO_MG_C1G_ROWS + ((i-1)%MaxRowToCheck) + 1 + (ESO_MG_C1G_ROWS - MaxRowToCheck)
		for j = 1 , ESO_MG_C1G_CONNECTTOWIN , 1 do
			C1CurrentOne = CurrentStartCheck + (j-1) * (ESO_MG_C1G_ROWS - 1)
			if(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 0) then
				break
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 1) then
				OpponentWinD = OpponentWinD + 1
				table.insert(C1OppWinArray, C1CurrentOne)
			elseif(ESO_MG_C1G_GRIDOBJC[C1CurrentOne].status == 2) then
				YouWinD = YouWinD + 1
				table.insert(C1YouWinArray, C1CurrentOne)
			end
			if(OpponentWinD == ESO_MG_C1G_CONNECTTOWIN)then
				ESO_MG.C1DrawWinLine(C1OppWinArray)--DRAW WIN Line
				ESO_MG.Sound(ESO_MG_SN_Lose1)
				ESO_MG_C1G_PT:SetText(ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\n|c888866won the Game!")
				ESO_MG_C1G_PWON:SetText("|cff0000" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "\nwon the Game!")
			elseif(YouWinD == ESO_MG_C1G_CONNECTTOWIN)then
				ESO_MG.C1DrawWinLine(C1YouWinArray)--DRAW WIN Line
				ESO_MG.Sound(ESO_MG_SN_Win2)
				ESO_MG_C1G_PT:SetText("You\n|c888866won the Game!")
				ESO_MG_C1G_PWON:SetText("|c00ff00You won the Game!")
			end
		end
	end
end

--Colour the Win Line and Setting Win Text
function ESO_MG.C1DrawWinLine(C1WinArray)
	for i,line in ipairs(C1WinArray) do
		ESO_MG_C1G_GRIDOBJ[line]:SetColor(0,1,0,1)
	end
	ESO_MG.C1EndGame()--END GAME
end

--Reset Game
function ESO_MG.C1ResetGame()
	ESO_MG_C1G_PWON:SetAlpha(1)
	for i = 1 , ESO_MG_C1G_COLS * ESO_MG_C1G_ROWS , 1 do
		ESO_MG_C1G_GRIDOBJ[i]:SetColor(1,1,1,1)
		ESO_MG_C1G_GRIDOBJC[i].status = 0
	end
	if(C1CurrentPlayer == 0) then
		ESO_MG_C1G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. "'s|r |c888866turn.|r")
	else
		ESO_MG_C1G_PT:SetText("|c888866It's|r |cffffff" .. ESO_MG_SELF .. "'s|r |c888866turn.|r")
	end
	ESO_MG.C1SetColors()
end

--Reset the Game Window Size depending on Grid and Replacing some stuff
function ESO_MG.C1SetGameWindowSize()
	if(ESO_MG_C1GameMaxed == 1)then
		ESO_MG_C1G_MENU:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 40, ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM +200)
	end
	ESO_MG_C1G_GAMECONT:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 40, 0)
	ESO_MG_C1G_C1L1:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 50,2)
	ESO_MG_C1G_C1L2:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 50,2)
	ESO_MG_C1G_PT:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 40,50)
	ESO_MG_C1G_PWON:SetAnchor(CENTER,ESO_MG_C1G_GAMECONT,CENTER,0,(ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM +200) / 2)
	ESO_MG_C1G_CONT:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM,ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM+5)
	--Just show the needed GridItems for the current Game
	for i = 1 , 100 , 1 do--Hide all
		ESO_MG_C1G_GRIDOBJ[i]:SetHidden(true)
		ESO_MG_C1G_GRIDOBJC[i]:SetHidden(true)
		ESO_MG_C1G_GRIDOBJB[i]:SetHidden(true)
	end
	for i = 1 , ESO_MG_C1G_ROWS * ESO_MG_C1G_COLS , 1 do--Show Needed and rearrange
		ESO_MG_C1G_GRIDOBJ[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM+5,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM+5)
		ESO_MG_C1G_GRIDOBJ[i]:SetHidden(false)
		ESO_MG_C1G_GRIDOBJC[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM)
		ESO_MG_C1G_GRIDOBJC[i]:SetHidden(false)
		ESO_MG_C1G_GRIDOBJB[i]:SetAnchor(TOPLEFT,ESO_MG_C1G_CONT,TOPLEFT,math.floor((i-1)/ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM,((i-1)%ESO_MG_C1G_ROWS)*ESO_MG_C1G_GRIDOBJDIM)
		ESO_MG_C1G_GRIDOBJB[i]:SetHidden(false)
	end

	--Set Highlighter Dimensions
	ESO_MG_C1G_HL:SetDimensions(ESO_MG_C1G_GRIDOBJDIM,ESO_MG_C1G_ROWS*(ESO_MG_C1G_GRIDOBJDIM+12))

	--Hiding all Lines between Cols
	for i = 1 , 10 -1 , 1 do
		ESO_MG_C1G_CL[i]:SetHidden(true)
	end
	
	--Showing the Line between Cols and Readjusting their Length
	for i = 1 , ESO_MG_C1G_COLS -1 , 1 do
		ESO_MG_C1G_CL[i]:SetHidden(false)
		ESO_MG_C1G_CL[i]:SetDimensions(3,ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM + 10)
	end
	
	--Hiding all Column Numbers
	for i = 1 , 10 , 1 do
		ESO_MG_C1G_CN[i]:SetHidden(true)
	end
	
	--Showing the needed Column Numbers
	for i = 1 , ESO_MG_C1G_COLS , 1 do
		ESO_MG_C1G_CN[i]:SetHidden(false)
	end
end

--Check if all Fields are Full
function ESO_MG.C1AllFieldsFull()
	C1AllFieldsFull = 0
	for i = 1, ESO_MG_C1G_COLS * ESO_MG_C1G_ROWS ,1 do
		if(ESO_MG_C1G_GRIDOBJC[i].status == 0) then
			break
		else
			C1AllFieldsFull = C1AllFieldsFull + 1
		end
	end
	if(C1AllFieldsFull == ESO_MG_C1G_COLS * ESO_MG_C1G_ROWS)then
		ESO_MG_C1G_PWON:SetText("|cffff00DRAW!")
		ESO_MG.Sound(ESO_MG_SN_Draw1)
		ESO_MG.C1EndGame()
	end
end

--End the current Game
function ESO_MG.C1EndGame()
	ESO_MG.RotateTexture(8000,ESO_MG_C1G_PWB1,1,-5)
	ESO_MG.RotateTexture(8000,ESO_MG_C1G_PWB2,1,2)
	ESO_MG.RotateTexture(8000,ESO_MG_C1G_PWB3,1,5)
	zo_callLater(function() ESO_MG.Fade(2000,ESO_MG_C1G_PWON,1,0) end,6000)
	EVENT_MANAGER:UnregisterForEvent("C1WaitOpponentInput", EVENT_CHAT_MESSAGE_CHANNEL)
	ESO_MG_C1G_PWON:SetHidden(false)
	ESO_MG_C1GameEnded = 1
	ESO_MG_C1Running = 0
	EVENT_MANAGER:RegisterForEvent("C1WaitPlayAgain", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1PlayAgain)
	ESO_MG_C1G_PA:SetEnabled(true)
	ESO_MG_C1G_PATX:SetText("|c888866Play Again|r")
	ESO_MG_C1G_CG:SetEnabled(false)
	ESO_MG_C1G_CGTX:SetText("|c666666Quit Game|r")
end

--Close the Menu Depending on GameStatus
function ESO_MG.C1CloseMenu()
	if(ESO_MG_C1GameEnded == 1)then
		ESO_MG_C1G_MENU:SetHidden(true)
		ESO_MG_CN_MENU:SetHidden(true)
	else -- Show the Warning 
		ESO_MG_CN_MENU:SetHidden(false)
		ESO_MG_CN_MENU:ClearAnchors()
		ESO_MG_CN_MENU:SetAnchor(CENTER,ESO_MG_C1G_MENU,CENTER,0,0)
		ESO_MG_CN_TXT:SetText("|c888866If you quit the Game, it will only end for you. |c008888" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .." |c888866will not be notified.\nAre you sure you want to quit?")
		ESO_MG_CN_YES:SetHandler("OnClicked",function() ESO_MG.Sound(ESO_MG_SN_Quit1) ESO_MG.C1EndGame() ESO_MG_C1G_MENU:SetHidden(true) ESO_MG_CN_MENU:SetHidden(true) end)
	end
end

--Minimize or maximize the Menu Depending on Status
function ESO_MG.C1ShowHideMenu()
	if(ESO_MG_C1GameMaxed == 1)then
		ESO_MG_CN_MENU:SetHidden(true)
		ESO_MG_C1G_BTNCLOSE:SetHidden(true)
		ESO_MG_C1GameMaxed = 0
		ESO_MG_C1G_GAMECONT:SetHidden(true)
		ESO_MG_C1G_MENU:SetDimensions(175,30)
		ESO_MG_C1G_va, ESO_MG_C1G_pt, ESO_MG_C1G_rt, ESO_MG_C1G_rpt, ESO_MG_C1G_ox, ESO_MG_C1G_oy =  ESO_MG_C1G_MENU:GetAnchor()
		ESO_MG_C1G_MENU:ClearAnchors()
		ESO_MG_C1G_MENU:SetAnchor(BOTTOMRIGHT,GuiRoot,BOTTOMRIGHT,0,-40*ESO_MG_MinimizedGames)
		ESO_MG_C1G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsplus_up.dds")
		ESO_MG_C1G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsplus_over.dds")
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames + 1
		ESO_MG_C1G_MENU:SetMovable(false)
		ESO_MG_C1G_BTNINFO:SetHidden(true)
		ESO_MG_C1G_BTNSH:ClearAnchors()
		ESO_MG_C1G_BTNSH:SetAnchor(TOPLEFT,ConnectFourMenu,TOPLEFT,0,0)
		ESO_MG_C1MinimizedPosition = ESO_MG_MinimizedGames
		ESO_MG.Sound(ESO_MG_SN_Fade1)
	else
		ESO_MG_C1G_BTNCLOSE:SetHidden(false)
		ESO_MG_C1GameMaxed = 1
		ESO_MG_C1G_GAMECONT:SetHidden(false)
		ESO_MG_C1G_MENU:SetDimensions(ESO_MG_C1G_COLS * ESO_MG_C1G_GRIDOBJDIM + 40, ESO_MG_C1G_ROWS * ESO_MG_C1G_GRIDOBJDIM +200)
		ESO_MG_C1G_BTNSH:SetNormalTexture("ESOUI/art/buttons/pointsminus_up.dds")
		ESO_MG_C1G_BTNSH:SetMouseOverTexture("ESOUI/art/buttons/pointsminus_over.dds")
		ESO_MG_C1G_MENU:ClearAnchors()
		ESO_MG_C1G_MENU:SetAnchor(ESO_MG_C1G_pt,ESO_MG_C1G_rt,ESO_MG_C1G_rpt,ESO_MG_C1G_ox,ESO_MG_C1G_oy)
		ESO_MG_MinimizedGames = ESO_MG_MinimizedGames - 1
		ESO_MG_C1G_MENU:SetMovable(true)
		ESO_MG_C1G_BTNINFO:SetHidden(false)
		ESO_MG_C1G_BTNSH:ClearAnchors()
		ESO_MG_C1G_BTNSH:SetAnchor(TOPRIGHT,ESO_MG_C1G_BTNCLOSE,TOPLEFT,-5,5)
		ESO_MG.MoveMinimizedDown(ESO_MG_C1MinimizedPosition)
		ESO_MG.Sound(ESO_MG_SN_Fade3)
	end
end

--Fill and Open the InfoWindow
function ESO_MG.C1OpenInfo()
	CurrentGame = ESO_MG_CAT1Name
	HelpText = "|c888866Commands:|r\n- |c888866Tell |c008888" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " |c888866a |cffff00Column |c888866to Play this Column. e.g. '|cffff00/Tell " .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " 1|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT1CancelText .. " |c888866to quit the current Game. e.g. '|cffff00/Tell " .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT1CancelText .. "|c888866'|r\n- |c888866Tell |c008888" .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " |cffff00" .. ESO_MG_CAT1AgainText .. " |c888866after a match has ended to play again. e.g. '|cffff00/Tell " .. ESO_MG_C1WaitForPlayer:gsub("%a", string.upper, 1) .. " " .. ESO_MG_CAT1AgainText .. "|c888866'|r\n"
	AnchorWindow = ESO_MG_C1G_MENU
	ESO_MG.OpenInfo(CurrentGame , HelpText , AnchorWindow)
end

--Click function Check if the selected Column is free and if so Enter the Columnnumber in Chat
function ESO_MG.ClickedItemC1(item,box,status)
	C1ColumnClicked = math.ceil(item / ESO_MG_C1G_ROWS)
	StatusCheck = 1
	for i = 1 , ESO_MG_C1G_ROWS , 1 do
		CheckCurrentItem = (C1ColumnClicked-1) * ESO_MG_C1G_ROWS + i
		if(ESO_MG_C1G_GRIDOBJC[CheckCurrentItem].status == 0)then
			statuscheck = 0
			break
		else
			statuscheck = 1
		end
	end
	if(statuscheck == 0)then
		CHAT_SYSTEM:StartTextEntry('/w ' .. ESO_MG_C1WaitForPlayer .. "" .. C1AccOrRealName .. C1ColumnClicked)
	else
		log("There is no free space in this Column. Please choose another one.")
	end
	if(ESO_MG_C1G_DEBUGMODE == 1) then --Function to cycle through the status for Debugging
		log("Clicked Column " .. C1ColumnClicked)
		if(status <= 1) then
			box.status = box.status + 1
		else
			box.status = 0
		end
		ESO_MG.C1SetColors()
		log("Status of " .. item .. " set to: " .. status + 1)
	end
end